#include <vcl.h>
#pragma hdrstop

#include "ThreadFormUnit.h"
#pragma package(smart_init)
#pragma resource "*.dfm"

TThreadForm *ThreadForm;
HANDLE Thread;

DWORD WINAPI ThreadFunc(LPVOID Param)
{
   HANDLE MainWnd(Param);

   RECT R;
   GetClientRect(MainWnd, &R);

   const MaxWidth = R.right - R.left;
   const MaxHeight = R.bottom - R.top;
   int X1, Y1, X2, Y2, R1, G1, B1;
   bool IsEllipse;

   while(true)
   {
      HDC DC = GetDC(MainWnd);

      X1 = rand() % MaxWidth;
      Y1 = rand() % MaxHeight;
      X2 = rand() % MaxWidth;
      Y2 = rand() % MaxHeight;

      R1 = rand() & 255;
      G1 = rand() & 255;
      B1 = rand() & 255;

      IsEllipse = rand() & 1;

      HBRUSH Brush = CreateSolidBrush(
         RGB(R1, G1, B1));
      SelectObject(DC, Brush);

      if(IsEllipse)
         Ellipse(DC, X1, Y1, X2, Y2);
      else
         Rectangle(DC, X1, Y1, X2, Y2);

      ReleaseDC(MainWnd, DC);
      DeleteObject(Brush);
   }
}

__fastcall TThreadForm::TThreadForm(TComponent* Owner)
   : TForm(Owner)
{
   randomize();

   DWORD Id;
   Thread = CreateThread(0, 0, ThreadFunc,
      ThreadForm->Handle, CREATE_SUSPENDED, &Id);

   if(!Thread)
   {
      ShowMessage("Error! Cannot create thread.");
      Application->Terminate();
   }
}

void __fastcall TThreadForm::StartClick(TObject *)
{
   ResumeThread(Thread);
   Start->Enabled = false;
   Stop->Enabled = true;
}

void __fastcall TThreadForm::StopClick(TObject *)
{
   SuspendThread(Thread);
   Stop->Enabled = false;
   Start->Enabled = true;
}
