//---------------------------------------------------------------------------
// DBMaskEdit.h
// By: Malcolm Smith, April 2000
// Email: mjfreelancing@optusnet.com.au
// Web  : www.mjfreelancing.com
// Last modified 3rd May 2000
//---------------------------------------------------------------------------
#ifndef DBMaskEditH
#define DBMaskEditH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include <Mask.hpp>
#include <StdCtrls.hpp>
#include <DBCtrls.hpp>      // for TFieldDataLink
//---------------------------------------------------------------------------
class PACKAGE TDBMaskEdit : public TMaskEdit
{
private:
  TFieldDataLink  *FDataLink;
  AnsiString __fastcall GetDataField(void);
  TDataSource* __fastcall GetDataSource(void);
  void __fastcall SetDataField(AnsiString pDataField);
  void __fastcall SetDataSource(TDataSource *pDataSource);
  void __fastcall DataChange(TObject *Sender);
  void __fastcall UpdateData(TObject *Sender);
  TField * __fastcall GetField(void);

  // ?? need the SetFocused method like TDBEdit

  void __fastcall CMExit(TWMNoParams Message);
  void __fastcall CMGetDataLink(TMessage Message);

protected:
  DYNAMIC void __fastcall MouseDown(TMouseButton Button, TShiftState Shift, int X, int Y);
  DYNAMIC void __fastcall KeyDown(unsigned short &Key, TShiftState Shift);
  DYNAMIC void __fastcall Change(void);
public:
  __fastcall TDBMaskEdit(TComponent* Owner);
  __fastcall ~TDBMaskEdit(void);
  __property TField *Field = {read = GetField};
__published:
  __property AnsiString DataField = {read = GetDataField, write = SetDataField, nodefault};
  __property TDataSource *DataSource = {read = GetDataSource, write = SetDataSource, nodefault};

  BEGIN_MESSAGE_MAP
    //    MESSAGE_HANDLER(WM_CUT, TMessage, WMCut)
    //    MESSAGE_HANDLER(WM_PASTE, TMessage, WMPaste)
    //    MESSAGE_HANDLER(WM_PAINT, TWMPaint, WMPaint)
    //    MESSAGE_HANDLER(CM_ENTER, TCMEnter, CMEnter)
    MESSAGE_HANDLER(CM_EXIT, TWMNoParams, CMExit)
    MESSAGE_HANDLER(CM_GETDATALINK, TMessage, CMGetDataLink)
  END_MESSAGE_MAP(TMaskEdit)

};
//---------------------------------------------------------------------------
#endif
