// TExampleButton
// By: Sean Rock
//---------------------------------------------------------------------------
#ifndef ExampleButtonH
#define ExampleButtonH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
//---------------------------------------------------------------------------

enum TExButtonState {esUp, esDown, esFlat, esDisabled};

class PACKAGE TExampleButton : public TGraphicControl
{
private:

  Graphics::TBitmap *FGlyph;
  AnsiString FCaption;
  TImageList *FImage;
  TExButtonState FState;
  bool FMouseInControl;
  TNotifyEvent FOnClick;
  void __fastcall SetGlyph(Graphics::TBitmap *Value);
  void __fastcall SetCaption(AnsiString Value);
  void __fastcall BeforeDestruction(void);
  void __fastcall SwapColors(TColor &Top, TColor &Bottom);
  void __fastcall CalcGlyphLayout(TRect &r);
  void __fastcall CalcTextLayout(TRect &r);
  MESSAGE void __fastcall CMMouseEnter(TMessage &Msg);
  MESSAGE void __fastcall CMMouseLeave(TMessage &Msg);
  MESSAGE void __fastcall CMEnabledChanged(TMessage &Msg);
protected:
  
  void __fastcall Paint(void);
  DYNAMIC void __fastcall MouseDown(TMouseButton Button, TShiftState Shift,
    int X, int Y);
  DYNAMIC void __fastcall MouseUp(TMouseButton Button, TShiftState Shift,
    int X, int Y);
public:
  __fastcall TExampleButton(TComponent* Owner);
__published:

  __property AnsiString Caption = {read=FCaption, write=SetCaption};
  __property Graphics::TBitmap * Glyph = {read=FGlyph, write=SetGlyph};
  __property TNotifyEvent OnClick = {read=FOnClick, write=FOnClick};


BEGIN_MESSAGE_MAP
  MESSAGE_HANDLER(CM_MOUSEENTER, TMessage, CMMouseEnter)
  MESSAGE_HANDLER(CM_MOUSELEAVE, TMessage, CMMouseLeave)
  MESSAGE_HANDLER(CM_ENABLEDCHANGED, TMessage, CMEnabledChanged)
END_MESSAGE_MAP(TGraphicControl)
};
//---------------------------------------------------------------------------
#endif
 
