//---------------------------------------------------------------------------
#ifndef SHFileListBoxH
#define SHFileListBoxH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include <FileCtrl.hpp>
#include <StdCtrls.hpp>
#include "ShlObj.h"


//---------------------------------------------------------------------------

class TShellFileListItem : public TObject
{
private:
  LPITEMIDLIST Fpidl;
  int FImageIndex;
public:
  __fastcall TShellFileListItem(LPITEMIDLIST lpidl, int Index);
  __fastcall ~TShellFileListItem(void);
  __property LPITEMIDLIST pidl = {read=Fpidl};
  __property int ImageIndex = {read=FImageIndex};
};

typedef void __fastcall (__closure *TAddItemEvent)(TObject *Sender, AnsiString
  Item, bool &CanAdd);

class PACKAGE TSHFileListBox : public TFileListBox
{
private:
  TImageList *FImages;
  TNotifyEvent FOnDblClick;
  bool FCanLaunch;
  bool FRightBtnSel;
  TAddItemEvent FOnAddItem;
  void __fastcall GetSysImages(void);
protected:
  DYNAMIC void __fastcall DblClick(void);
  void __fastcall ReadFileNames(void);
  DYNAMIC void __fastcall MouseUp(TMouseButton Button, TShiftState Shift, int X, int Y);
  void __fastcall DrawItem(int Index, const TRect &Rect, TOwnerDrawState State);
  void __fastcall DoHorizontalScrollBar(int he);
  DYNAMIC void __fastcall DeleteString(int Index);

public:
  __fastcall TSHFileListBox(TComponent* Owner);
  __fastcall ~TSHFileListBox(void);
  int __fastcall AddItem(LPITEMIDLIST pidl);
__published:
  __property bool CanLaunch = {read=FCanLaunch, write=FCanLaunch, default=true};
  __property bool RightBtnSel = {read=FRightBtnSel, write=FRightBtnSel,
    default=true};
  __property TNotifyEvent OnDblClick = {read=FOnDblClick, write=FOnDblClick};
  __property TAddItemEvent OnAddItem = {read=FOnAddItem, write=FOnAddItem};
};

extern "C" LPITEMIDLIST CopyPIDL(LPITEMIDLIST lpidl);
extern "C" unsigned short GetPIDLSize(LPITEMIDLIST lpidl);
extern "C" LPITEMIDLIST CreatePIDL(unsigned short size);
extern "C" LPITEMIDLIST GetNextItem(LPITEMIDLIST pidl);

//---------------------------------------------------------------------------
#endif
