//------------------------------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop

#include "ComponentEditors.h"

#include "clipbrd.hpp"
//------------------------------------------------------------------------------------------//
//#pragma package(smart_init,weak)

// You may wish to recompile the package with this unit weakly packaged to see the diiference
// in the *.bpi file generated. If the unit is weakly packaged the *.bpi file is substantially
// bigger as it contains the .obj of the unit. Aside from this the package will function as
// before except the name of the unit will not be an issue.

#pragma package(smart_init)
//------------------------------------------------------------------------------------------//

//------------------------------------------------------------------------------------------//
//                                      CONSTRUCTOR
//------------------------------------------------------------------------------------------//
__fastcall TImageComponentEditor::TImageComponentEditor(Classes::TComponent* AComponent,
                                                        _di_IDesigner ADesigner)
           : TDefaultEditor(AComponent, ADesigner)
{
   ActiveWritersGuildLogo = new Graphics::TBitmap();
   InActiveWritersGuildLogo = new Graphics::TBitmap();

   ActiveWritersGuildLogo->LoadFromResourceName(reinterpret_cast<int>(HInstance),
                                                "RESOURCE_ActiveWritersGuildLogo");

   InActiveWritersGuildLogo->LoadFromResourceName(reinterpret_cast<int>(HInstance),
                                                  "RESOURCE_InActiveWritersGuildLogo");
}
//------------------------------------------------------------------------------------------//
//                                       DESTRUCTOR
//------------------------------------------------------------------------------------------//
__fastcall TImageComponentEditor::~TImageComponentEditor(void)
{
   delete ActiveWritersGuildLogo;
   delete InActiveWritersGuildLogo;
}
//------------------------------------------------------------------------------------------//
int __fastcall TImageComponentEditor::GetVerbCount(void)
{
   return 4;
}
//------------------------------------------------------------------------------------------//
AnsiString __fastcall TImageComponentEditor::GetVerb(int Index)
{
   switch(Index)
   {
      case 0 : return "&Copy Image";
      case 1 : return "&Paste Image";
      case 2 : return "-";
      case 3 : return "";
      default : return "";
   }
}
//------------------------------------------------------------------------------------------//
void __fastcall TImageComponentEditor::PrepareItem(int Index, const Menus::TMenuItem* AItem)
{
   switch(Index)
   {
      case 0 : // COPY
      {
          TMenuItem* MenuItem = const_cast<TMenuItem*>(AItem);

          MenuItem->Bitmap->LoadFromResourceName(reinterpret_cast<int>(HInstance),
                                                 "RESOURCE_GreyedCopyImage");

          TImage* Image = dynamic_cast<TImage*>(Component);

          if(Image)
          {
             if(Image->Picture->Graphic == 0) MenuItem->Enabled = false;
             else
             {
                MenuItem->Enabled = true;
                MenuItem->Bitmap->LoadFromResourceName(reinterpret_cast<int>(HInstance),
                                                       "RESOURCE_CopyImage");
             }
          }
          else MenuItem->Enabled = false;
      }
               break;

      case 1 : // PASTE
      {
          TMenuItem* MenuItem = const_cast<TMenuItem*>(AItem);

          MenuItem->Bitmap->LoadFromResourceName(reinterpret_cast<int>(HInstance),
                                                 "RESOURCE_GreyedPasteImage");
          MenuItem->Enabled = false;

          TClipboard* TheClipboard = Clipboard();

          for(int i=0; i<TheClipboard->FormatCount; ++i)
          {
             if(TPicture::SupportsClipboardFormat(__classid(TPicture),
                                                  TheClipboard->Formats[i]))
             {
                MenuItem->Enabled = true;
                MenuItem->Bitmap->LoadFromResourceName(reinterpret_cast<int>(HInstance),
                                                       "RESOURCE_PasteImage");
                break;
             }
             else MenuItem->Enabled = false;
          }
      }
               break;

      case 2 : break; // Separator Line

      case 3 :
      {
          TMenuItem* MenuItem = const_cast<TMenuItem*>(AItem);

          MenuItem->OnMeasureItem = MeasureMenuItem3;
          MenuItem->OnAdvancedDrawItem = AdvancedDrawMenuItem3;

          MenuItem->Enabled = false;
      }
               break;

      default : break;
   }
}
//------------------------------------------------------------------------------------------//
void __fastcall TImageComponentEditor::ExecuteVerb(int Index)
{
   switch(Index)
   {
      case 0 : Copy();
               break;
      case 1 : Paste();
               break;
      case 2 : break;
      case 3 : break;
      default : break;
   }
}
//------------------------------------------------------------------------------------------//
void __fastcall TImageComponentEditor::Copy(void)
{
   TImage* Image = dynamic_cast<TImage*>(Component);

   if(Image)
   {
      Clipboard()->Assign(Image->Picture);

//      // Show also other method using Assign like Paste
//      WORD     AFormat;
//     unsigned AData;
//      HPALETTE APalette;
//
//      Image->Picture->SaveToClipboardFormat(AFormat, AData, APalette);
//
//      // Obtain a pointer to the global instance of the clipboard
//      TClipboard* TheClipboard = Clipboard();
//
//      // Copy to the clipboard
//      TheClipboard->SetAsHandle(AFormat, AData);   
   }
}
//------------------------------------------------------------------------------------------//
void __fastcall TImageComponentEditor::Paste(void)
{
   TImage* Image = dynamic_cast<TImage*>(Component);

   if(Image)
   {
      Image->Picture->Assign(Clipboard());

//      TClipboard* TheClipboard = Clipboard();

//      for(int i=0; i<TheClipboard->FormatCount; ++i)
//      {
//         if(TPicture::SupportsClipboardFormat(__classid(TPicture),
//                                              TheClipboard->Formats[i]))
//         {
//            HPALETTE APalette;
//            Image->Picture->LoadFromClipboardFormat
//                            (TheClipboard->Formats[i],
//                             TheClipboard->GetAsHandle(TheClipboard->Formats[i]),
//                             APalette);
//            break;
//         }
//      }

   }
}
//------------------------------------------------------------------------------------------//
void __fastcall TImageComponentEditor::MeasureMenuItem3(System::TObject* Sender,
                                                        Graphics::TCanvas* ACanvas,
                                                        int& Width,
                                                        int& Height)
{
   Width = 222 - Height;
   Height = 60;
}

//------------------------------------------------------------------------------------------//
void __fastcall TImageComponentEditor::AdvancedDrawMenuItem3(System::TObject* Sender,
                                                             Graphics::TCanvas* ACanvas,
                                                             const TRect& ARect,
                                                             TOwnerDrawState State)
{
   if(State.Contains(odSelected))
   {
      ACanvas->Draw(ARect.Left, ARect.Top, ActiveWritersGuildLogo);
   }
   else
   {
      ACanvas->Draw(ARect.Left, ARect.Top, InActiveWritersGuildLogo);
   }
}
//------------------------------------------------------------------------------------------//



