//------------------------------------------------------------------------------------------//
#ifndef ComponentEditorsH
#define ComponentEditorsH
//------------------------------------------------------------------------------------------//
#include "DesignIntf.hpp"
#include "VCLEditors.hpp"
//------------------------------------------------------------------------------------------//
class TImageComponentEditor : public TDefaultEditor
{
   typedef TComponentEditor inherited;

private:
   virtual void __fastcall AdvancedDrawMenuItem3(System::TObject* Sender,
                                                 Graphics::TCanvas* ACanvas,
                                                 const TRect& ARect,
                                                 TOwnerDrawState State);


   virtual void __fastcall MeasureMenuItem3(System::TObject* Sender,
                                            Graphics::TCanvas* ACanvas,
                                            int& Width,
                                            int& Height);

   // Private Data
   Graphics::TBitmap* ActiveWritersGuildLogo;
   Graphics::TBitmap* InActiveWritersGuildLogo;

public:
   // Right-Click
   // CONTEXT MENU - Step 1
   virtual int __fastcall GetVerbCount(void);
   //              - Step 2
   virtual AnsiString __fastcall GetVerb(int Index);
   //              - Step 3
   virtual void __fastcall PrepareItem(int Index, const Menus::TMenuItem* AItem);
   //              - Step 4
   virtual void __fastcall ExecuteVerb(int Index);

   // Copy image to Clipboard
   virtual void __fastcall Copy(void);

   // Paste image from Clipboard
   virtual void __fastcall Paste(void);

public:
   __fastcall virtual TImageComponentEditor(Classes::TComponent* AComponent,
                                                   _di_IDesigner ADesigner);

public:
   __fastcall virtual ~TImageComponentEditor(void);
};

//------------------------------------------------------------------------------------------/
/*
//------------------------------------------------------------------------------------------//
class TImageComponentEditor : public TDefaultEditor
{
   typedef TComponentEditor inherited;

private:
   virtual void __fastcall AdvancedDrawMenuItem3(System::TObject* Sender,
                                                 Graphics::TCanvas* ACanvas,
                                                 const Windows::TRect& ARect,
                                                 TOwnerDrawState State);


   virtual void __fastcall MeasureMenuItem3(System::TObject* Sender,
                                            Graphics::TCanvas* ACanvas,
                                            int& Width,
                                            int& Height);


public:
   // Right-Click
   // CONTEXT MENU - Step 1
   virtual int __fastcall GetVerbCount(void);
   //              - Step 2
   virtual AnsiString __fastcall GetVerb(int Index);
   //              - Step 3
   virtual void __fastcall PrepareItem(int Index, const Menus::TMenuItem* AItem);
   //              - Step 4
   virtual void __fastcall ExecuteVerb(int Index);

   // Copy image to Clipboard
   virtual void __fastcall Copy(void);

   // Paste image from Clipboard
   virtual void __fastcall Paste(void);

public:
   #pragma option push -w-inl
   inline __fastcall virtual TImageComponentEditor(Classes::TComponent* AComponent,
                                                   _di_IFormDesigner ADesigner)
                                                   : TDefaultEditor(AComponent, ADesigner)
   { }
   #pragma option pop


public:
   #pragma option push -w-inl
   inline __fastcall virtual ~TImageComponentEditor(void) { }
   #pragma option pop
};
*/
//------------------------------------------------------------------------------------------//

//------------------------------------------------------------------------------------------//
#endif
