//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "ComponentEditors.h"
#include "PropertyEditors.h"
//#include "GetTypeInfo.h"  // For illustration only
#include "NonVCLTypeInfo.h"
#include <Mask.hpp>

#include "Comctrls.hpp"

//------------------------------------------------------------------------------------------//
#pragma package(smart_init)
//------------------------------------------------------------------------------------------//

namespace Registrationforenhancededitors
{
   void __fastcall PACKAGE Register()
   {
      // Using the following Registration registers the 'TDisplayFontNameProperty' for
      // properties of type AnsiString, of name 'Name' for the TFont class.

      // 1 - Get the TypeInfo for TFont::Name
      TPropInfo* FontNamePropInfo = Typinfo::GetPropInfo(__typeinfo(TFont),
                                                         "Name");

      // 2 - Register the property editor
      RegisterPropertyEditor(*FontNamePropInfo->PropType,
                             __classid(TFont),
                             "",
                             __classid(TDisplayFontNameProperty));


      // Using the following Registration registers the 'TImageListPropertyEditor' for ALL
      // properties of type 'TCustomImageList' for ALL components.
      RegisterPropertyEditor(__typeinfo(TCustomImageList),
                             0,
                             "",
                             __classid(TImageListPropertyEditor));


      // Using the following Registration registers the 'TDisplayCursorProperty' for ALL
      // properties of type 'TCursor' for ALL components.
      // Since property editors are used from newest to oldest this property editor
      // will be used in preference to previously installed editors, hence this will
      // be used for the already existing TShape classes 'Shape' property

      // 1 - Get the TypeInfo of TCursor
//      TPropInfo* CursorPropInfo = Typinfo::GetPropInfo(__typeinfo(TForm),
//                                                       "Cursor");

      // 2 - Register the property editor
      RegisterPropertyEditor(*(Typinfo::GetPropInfo(__typeinfo(TForm),
                                                       "Cursor"))->PropType,
                             0,
                             "",
                             __classid(TDisplayCursorProperty));


      // TImageIndex property editor Registrations

      // 1 - Get the TypeInfo for TImageIndex
      TPropInfo* ImageIndexPropInfo = Typinfo::GetPropInfo(__typeinfo(TMenuItem),
                                                           "ImageIndex");

      // 2 - Register the property editors

      // TMenuItemImageIndexProperty for properties of type TImageIndex of ANY name
      //                             for TMenuItem

      RegisterPropertyEditor(*ImageIndexPropInfo->PropType,
                             __classid(TMenuItem),
                             "",
                             __classid(TMenuItemImageIndexProperty));

      // TToolButtonImageIndexProperty for properties of type TImageIndex called
      //                               'ImageIndex' for TToolButton

      RegisterPropertyEditor(*ImageIndexPropInfo->PropType,
                             __classid(TToolButton),
                             "ImageIndex",
                             __classid(TToolButtonImageIndexProperty));


      // TToolButtonImageIndexProperty for properties of type TImageIndex called
      //                               'ImageIndex' for TListColumn

      RegisterPropertyEditor(*ImageIndexPropInfo->PropType,
                             __classid(TListColumn),
                             "ImageIndex",
                             __classid(TListColumnImageIndexProperty));

      // TPersistentDerivedImageIndexProperty for properties of type TImageIndex of
      //                                      ANY name for TPersistent derived classes

      RegisterPropertyEditor(*ImageIndexPropInfo->PropType,
                             __classid(TPersistent),
                             "",
                             __classid(TPersistentDerivedImageIndexProperty));

      // TComponentDerivedImageIndexProperty for properties of type TImageIndex of
      //                                       ANY name for TComponent derived classes

      RegisterPropertyEditor(*ImageIndexPropInfo->PropType,
                             __classid(TComponent),
                             "",
                             __classid(TComponentDerivedImageIndexProperty));


      // Using the following Registration registers the 'TShapePropertyEditor' for ALL
      // properties of type 'TShapeType' for ALL components.

      // 1 - Get the TypeInfo for TImageIndex
      TPropInfo* ShapeTypePropInfo = Typinfo::GetPropInfo(__typeinfo(TShape),
                                                           "Shape");

      // Register it :-)
      RegisterPropertyEditor(*ShapeTypePropInfo->PropType,
                             0,
                             "",
                            __classid(TShapeTypePropertyEditor));



//      static TTypeInfo UnsignedTypeInfo;
//      UnsignedTypeInfo.Kind = tkInteger;
//      UnsignedTypeInfo.Name = "unsigned int";

//      RegisterPropertyEditor(UnsignedTypeInfo(),
//                             0,
//                             "",
//                            __classid(TUnsignedProperty));


      TPropInfo* VCLCharPropInfo = Typinfo::GetPropInfo(__typeinfo(TMaskEdit),
                                                           "PasswordChar");


//      RegisterPropertyEditor(*UnsignedPropInfo->PropType,
//                             0,
//                             "",
//                            __classid(TUnsignedProperty));

      RegisterPropertyEditor(*(Typinfo::GetPropInfo(__typeinfo(TNonVCLTypesClass),
                               "UnsignedIntProperty"))->PropType,
                             0,
                             "",
                             __classid(TUnsignedProperty));

      RegisterPropertyEditor(TNonVCLTypeInfo::Char(),
                             0,
                             "",
                             __classid(TCharPropertyEditor));

      RegisterPropertyEditor(*VCLCharPropInfo->PropType,
                             0,
                             "",
                             __classid(TCharPropertyEditor));

      RegisterPropertyEditor(TNonVCLTypeInfo::SignedChar(),
                             0,
                             "",
                             __classid(TSignedCharProperty));

      RegisterPropertyEditor(TNonVCLTypeInfo::UnsignedChar(),
                             0,
                             "",
                            __classid(TUnsignedCharProperty));


      // The following Registration registers the 'TImageComponentEditor' for ALL
      // components that are of type 'TImage' or are descendents of 'TImage'. Again this
      // overrides any existing component editor previously installed for 'TImage' and its
      // descendents

      RegisterComponentEditor(__classid(TImage),
                              __classid(TImageComponentEditor));

   }

}
//------------------------------------------------------------------------------------------//
