//------------------------------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
//------------------------------------------------------------------------------------------//

#include "EnhancedImage.h"
#include <memory> // for auto_ptr<>

//------------------------------------------------------------------------------------------//
#pragma package(smart_init)
//------------------------------------------------------------------------------------------//
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//------------------------------------------------------------------------------------------//

static inline void ValidCtrCheck(TEnhancedImage *)
{
        new TEnhancedImage(NULL);
}

//------------------------------------------------------------------------------------------//
//                                                                                          //
//         TEnhancedImage:: Constructor                                                     //
//                                                                                          //
//------------------------------------------------------------------------------------------//

__fastcall TEnhancedImage::TEnhancedImage(TComponent* Owner)
        : TImage(Owner),
          FUseImageList(false),
          FImageIndex(-1),
          FImageList(0)
{
}

//------------------------------------------------------------------------------------------//
//                                                                                          //
//         TEnhancedImage:: Member Functions                                                //
//                                                                                          //
//------------------------------------------------------------------------------------------//

void __fastcall TEnhancedImage::Notification(TComponent* AComponent, TOperation Operation)
{
   inherited::Notification(AComponent, Operation);

   if(Operation == opRemove)
   {
      if(AComponent == ImageList) ImageList = 0;

      // Can make more checks for other properties if needed
   }
}

//------------------------------------------------------------------------------------------//

void __fastcall TEnhancedImage::SetUseImageList(bool NewUseImageList)
{
   if(NewUseImageList != UseImageList)
   {
      FUseImageList = NewUseImageList;

      UpdatePicture();
   }
}

//------------------------------------------------------------------------------------------//

void __fastcall TEnhancedImage::SetImageIndex(Imglist::TImageIndex NewImageIndex)
{
   if(NewImageIndex != FImageIndex)
   {
      FImageIndex = NewImageIndex;

      UpdatePicture();
   }
}

//------------------------------------------------------------------------------------------//

void __fastcall TEnhancedImage::SetImageList(Imglist::TCustomImageList* NewImageList)
{
   if(NewImageList != FImageList)
   {
      FImageList = NewImageList;
      if(ImageList == 0) ImageIndex =-1;
   }
}

//------------------------------------------------------------------------------------------//

void __fastcall TEnhancedImage::UpdatePicture(void)
{
   if( UseImageList
       && ImageList != 0
       && ImageIndex >= 0
       && ImageIndex < ImageList->Count )
   {
       std::auto_ptr<Graphics::TBitmap> Image(new Graphics::TBitmap());

       ImageList->GetBitmap(ImageIndex, Image.get());
       Picture->Assign(Image.get());

//      Alternatively...

//      Graphics::TBitmap* Image = new Graphics::TBitmap();
//
//      try
//      {
//         ImageList->GetBitmap(ImageIndex, Image);
//         Picture->Assign(Image);
//      }
//      __finally
//      {
//         delete Image;
//      }

   }
}

//------------------------------------------------------------------------------------------//

