//------------------------------------------------------------------------------------------//
#ifndef EnhancedImageH
#define EnhancedImageH
//------------------------------------------------------------------------------------------//
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
//------------------------------------------------------------------------------------------//
//------------------------------------------------------------------------------------------//
class PACKAGE TEnhancedImage : public TImage
{
        typedef TImage inherited;
 private:
        TCustomImageList* FImageList;
        Imglist::TImageIndex FImageIndex;
        bool FUseImageList;

 protected:
        virtual void __fastcall SetUseImageList(bool NewUseImageList);
        virtual void __fastcall SetImageIndex(Imglist::TImageIndex NewImageIndex);
        virtual void __fastcall SetImageList(Imglist::TCustomImageList* NewImageList);
        virtual void __fastcall UpdatePicture(void);

        // Override Notification
        virtual void __fastcall Notification(TComponent* AComponent, TOperation Operation);

 public:
        __fastcall TEnhancedImage(TComponent* Owner);

 __published:
        __property bool UseImageList = {read=FUseImageList,
                                        write=SetUseImageList,
                                        default=false};

        __property TCustomImageList* ImageList = {read=FImageList,
                                                  write=SetImageList,
                                                  default=0};

        __property Imglist::TImageIndex ImageIndex = {read=FImageIndex,
                                                      write=SetImageIndex,
                                                      default=-1};
};
//------------------------------------------------------------------------------------------//
//------------------------------------------------------------------------------------------//
#endif
