//------------------------------------------------------------------------------------------//
#include <vcl\vcl.h>
#pragma hdrstop
//------------------------------------------------------------------------------------------//

#include "FilterEdit.h"

//------------------------------------------------------------------------------------------//
#pragma package(smart_init)
//------------------------------------------------------------------------------------------//
// ValidCtrCheck is used to assure that the components created do not have                  //
// any pure virtual functions.                                                              //
//------------------------------------------------------------------------------------------//

static inline void ValidCtrCheck(TFilterEdit *)
{
	new TFilterEdit(NULL);
}

//------------------------------------------------------------------------------------------//
//                                                                                          //
//         TFilterEdit:: Constructor                                                        //
//                                                                                          //
//------------------------------------------------------------------------------------------//

__fastcall TFilterEdit::TFilterEdit(TComponent* Owner)
	: TEdit(Owner),
          FExcludeFilter(false)
{
}

//------------------------------------------------------------------------------------------//
//                                                                                          //
//         TFilterEdit:: Member Functions                                                   //
//                                                                                          //
//------------------------------------------------------------------------------------------//

void __fastcall TFilterEdit::KeyPress(char &Key)
{
   // Is Key the Backspace key
   if(Key != '\b')
   {
      // Is Key contained in the filter
      for(int i=1; i<=FFilterString.Length(); ++i)
      {
         if(Key == FFilterString[i])
         {
            if(!ExcludeFilter) return;
            else
            {
               Key = 0;
               return;
            }
         }
      }

      // Key is not in the filter
      if(!ExcludeFilter) Key = 0;
   }
}
//------------------------------------------------------------------------------------------//



