//------------------------------------------------------------------------------------------//
#ifndef PropertyEditorsForNewAdditionalComponentsH
#define PropertyEditorsForNewAdditionalComponentsH
//------------------------------------------------------------------------------------------//
#include "DesignIntf.hpp"
#include "VCLEditors.hpp"
//------------------------------------------------------------------------------------------//
//------------------------------------------------------------------------------------------//
//                                                                                          //
//  The class below should be inherited from TImageIndexProperty from the 'EnhancedEditors' //
//  Package, but it not is not done so here. This is for compliance with the text in the    //
//  book. If you are using this property editor feel free to modify it.                     //
//                                                                                          //
//------------------------------------------------------------------------------------------//
//------------------------------------------------------------------------------------------//
class PACKAGE TImageIndexPropertyEditor : public TIntegerProperty,ICustomPropertyDrawing
{
	typedef TIntegerProperty inherited;

private:
        static const int Border = 2;
        static const int MaxImageWidth = 64;
        static const int MaxImageHeight = 64;

protected:
        Imglist::TCustomImageList* __fastcall GetComponentImageList(void);
        
public:
        virtual TPropertyAttributes __fastcall GetAttributes(void);
        virtual void __fastcall GetValues(Classes::TGetStrProc Proc);

	void __fastcall ListMeasureWidth(const AnsiString Value,
                                                 Graphics::TCanvas* ACanvas,
                                                 int& AWidth);

        void __fastcall ListMeasureHeight(const AnsiString Value,
                                                  Graphics::TCanvas* ACanvas,
                                                  int& AHeight);

	void __fastcall ListDrawValue(const AnsiString Value,
                                              Graphics::TCanvas* ACanvas,
                                              const TRect& ARect,
                                              bool ASelected);

	 void _fastcall PropDrawValue(Graphics::TCanvas* ACanvas,
                                              const TRect& ARect,
                                              bool ASelected);

        // This is a read-only property to be used as the pointer to the components
        // image list
        __property Imglist::TCustomImageList* ComponentImageList
                                              = {read=GetComponentImageList};

protected:
        #pragma option push -w-inl
        inline __fastcall virtual TImageIndexPropertyEditor(const Designintf::_di_IDesigner ADesigner,
                                                       int APropCount)
                                                       : TIntegerProperty(ADesigner,
                                                                       APropCount)
        { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	inline __fastcall virtual ~TImageIndexPropertyEditor(void)
        { }
	#pragma option pop

};
//------------------------------------------------------------------------------------------//
//------------------------------------------------------------------------------------------//
#endif
