//------------------------------------------------------------------------------------------//
#ifndef NonVCLTypeInfoH
#define NonVCLTypeInfoH
//------------------------------------------------------------------------------------------//

#ifndef TypInfoHPP
#include <TypInfo.hpp>
#endif

//------------------------------------------------------------------------------------------//

//class __declspec(delphiclass) TNonVCLTypesClass;

class PACKAGE TNonVCLTypeInfo : public TObject
{
public:
   // Fundamental Integer Types
   static PTypeInfo __fastcall Int();
   static PTypeInfo __fastcall UnsignedInt();

   static PTypeInfo __fastcall ShortInt();
   static PTypeInfo __fastcall UnsignedShortInt();

   static PTypeInfo __fastcall LongInt();
   static PTypeInfo __fastcall UnsignedLongInt();

   static PTypeInfo __fastcall Char();
   static PTypeInfo __fastcall UnsignedChar();
   static PTypeInfo __fastcall SignedChar();

   // Fundamental Floating Point Types
   static PTypeInfo __fastcall Double();
   static PTypeInfo __fastcall LongDouble();
   static PTypeInfo __fastcall Float();

   // Fundamental Boolean type
   static PTypeInfo __fastcall Bool();

   // The AnsiString class
   static PTypeInfo __fastcall AnsiString();

private:
//   #pragma option push -w-inl
   inline __fastcall TNonVCLTypeInfo() : TObject()
   { }
};

//------------------------------------------------------------------------------------------//

class PACKAGE TNonVCLTypesClass : public TObject
{
public:
__published:

   // Fundamental Integer Types
   __property int IntProperty = {};
   __property unsigned int UnsignedIntProperty = {};

   __property short int ShortIntProperty = {};
   __property unsigned short int UnsignedShortIntProperty = {};

   __property long int LongIntProperty = {};
   __property unsigned long int UnsignedLongIntProperty = {};

   __property char CharProperty = {};
   __property unsigned char UnsignedCharProperty = {};
   __property signed char SignedCharProperty = {};

   // Fundamental Floating Point Types
   __property double DoubleProperty = {};
   __property long double LongDoubleProperty = {};
   __property float FloatProperty = {};

   // Fundamental Boolean type
   __property bool BoolProperty = {};

   // The AnsiString class
   __property AnsiString AnsiStringProperty = {};

private:
//   #pragma option push -w-inl
   inline __fastcall TNonVCLTypesClass() : TObject()
   { }
};
//------------------------------------------------------------------------------------------//
#endif
