//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "udmMain.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TdmMain *dmMain;
//---------------------------------------------------------------------------
__fastcall TdmMain::TdmMain(TComponent* Owner)
        : TDataModule(Owner)
{
}
//---------------------------------------------------------------------------


AnsiString __fastcall TdmMain::CreateConnectionString(AnsiString Server, AnsiString FileName, ConnectionType CType)
{
  AnsiString ConnectionString = "";
  switch (CType){
    case ctLocal : ConnectionString = FileName;break;
    case ctTCPIP : ConnectionString.sprintf("%s:%s",Server,FileName);break;
    case ctNetBEUI : ConnectionString.sprintf("\\%s\%s",Server,FileName);break;
    case ctSPX : ConnectionString.sprintf("%s@%s",Server,FileName);break;
  }
  return ConnectionString;
}
void __fastcall TdmMain::cnMainAfterConnect(TObject *Sender)
{
 qrProgram->Active = true;
 qrRevision->Active = true;
 qrBugs->Active = true;
}
//---------------------------------------------------------------------------

void __fastcall TdmMain::cnMainBeforeDisconnect(TObject *Sender)
{
  trMain->Active = false;
}
//---------------------------------------------------------------------------
void __fastcall TdmMain::qrProgramAfterPost(TDataSet *DataSet)
{
  try
  {
    //commit the changes, and retain the transaction
    trMain->CommitRetaining();
  } catch (Exception &E)//if *any* error happens, we'll rollback and restart
  {
    trMain->RollbackRetaining();
    ShowMessage("Error commiting changes. "+E.Message);
  }
}
//---------------------------------------------------------------------------



void __fastcall TdmMain::qrRevisionBeforePost(TDataSet *DataSet)
{
  //assign it to the current pro_id, if pro_id is null
  if (DataSet->FieldByName("pro_id")->IsNull){
    DataSet->FieldByName("pro_id")->AsInteger =
      qrProgram->FieldByName("pro_id")->AsInteger;
  }

}
//---------------------------------------------------------------------------



void __fastcall TdmMain::qrRevisionAfterPost(TDataSet *DataSet)
{
  qrProgramAfterPost(DataSet);
  if (!qrBugs->IsEmpty()){
    qrBugs->Refresh();
  }
}
//---------------------------------------------------------------------------


void __fastcall TdmMain::qrProgramPostError(TDataSet *DataSet,
      EDatabaseError *E, TDataAction &Action)
{
  ShowMessage("Error applying changes. " + E->Message);
  Action = daAbort;
}
//---------------------------------------------------------------------------

