//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdio.h>
#pragma hdrstop

#include "ufrmMain.h"
#include "udmMain.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmMain *frmMain;
//---------------------------------------------------------------------------
__fastcall TfrmMain::TfrmMain(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------




void __fastcall TfrmMain::UpdateScreen()
{
  bool Connected = dmMain->cnMain->TestConnected();
  rdConnection->Enabled = !Connected;
  pnlConnection->Enabled = !Connected;
  btnConnect->Enabled = !Connected;
  btnDisconnect->Enabled = Connected;
  btnCreate->Enabled = !Connected;

  if (Connected)
  {

  }
        //TODO: Add your source code here
}
void __fastcall TfrmMain::btnCreateClick(TObject *Sender)
{
  //create a new database
  try
  {
    dmMain->cnMain->DatabaseName = dmMain->CreateConnectionString(edtHost->Text,
                                        edtFile->Text,(ConnectionType)rdConnection->ItemIndex);
    dmMain->cnMain->Params->Clear();
    //a normal connection string looks like
    //create database "c:\bcb5book.gdb" user "sysdba" password "masterkey";
    //we must specify the user and password parameter, however, can not
    //use the normal name=value format, must use name value

    dmMain->cnMain->Params->Add("user \""+edtUser->Text+"\"");
    dmMain->cnMain->Params->Add("password \""+edtPass->Text+"\"");
    dmMain->cnMain->Params->Add("page_size 4096");
    //now we create it
    dmMain->cnMain->CreateDatabase();
    //and execute the sql required to create the tables, sprocs, etc.
    dmMain->cnMain->Connected = true;

    MessageDlg("Database successfully created.",mtInformation,
      TMsgDlgButtons()<<mbOK,0);

    UpdateScreen();
  }catch (Exception &E)
  {
    if (dmMain->trMain->InTransaction)
    {
      dmMain->trMain->Rollback();//rollback trans
    }
    MessageDlg("Error Generating New Database : "+E.Message,
                mtWarning,TMsgDlgButtons()<<mbOK,0);
  }
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::btnConnectClick(TObject *Sender)
{
  dmMain->cnMain->Params->Clear();
  dmMain->cnMain->Params->Values["user_name"] = edtUser->Text;
  dmMain->cnMain->Params->Values["password"] = edtPass->Text;

  dmMain->cnMain->DatabaseName = dmMain->CreateConnectionString(edtHost->Text,
                                      edtFile->Text,(ConnectionType)rdConnection->ItemIndex);

  dmMain->cnMain->Connected = true;

  evtMain->RegisterEvents();
  UpdateScreen();
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::btnDisconnectClick(TObject *Sender)
{
  if (dmMain->trMain->InTransaction)
  {
    if (MessageDlg("Commit changes to database?",mtConfirmation,
      TMsgDlgButtons()<<mbYes<<mbNo,0)==mrNo)
    {
      dmMain->trMain->Rollback();
    }else
    {
      dmMain->trMain->Commit();
    }
  }
  evtMain->UnRegisterEvents();
  dmMain->cnMain->Connected = false;

  UpdateScreen();
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::FormShow(TObject *Sender)
{
  UpdateScreen();

}
//---------------------------------------------------------------------------



void __fastcall TfrmMain::FormCloseQuery(TObject *Sender, bool &CanClose)
{
  btnDisconnectClick(Sender);
  CanClose = true;

}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::sqlMonitorSQL(AnsiString EventText,
      TDateTime EventTime)
{
  memDiag->Lines->Add(EventText);
}
//---------------------------------------------------------------------------






void __fastcall TfrmMain::DBGrid4KeyUp(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
  if (Key ==VK_DELETE && dynamic_cast<TDBGrid *>(Sender)->DataSource->DataSet->State==dsBrowse){
    dynamic_cast<TDBGrid *>(Sender)->DataSource->DataSet->Delete();
  }
        
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::btnNewProgramClick(TObject *Sender)
{
  dmMain->qrProgram->Insert();        
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::btnNewRevisionClick(TObject *Sender)
{
  dmMain->qrRevision->Insert();        
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::btnNewBugClick(TObject *Sender)
{
  dmMain->qrBugs->Insert();
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::evtMainEventAlert(TObject *Sender,
      AnsiString EventName, int EventCount, bool &CancelAlerts)
{
  ShowMessage(EventName);
}
//---------------------------------------------------------------------------

