//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnXMLClick(TObject *Sender)
{
  Memo1->Lines->Clear();
  XMLDocument1->Active = true;
  _di_IXMLNode Chapter = XMLDocument1->DocumentElement;
  Memo1->Lines->Add("Chapter: " + Chapter->Attributes["Title"]);
  _di_IXMLNode Section = Chapter->ChildNodes->GetNode(0);
  Memo1->Lines->Add("Section: " + Section->Attributes["Title"]);
  Memo1->Lines->Add("Components: " +
    Section->ChildNodes->Nodes[(AnsiString)"Components"]->GetText());
//    Section->ChildNodes->IndexOf("Components")]->GetText());
  Memo1->Lines->Add("Wizards: " +
    Section->ChildNodes->Nodes[(AnsiString)"Wizards"]->GetText());
//    Section->ChildNodes->IndexOf("Wizards")]->GetText());
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnNewSectionClick(TObject *Sender)
{
  XMLDocument1->Active = true;
  _di_IXMLNode Chapter = XMLDocument1->DocumentElement;
  Chapter->AddChild("Section");
  _di_IXMLNode NewSection = Chapter->ChildNodes->GetNode(
    Chapter->ChildNodes->Count-1);
  NewSection->SetAttribute("Title", (AnsiString)"New Section Title");
  NewSection->AddChild("Components");
  NewSection->AddChild("Wizards");
  XMLDocument1->SaveToFile();
  AnsiString XML;
  XMLDocument1->SaveToXML(XML);
  ShowMessage(XML);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
  Chapter = GetChapter(XMLDocument1);
  CurrentSection = 0; // First Section
  DisplaySection();
}

void TForm1::DisplaySection(void)
{
  Memo1->Lines->Clear();
  Memo1->Lines->Add("Chapter: " + Chapter->Title);
  Memo1->Lines->Add("Section: " +
    Chapter->Section[CurrentSection]->Title);
  Memo1->Lines->Add("Components: " +
    Chapter->Section[CurrentSection]->Components);
  Memo1->Lines->Add("Wizards: " +
    Chapter->Section[CurrentSection]->Wizards);
  // Enable/disable buttons
  btnFirst->Enabled = CurrentSection > 0;
  btnPrev->Enabled = CurrentSection > 0;
  btnNext->Enabled = CurrentSection < Chapter->Count-1;
  btnLast->Enabled = CurrentSection < Chapter->Count-1;
};

//---------------------------------------------------------------------------
void __fastcall TForm1::btnFirstClick(TObject *Sender)
{
  CurrentSection = 0;
  DisplaySection();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnPrevClick(TObject *Sender)
{
  if (CurrentSection)
  {
    CurrentSection--;
    DisplaySection();
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnNextClick(TObject *Sender)
{
  if (CurrentSection < Chapter->Count-1)
  {
    CurrentSection++;
    DisplaySection();
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnLastClick(TObject *Sender)
{
  CurrentSection = Chapter->Count-1;
  DisplaySection();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::cdsChapterAfterPost(TDataSet *DataSet)
{
  dynamic_cast<TClientDataSet*>(DataSet)->ApplyUpdates(0);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::cdsSectionAfterPost(TDataSet *DataSet)
{
  cdsChapter->ApplyUpdates(0);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
  if ((cdsChapter->ChangeCount + cdsSection->ChangeCount) > 0)
    cdsChapter->ApplyUpdates(0);
}
//---------------------------------------------------------------------------

