/*---------------------------------------------------------------------------
  CommCtrlDlgForm.cpp
        C++Builder Developer's Guide
        Chapter 14 - Common Control and Dialog Utility
        (c) Paul Gustavson, 2002
        Skeleton program designed for demonstrating Common Control & Dialogs
---------------------------------------------------------------------------*/

#include <vcl.h>
#pragma hdrstop

#include <stdio.h>
#include <cderr.h>

#include "CommCtrlDlgForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFormCommCtrl_Dlg *FormCommCtrl_Dlg;
//---------------------------------------------------------------------------
__fastcall TFormCommCtrl_Dlg::TFormCommCtrl_Dlg(TComponent* Owner)
        : TForm(Owner)
{
   WM_FINDMSGSTRING = RegisterWindowMessage(FINDMSGSTRING);
   WindowProc = MyWndProc;
   InitCommonControls();    // make sure the the common control DLL is loaded.
   ControlHandle = NULL;
}

//---------------------------------------------------------------------------

void __fastcall TFormCommCtrl_Dlg::MyWndProc(Messages::TMessage &Message)
{
  // If the window receives a notification message then
  // pass it to the appropriate windows messaging function. Otherwise let
  // the default processing for the message take place.

  if (Message.Msg == WM_FINDMSGSTRING)
        Process_wmFindMsgString(Message);
  else
        WndProc(Message) ;
}

//---------------------------------------------------------------------------

void __fastcall TFormCommCtrl_Dlg::ButtonMakeListViewClick(TObject *Sender)
{
 HWND ListBox;
 RECT Rect;
/*
 DWORD dwStyle = WS_TABSTOP |
                                 WS_CHILD |
                                 WS_BORDER |
                                 WS_VISIBLE |
                                 LVS_REPORT |
                                 LVS_NOSORTHEADER;
*/
// DWORD dwExStyle = 0;

 Rect = GetClientRect();
 HINSTANCE  hInstance = (HINSTANCE )GetWindowThreadProcessId(
    Handle,	// handle of window
    NULL	// address of variable for process identifier
   );

  ControlHandle = CreateWindowEx(0L,
      WC_LISTVIEW,
      NULL,
      WS_VISIBLE | WS_CHILD | WS_BORDER | TVS_HASLINES | TVS_HASBUTTONS | TVS_LINESATROOT,
      0, 180,
      Rect.right - Rect.left, Rect.bottom-180,
      Handle,
      0,
      hInstance,
      NULL);

}
//---------------------------------------------------------------------------

void __fastcall TFormCommCtrl_Dlg::Button2Click(TObject *Sender)
{
  if (ControlHandle)
     ListView_SetBkColor(ControlHandle,CLR_NONE);
}
//---------------------------------------------------------------------------
void __fastcall TFormCommCtrl_Dlg::ButtonChooseColorClick(TObject *Sender)
{
    LPCHOOSECOLOR cc;
    COLORREF	initrgb, rgb;
    BOOL		res;
    DWORD		err;

    initrgb= 0x0000FFFF; //yellow

    char result[MAX_PATH];

    HINSTANCE  hInstance = (HINSTANCE )GetWindowThreadProcessId(
            Handle,	// handle of window
            NULL);	// address of variable for process identifier

    DWORD mcolors[15];
    mcolors[0] =  0x00FF0000; // blue
    mcolors[1] =  0x00FF4040; // med blue
    mcolors[2] =  0x00FF8080; // light med blue
    mcolors[3] =  0x00FFFF00; // aqua
    mcolors[4] =  0x0000FF00; // green
    mcolors[5] =  0x0040FF40; // med green
    mcolors[6] = 0x0080FF80; // light med green
    mcolors[7] =  0x0000FFFF; // yellow
    mcolors[8] =  0x000000FF; // red
    mcolors[9] = 0x004040FF; // more pink
    mcolors[10] = 0x008080FF; // pink
    mcolors[11] = 0x00400040; // purple
    mcolors[12] = 0x00808080; // gray
    mcolors[13] = 0x00404040; // dk gray
    mcolors[14] =  0x00000000; // white
    mcolors[15] =  0x00FFFFFF; // black

    cc = (LPCHOOSECOLOR)malloc(sizeof(CHOOSECOLOR));
    cc->lStructSize = (DWORD) sizeof(CHOOSECOLOR);
    cc->hwndOwner = Handle;
    cc->hInstance = hInstance;
    cc->rgbResult = initrgb;
    cc->lpCustColors = mcolors; //m_crCustomColors; //NULL;
    cc->Flags = CC_ANYCOLOR | CC_FULLOPEN | CC_RGBINIT;
    cc->lCustData = NULL;
    cc->lpfnHook = NULL;
    cc->lpTemplateName = NULL;

    if (!(res = ChooseColor(cc)))
    {
            err = CommDlgExtendedError();
            sprintf(result,"Error: %d\n",err);
    }
    else{
            rgb=cc->rgbResult;
            sprintf(result,"r g b: %d %d %d\n", ((BYTE) (rgb)) ,((BYTE)
                    (((WORD) (rgb)) >> 8)),((BYTE) ((rgb) >> 16))  );
    }
    MessageBox(Handle,result,"Result",MB_OK);
}
//---------------------------------------------------------------------------
void __fastcall TFormCommCtrl_Dlg::ButtonChooseFontClick(TObject *Sender)
{
    LPCHOOSEFONT cf;
    COLORREF	rgb;
    BOOL		res;
    DWORD		err;
    DWORD     colors = 0;
    LOGFONT lf;
    HFONT hFont;

    char result[MAX_PATH];

        cf = (LPCHOOSEFONT)malloc(sizeof(CHOOSEFONT));
	cf->lStructSize= sizeof(CHOOSEFONT);
	cf->hwndOwner	= Handle;
        cf->hDC         = GetDC(Handle);
	cf->Flags	= CF_APPLY | CF_EFFECTS | CF_SCALABLEONLY |
                                CF_BOTH | CF_WYSIWYG;
        cf->lpLogFont   = &lf;
	cf->iPointSize	= 0;
	cf->rgbColors	= colors;
	cf->lCustData	= 0L;
	cf->lpfnHook	= NULL;
	cf->lpTemplateName = NULL;
	cf->hInstance	= NULL;
	cf->lpszStyle	= NULL;
	cf->nFontType	= 0;
	cf->nSizeMin	= 0;
	cf->nSizeMax	= 0;

    if (!(res = ChooseFont(cf)))
    {
            err = CommDlgExtendedError();
            sprintf(result,"Error: %d\n",err);
    }
    else{
        hFont = CreateFontIndirect(&lf);
        rgb=cf->rgbColors; //colors;
        sprintf(result,"height %d  width %d   italic %d   underline %d   "
                       "strikeout %d  \n Color r g b: %d %d %d\n\n",
                       lf.lfHeight,lf.lfWidth,lf.lfItalic,
                       lf.lfUnderline, lf.lfStrikeOut ,
                       ((BYTE) (rgb)) ,((BYTE)(((WORD) (rgb)) >> 8)),
                       ((BYTE) ((rgb) >> 16))  );
    }
    MessageBox(Handle,result,"Result",MB_OK);

}

//---------------------------------------------------------------------------

void TFormCommCtrl_Dlg::MessageErrorCommDlg()
{
    AnsiString msg;
    DWORD error = CommDlgExtendedError();
    switch (error)
    {
        case CDERR_DIALOGFAILURE :
            msg = "The dialog box could not be created."
                  "Check for invalid window handle";
        case CDERR_FINDRESFAILURE :
            msg = "Failed to find a specified resource.";
            break;
        case CDERR_MEMLOCKFAILURE :
            msg = "Unable to allocate memory for internal structures.";
            break;
        case CDERR_INITIALIZATION :
            msg = "Failed during initialization."
                  "Sufficient memory is not available.";
            break;
        case CDERR_NOHINSTANCE    :
            msg = "Failed. Need an instance handle.";
            break;
        case CDERR_LOCKRESFAILURE :
            msg = "Failed to lock a specified resource.";
            break;
        case CDERR_NOHOOK         :
            msg = "Failed. Need pointer to a corresponding hook procedure.";
            break;
        case CDERR_LOADRESFAILURE :
            msg = "Failed to load a specified resource.";
            break;
        case CDERR_NOTEMPLATE     :
            msg = "Failed. Need a corresponding template.";
            break;
        case CDERR_LOADSTRFAILURE :
            msg = "Failed to load a specified string.";
            break;
        case CDERR_STRUCTSIZE     :
            msg = "lStructSize value is invalid.";
            break;
        case CDERR_MEMALLOCFAILURE:
            msg = "Unable to allocate memory for internal structures.";
            break;
        case FRERR_BUFFERLENGTHZERO:
            msg = "Buffer length zero";
            break;
        default :
            msg = "Unable to determine problem";
    }
    MessageBox(NULL,msg.c_str(),"Common Dialog Error",MB_OK);
}

//---------------------------------------------------------------------------
void __fastcall TFormCommCtrl_Dlg::ButtonFindTextClick(TObject *Sender)
{
//FindText

    FINDREPLACE* fr;
    char TextFind[80];
    char TextReplace[80];
    TextFind[0] = 0;
    TextReplace[0] = 0;

    fr = (FINDREPLACE*)malloc(sizeof(FINDREPLACE));
    fr->lStructSize = sizeof(FINDREPLACE);
    fr->hwndOwner = Handle;
    HINSTANCE  hInstance = (HINSTANCE )GetWindowThreadProcessId(
            Handle,	// handle of window
            NULL);	// address of variable for process identifier
    fr->hInstance = hInstance;      // NULL; //
    fr->Flags =  FR_DOWN | FR_REPLACE;
    fr->lpstrFindWhat = TextFind;
    fr->lpstrReplaceWith = TextReplace;
    fr->wFindWhatLen = 80;
    fr->wReplaceWithLen = 80;
//    fr->lCustData = NULL;
 //   fr->lpfnHook = NULL;
 //   fr->lpTemplateName = NULL;

//    WM_FINDMSGSTRING = RegisterWindowMessage(FINDMSGSTRING);
    HWND HandleResult = FindText(fr);

    if (!HandleResult)
    {
        MessageErrorCommDlg();
    }

    // The Find or Replace dialog box sends the FINDMSGSTRING registered
    // message to the window procedure of its owner window when the user clicks
    // the Find Next, Replace, or Replace All button, or closes the dialog box.
}

//---------------------------------------------------------------------------
void __fastcall TFormCommCtrl_Dlg::Process_wmFindMsgString(TMessage Msg)
{
    LPFINDREPLACE lpfr = (LPFINDREPLACE) Msg.LParam;
    char result[MAX_PATH];

    sprintf(result,"TextToFind = %s\nReplacementText = %s\n",
                   lpfr->lpstrFindWhat,lpfr->lpstrReplaceWith);

    MessageBox(NULL,result,"Find Dialog Results",MB_OK);
}

//---------------------------------------------------------------------------
void __fastcall TFormCommCtrl_Dlg::ButtonOpenFileClick(TObject *Sender)
{
//GetOpenNameFile
    OPENFILENAME openfilename;
    char filename[MAX_PATH];
    *filename = '\0';

   memset(&openfilename, 0, sizeof(openfilename));

   openfilename.lStructSize  = sizeof(OPENFILENAME);
   openfilename.hwndOwner = Handle;
    HINSTANCE  hInstance = (HINSTANCE )GetWindowThreadProcessId(
            Handle,	// handle of window
            NULL);	// address of variable for process identifier
    openfilename.hInstance = hInstance;
   openfilename.lpstrFilter = "All Files\0*.*\0\0";
//   openfilename->lpstrCustomFilter;
//   openfilename->nMaxCustFilter;
   openfilename.nFilterIndex = 1;
   openfilename.lpstrFile = filename;
   openfilename.nMaxFile = MAX_PATH;
//   openfilename->lpstrFileTitle;
//   openfilename->nMaxFileTitle;
//   openfilename->lpstrInitialDir;
//   openfilename->lpstrTitle;
   openfilename.Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST |
                OFN_NOREADONLYRETURN | OFN_PATHMUSTEXIST;

   if (GetOpenFileName(&openfilename) == 0)
   {
        MessageErrorCommDlg();
   }
   else
   {
    char result[MAX_PATH];
    sprintf(result,"FileToOpen = %s\n",filename);
    MessageBox(NULL,result,"Open Dialog Results",MB_OK);
   }
}
//---------------------------------------------------------------------------
void __fastcall TFormCommCtrl_Dlg::ButtonSaveFileClick(TObject *Sender)
{
//GetSaveFileName
    OPENFILENAME savefilename;
    char filename[MAX_PATH];
    *filename = '\0';

   memset(&savefilename, 0, sizeof(savefilename));

   savefilename.lStructSize  = sizeof(OPENFILENAME);
   savefilename.hwndOwner = Handle;
    HINSTANCE  hInstance = (HINSTANCE )GetWindowThreadProcessId(
            Handle,	// handle of window
            NULL);	// address of variable for process identifier
    savefilename.hInstance = hInstance;      // NULL; //
   savefilename.lpstrFilter = "All Files\0*.*\0\0";
//   savefilename->lpstrCustomFilter;
//   savefilename->nMaxCustFilter;
   savefilename.nFilterIndex = 1;
   savefilename.lpstrFile = filename;
   savefilename.nMaxFile = MAX_PATH;
//   openfilename->lpstrFileTitle;
//   openfilename->nMaxFileTitle;
//   openfilename->lpstrInitialDir;
//   openfilename->lpstrTitle;
   savefilename.Flags = OFN_EXPLORER | OFN_PATHMUSTEXIST;

   if (GetSaveFileName(&savefilename) == 0)
   {
        MessageErrorCommDlg();
   }
   else
   {
    char result[MAX_PATH];
    sprintf(result,"FileToSave = %s\n",filename);
    MessageBox(NULL,result,"Save Dialog Results",MB_OK);
   }
}
//---------------------------------------------------------------------------
void __fastcall TFormCommCtrl_Dlg::ButtonPrintSetupClick(TObject *Sender)
{
//PageSetupDlg
}
//---------------------------------------------------------------------------
void __fastcall TFormCommCtrl_Dlg::ButtonPrintClick(TObject *Sender)
{
//PrintDlg
}
//---------------------------------------------------------------------------
void __fastcall TFormCommCtrl_Dlg::ButtonReplaceTextClick(TObject *Sender)
{
//ReplaceText
}
//---------------------------------------------------------------------------
