/*---------------------------------------------------------------------------
  DllLibUtilForm.cpp
        C++Builder Developer's Guide
        Chapter 14 - DLL LIB Util
        (c) Paul Gustavson, 2002
        Used to examine DLL and LIB files and create BCB compliant LIBs
---------------------------------------------------------------------------*/
#include <vcl\vcl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dir.h>
#include <winver.h>
#include <shlwapi.h>
#include <assert.h>

#pragma hdrstop

extern unsigned _stklen=0x2000;

#include "DllLibUtilForm.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TFormDLLLibUtil *FormDLLLibUtil;

//---------------------------------------------------------------------------
void TFileInfo::Init()
{
    Version = "";
    FileOS = "";
    FileType = "";
    FileFlags = "";
    FileDescription = "";
    LegalCopyright = "";
    CompanyName = "";
    InternalName = "";
    ProductName = "";
    Comments = "";
    OriginalFilename = "";
    FileVersion = "";
    LegalTrademarks = "";
    ProductVersion = "";
}


//---------------------------------------------------------------------------
__fastcall TFormDLLLibUtil::TFormDLLLibUtil(TComponent* Owner)
	: TForm(Owner)
{
//	ImplibOptions = {NULL};
//	Infilename = {NULL};
}



//---------------------------------------------------------------------------
void TFormDLLLibUtil::Process_Command_Line(AnsiString file, AnsiString options)
{
 strcpy(ImpOptions,options.c_str());
 strcpy(Infilename,file.c_str());
}


//---------------------------------------------------------------------------
int TFormDLLLibUtil::ConvertDef(char *in_filename, char *out_filename)
/* Append underscores and equate to dll names */
{
FILE *Infile, *Outfile;
int RetVal;
char Instr[256], Outstr[512];
char data[100];
char *P;

  RetVal = FALSE;

  Infile = fopen(in_filename,"rb");
  if(Infile != NULL) {
    Outfile = fopen(out_filename,"wb");
    if(Outfile != NULL) {

      MemoStatus->Lines->Add(">ConvertDef(\"" +
                AnsiString(in_filename) + "\"->\"" +
                AnsiString(out_filename) + "\"");
      MemoStatus->Lines->Add("");


      while(fgets(Instr, sizeof(Instr), Infile)) {
        strcpy(Outstr, Instr);
        if(strchr(Outstr,'@')) {
          P = strtok(Instr," "); /* Get identifier without leading spaces */
          strcpy(Outstr,"   "); /* Add some space  */
          strcat(Outstr, "_"); /* Add some space, equal sign, underscore */
          strcat(Outstr, P); /* Add the identifier */
          strcat(Outstr, "  =   "); /* Add some space, equal sign, underscore */
          strcat(Outstr,P); /* Add the identifier */
          strcat(Outstr,"\r\n"); /* Add cr/lf to end line */
          fputs(Outstr, Outfile); /* Output changed line to file */
        }
        else
          fputs(Instr, Outfile); /* Output unchanged line directly to file */
      } /* while */
      fclose(Infile);
      fclose(Outfile);
      RetVal = TRUE;
    }
    else
    {
//      EditError->Text = "Error opening temporary output file";
      MemoStatus->Lines->Add("Error opening temporary output file");
    }
  }
  else
  {
    sprintf(data,"Error opening temporary input file %s",in_filename);
//    EditError->Text = data;
    MemoStatus->Lines->Add(data);
  }

  return(RetVal);
}


//---------------------------------------------------------------------------
int TFormDLLLibUtil::ProcessDefFile_Filter(char *Filename)
{
FILE *Infile, *Outfile;
int RetVal;
char Instr[256], Outstr[512];
char data[100];
char *P;

  RetVal = FALSE;

  Infile = fopen(Filename,"rb");
  if(Infile != NULL) {
    Outfile = fopen("temp2.def","wb");
    if(Outfile != NULL) {
      while(fgets(Instr, sizeof(Instr), Infile)) {
        strcpy(Outstr, Instr);
        if(strchr(Outstr,'@')) {
          P = strtok(Instr," "); /* Get identifier without leading spaces */
          strcpy(Outstr,"   "); /* Add some space  */
//          strcat(Outstr, "_"); /* Add some space, equal sign, underscore */
          strcat(Outstr, P); /* Add the identifier */
//          strcat(Outstr, "  =   "); /* Add some space, equal sign, underscore */
//          strcat(Outstr,P); /* Add the identifier */
          strcat(Outstr,"\r\n"); /* Add cr/lf to end line */
          fputs(Outstr, Outfile); /* Output changed line to file */
        }
        else
          fputs(Instr, Outfile); /* Output unchanged line directly to file */
      } /* while */
      fclose(Infile);
      fclose(Outfile);
      RetVal = TRUE;
    }
    else
    {
//      EditError->Text = "Error opening temporary output file";
      MemoStatus->Lines->Add("Error opening temporary output file");
    }
  }
  else
  {
    sprintf(data,"Error opening temporary input file %s",Filename);
//    EditError->Text = data;
    MemoStatus->Lines->Add(data);

  }

  return(RetVal);
}

//---------------------------------------------------------------------------

bool TFormDLLLibUtil::IsWindowsNT()
{
	OSVERSIONINFO osv;
    osv.dwOSVersionInfoSize = sizeof(osv);
    GetVersionEx(&osv);
    return (osv.dwPlatformId == VER_PLATFORM_WIN32_NT);
}
//---------------------------------------------------------------------------

bool __fastcall TFormDLLLibUtil::SystemCommand(AnsiString command, bool hidden)
{
    bool result = false;
    if (!hidden)
    {
       MemoStatus->Lines->Add(">" + AnsiString(command));
       result = system(command.c_str());
       MemoStatus->Lines->Add("");
    }
    else
    {
        // If NT do security stuff
        SECURITY_DESCRIPTOR sd;
        SECURITY_ATTRIBUTES sa;
        LPSECURITY_ATTRIBUTES lpsa = NULL;
        if (IsWindowsNT()) {
                InitializeSecurityDescriptor(&sd,
                SECURITY_DESCRIPTOR_REVISION);
            SetSecurityDescriptorDacl(&sd, true, NULL, false);
            sa.nLength = sizeof(SECURITY_ATTRIBUTES);
            sa.bInheritHandle = true;
            sa.lpSecurityDescriptor = &sd;
            lpsa = &sa;
        }

        // Create the Pipe and get r/w handles
        HANDLE hReadPipe;
        HANDLE hWritePipe;
        assert(CreatePipe(&hReadPipe,
                                          &hWritePipe,
                          lpsa,
                          2500000));
        // initialize STARTUPINFO struct
        STARTUPINFO si;
        memset(&si, 0, sizeof(STARTUPINFO));
        si.cb = sizeof(STARTUPINFO);
        si.dwFlags = STARTF_USESHOWWINDOW |STARTF_USESTDHANDLES;
        si.wShowWindow = SW_HIDE;
        si.hStdOutput = hWritePipe;
        si.hStdError = hWritePipe;
        PROCESS_INFORMATION pi;
        assert(hWritePipe);
        // Run the cmdLine tool
        MemoStatus->Lines->Add(">" + AnsiString(command));

        Application->ProcessMessages();

        if (CreateProcess(NULL,
                               command.c_str(),
                               NULL,//security
                               NULL,// security
                               TRUE,//inherits handles
                               0,
                               0,
                               0,
                               &si,
                               &pi))
        {
            CloseHandle(pi.hThread);
            WaitForSingleObject(pi.hProcess, 90000);

            // read from the pipe and put in richedit
            assert(hReadPipe);
            DWORD BytesRead; //unsigned long
            char dest[4000];
            bool RdLoopDone = false;
            int FBreak = 1;
            if (ExitCode) Screen->Cursor = crDefault;
            while (!RdLoopDone)
            {
                memset(dest, 0, 4000);
                assert(ReadFile(hReadPipe, &dest, sizeof(dest), &BytesRead, NULL));
                MemoStatus->Lines->Add("   " + String(dest));
                if (BytesRead < 4000)
                    RdLoopDone = true;
                if (FBreak > 150)
                    RdLoopDone = true;
                FBreak++;
            }
            MemoStatus->Lines->Add("");
       }
       result = true;
    }
    return result;
}

//---------------------------------------------------------------------------
void __fastcall TFormDLLLibUtil::ButtonImpItClick(TObject *Sender)
{
  MemoStatus->Lines->Clear();
  MemoStatus->Lines->Add("DLL -> BCB Lib...");
  MemoStatus->Lines->Add("");

  struct ffblk ffblk;
  char Newfilename[256];
  int Done;
  char Cmd[256];
  char drive[MAXDRIVE];
  char dir[MAXDIR];
  char file[MAXFILE];
  char ext[MAXEXT];
  char Filepath[MAXDRIVE+MAXDIR+MAXFILE+MAXEXT];

  char data[200];

  if (FileListBox1->FileName.Length() == 0)
  {
        MessageBeep(MB_OK);
        MemoStatus->Lines->Add("Please select a DLL file!");
        return;
  }

  Process_Command_Line(FileListBox1->FileName, EditImplibOptions->Text);

  if(strlen(Infilename) != 0)
  {
   drive[0] = dir[0] = file[0] = ext[0] = '\0';
   fnsplit(Infilename,drive,dir,file,ext);
   strcpy(Filepath, drive);
   strcat(Filepath, dir);
   Done = findfirst(Infilename,&ffblk,0);
   while(!Done)
   {
     strcpy(Infilename, Filepath);
     strcat(Infilename, ffblk.ff_name);
     if(!strchr(Infilename,'.')) /* Add default extension */
       strcat(Infilename,".DLL");

     /* Build a new filename with .LIB extension */

     strcpy(Newfilename,EditTarget1->Text.c_str());
     strcat(Newfilename,EditFileLib->Text.c_str());

     AnsiString output1file = TempDir + "temp.def";
      if (FileExists(output1file))  DeleteFile(output1file.c_str());

     AnsiString output2file = TempDir + "temp2.def";
      if (FileExists(output2file))  DeleteFile(output2file.c_str());

     /* Run IMPDEF.exe on the input .DLL file */
     sprintf(Cmd,"IMPDEF \"%s\" \"%s\"",output1file, Infilename);

     if(SystemCommand(AnsiString(Cmd),true) != -1)    /* Successful .DEF file creation */
     { /* Successful .DEF file creation */
       if (CheckBoxVC->Checked)  // Visual C++ DLL
       {
           if(ConvertDef(output1file.c_str(),output2file.c_str())) /* Append underscores and equate to dll names */
           {
             /* Run implib on def file to produce .lib output */
             sprintf(Cmd,"IMPLIB %s \"%s\" \"%s\"", ImpOptions, Newfilename,output2file.c_str());

             if(SystemCommand(AnsiString(Cmd)) != -1)
             {
               LoadText(output2file,RichEditNewLIBList,"IMPDEF");
             }
             else {
               sprintf(data,"%s ----> IMPLIB Failed. - Illegal Command line.",Infilename); //, Newfilename);
               MessageBeep(MB_OK);
               MemoStatus->Lines->Add(data);
               break;
             } // else
           } // if (ConvertDef
       }
       else  // Borland DLL
       {
             sprintf(Cmd,"IMPLIB %s \"%s\" \"%s\"", ImpOptions, Newfilename,output1file.c_str());

             if(SystemCommand(AnsiString(Cmd)) != -1)
             {
               LoadText(output1file,RichEditNewLIBList,"IMPDEF");
             }
             else {
               sprintf(data,"%s ----> IMPLIB Failed. - Illegal Command line.",Infilename); //, Newfilename);
               MessageBeep(MB_OK);
               MemoStatus->Lines->Add(data);
               break;
             } // else
       }
     } // if (system)
     else
     {
       MemoStatus->Lines->Add("Error processing file - Unable to create DEF file");
       break;
     }
     Done = findnext(&ffblk);
   } /* while */
  }
}

//---------------------------------------------------------------------------
bool __fastcall TFormDLLLibUtil::ShowFileInfo(AnsiString filename, TMemo* memo)
{
  char data[200];

    bool result = true;
    memo->Lines->Clear();
    AnsiString Version = "";
    AnsiString FileOS = "";
    AnsiString FileType = "";
    AnsiString FileFlags = "";
    AnsiString FileDescription = "";
    TFileInfo FileInfo;
    FileInfo.Init();

    AnsiString command = AnsiString(">GetFileVersionInfo(\"" +
                            filename + "\")");
    MemoStatus->Lines->Add(command);
    MemoStatus->Lines->Add("");


    if (GetFileInfo(filename,FileInfo) == -1)
    {
         sprintf(data,"Unable to get file information");
         MemoStatus->Lines->Add(data);
         MemoStatus->Lines->Add("");
         result = false;
    }
    else
    {
         sprintf(data,"GetFileVersionInfo() ----> %s Complete",filename);
         MemoStatus->Lines->Add(data);
         MemoStatus->Lines->Add("");
    }

    memo->Lines->Add("File Name:     " +  FileInfo.OriginalFilename);
    memo->Lines->Add("Internal Name: " +  FileInfo.InternalName);
    memo->Lines->Add("Product Name:  " +  FileInfo.ProductName);
    memo->Lines->Add("Company:       " +  FileInfo.CompanyName);
    memo->Lines->Add("File Type:     " +  FileInfo.FileType);
    memo->Lines->Add("File OS:       " +  FileInfo.FileOS);
    memo->Lines->Add("Build Type:    " +  FileInfo.FileType);
    memo->Lines->Add("File Version:  " +  FileInfo.Version);
    memo->Lines->Add("Description:   " +  FileInfo.FileDescription);
    memo->Lines->Add("Comments:      " +  FileInfo.Comments);
    memo->Lines->Add("Trademark:     " +  FileInfo.LegalTrademarks);
    memo->Lines->Add("Copyright:     " +  FileInfo.LegalCopyright);
    return result;
}

//---------------------------------------------------------------------------
void __fastcall TFormDLLLibUtil::ButtonExamineDLLClick(TObject *Sender)
{
  MemoStatus->Lines->Clear();
  MemoStatus->Lines->Add("Examine DLL...");
  MemoStatus->Lines->Add("");

  struct ffblk ffblk;
  char Newfilename[256];
  int Done;
  char Cmd[256];
  char drive[MAXDRIVE];
  char dir[MAXDIR];
  char file[MAXFILE];
  char ext[MAXEXT];
  char Filepath[MAXDRIVE+MAXDIR+MAXFILE+MAXEXT];

  char data[200];

 // let's make sure the file exists
  if (FileListBox1->FileName.Length() == 0)
  {
        MessageBeep(MB_OK);
        MemoStatus->Lines->Add("Please select a DLL file!");
        return;
  }

  if (!FileExists(FileListBox1->FileName))
  {
    ShowMessage(AnsiString("Please select a file, and try again. "));
    MessageBeep(MB_OK);
    return;
  }

  Process_Command_Line(FileListBox1->FileName,EditImpdefOptions->Text);

  if(strlen(Infilename) != 0)
  {
   drive[0] = dir[0] = file[0] = ext[0] = '\0';
   fnsplit(Infilename,drive,dir,file,ext);
   strcpy(Filepath, drive);
   strcat(Filepath, dir);
   Done = findfirst(Infilename,&ffblk,0);
   while(!Done)
   {
     strcpy(Infilename, Filepath);
     strcat(Infilename, ffblk.ff_name);
     if(!strchr(Infilename,'.')) /* Add default extension */
         strcat(Infilename,".DLL");

     /* Get File info */
     ShowFileInfo(FileListBox1->FileName,MemoInfoDLL);

     /* Build a new filename with .LIB extension */
     strcpy(Newfilename,EditFileLib->Text.c_str());


     AnsiString output1file = TempDir + "temp.def";
      if (FileExists(output1file))  DeleteFile(output1file.c_str());

     /* Run IMPDEF.exe on the input .DLL file */
     sprintf(Cmd,"IMPDEF %s \"%s\" \"%s\"", ImpOptions,output1file,Infilename);
     if(SystemCommand(AnsiString(Cmd)) != -1)
     { /* Successful .DEF file creation */
//       if(ProcessDefFile_Filter("temp.def")) /* Append underscores and equate to dll names */
//       {

         LoadText(output1file,MemoExportsDLL,"IMPDEF");

         Process_Command_Line(FileListBox1->FileName,"-em.");
         if (ShowDependencies(Infilename,ImpOptions,MemoDependDLL))
         { /* Successful */
//             LoadText("temp.def",MemoExportsDLL,"IMPDEF");
         }
//       }
     }
     else
     {
         sprintf(data,"%s ----> IMPDEF Failed. - Illegal command line.",Infilename);
         MessageBeep(MB_OK);
//         EditError->Text = data; //"Completed!
         MemoStatus->Lines->Add(data);
         break;
     }
     Done = findnext(&ffblk);
   } /* while */
 }
}
//---------------------------------------------------------------------------
void __fastcall TFormDLLLibUtil::SpeedButtonApplyMaskClick(TObject *Sender)
{
  FileListBox1->Mask = EditMask->Text;
}
//---------------------------------------------------------------------------

int __fastcall TFormDLLLibUtil::GetFileInfo(AnsiString &pFile, TFileInfo  &pFileInfo)
{
    AnsiString MyFileName = pFile;

    unsigned long Tmp, VersionInfoSize;
    VS_FIXEDFILEINFO *VersionInfo =0;
    DWORD VersionHandle;
    DWORD VersionSize;

    VersionInfoSize = GetFileVersionInfoSize( (LPTSTR) MyFileName.c_str(), &VersionHandle);
    VersionInfo     = (VS_FIXEDFILEINFO*)malloc(VersionInfoSize);

    if ((VersionInfoSize) && (VersionInfo))  // make sure we have version information
    {
        GetFileVersionInfo(MyFileName.c_str(), VersionHandle, VersionInfoSize, VersionInfo);

         /*Some needed items*/
//         char *buf;
         char *b = NULL;
         AnsiString BaseString;
         AnsiString temp;
         TLanguage_CodePage *Language_CodePage =0;
         unsigned int buflen = 0;

         // Get the Language ID & CodePage info*/
         VerQueryValue(VersionInfo,
              TEXT("\\VarFileInfo\\Translation"),
              (LPVOID*)&Language_CodePage, &buflen);

         // Establish a base string for getting the Version Info*/
         char LanguageID[8];
         sprintf(LanguageID,"%04x%04x",Language_CodePage->Language, Language_CodePage->CodePage);
         BaseString ="\\StringFileInfo\\" + AnsiString(LanguageID);

         /*Append the desired field from the version info to the base string, get
         the version info strings & display them*/
         temp = BaseString + "\\CompanyName";
         if (VerQueryValue(VersionInfo,
             TEXT(temp.c_str()),
             (void **) &b, &buflen))
             pFileInfo.CompanyName = b;
         temp =BaseString + "\\FileDescription";
         if (VerQueryValue(VersionInfo,
             TEXT(temp.c_str()),
             (void **) &b, &buflen))
             pFileInfo.FileDescription = AnsiString(b);
         temp =BaseString + "\\FileVersion";
         if (VerQueryValue(VersionInfo,
             TEXT(temp.c_str()),
             (void **) &b, &buflen))
             pFileInfo.FileVersion = b;
         temp =BaseString + "\\InternalName";
         if (VerQueryValue(VersionInfo,
             TEXT(temp.c_str()),
             (void **) &b, &buflen))
             pFileInfo.InternalName = b;
         temp =BaseString + "\\LegalCopyright";
         if (VerQueryValue(VersionInfo,
             TEXT(temp.c_str()),
             (void **) &b, &buflen))
             pFileInfo.LegalCopyright = b;
         temp =BaseString + "\\LegalTrademarks";
         if (VerQueryValue(VersionInfo,
             TEXT(temp.c_str()),
             (void **) &b, &buflen))
             pFileInfo.LegalTrademarks = b;
         temp =BaseString + "\\OriginalFilename";
         if (VerQueryValue(VersionInfo,
             TEXT(temp.c_str()),
             (void **) &b, &buflen))
             pFileInfo.OriginalFilename = b;
         temp =BaseString + "\\ProductName";
         if (VerQueryValue(VersionInfo,
             TEXT(temp.c_str()),
             (void **) &b, &buflen))
             pFileInfo.ProductName = b;
         temp =BaseString + "\\ProductVersion";
         if (VerQueryValue(VersionInfo,
             TEXT(temp.c_str()),
             (void **) &b, &buflen))
             pFileInfo.ProductVersion = b;
         temp =BaseString + "\\Comments";
         if (VerQueryValue(VersionInfo,
             TEXT(temp.c_str()),
             (void **) &b, &buflen))
             pFileInfo.Comments = b;

          TFixedFileInfo *MyFileInfo;
          unsigned int ii = sizeof(MyFileInfo);
          VerQueryValue(VersionInfo, "\\", (void **) &MyFileInfo, &ii);
          AnsiString MyString = MyFileInfo->MajorVersion;
          AnsiString TmpString = MyString + ".";
          MyString = MyFileInfo->MinorVersion;
          TmpString += MyString + ".";
          MyString = MyFileInfo->Release;
          TmpString += MyString + ".";
          MyString = MyFileInfo->Build;
          TmpString += MyString;
          pFileInfo.Version = TmpString;

            VS_FIXEDFILEINFO *MoreFileInfo;
            ii = sizeof(VS_FIXEDFILEINFO);
            VerQueryValue(VersionInfo, "\\", (void **) &MoreFileInfo, &ii);

            switch (MoreFileInfo->dwFileOS)
            {
               case VOS_NT	      : pFileInfo.FileOS = "WinNT"; break; // The file was designed for Windows NT.
               case VOS_DOS     : pFileInfo.FileOS = "DOS"; break;
               case VOS_OS216   : pFileInfo.FileOS = "OS2 16-bit"; break;
               case VOS_OS232   : pFileInfo.FileOS = "OS2 32-bit"; break;
               case VOS__WINDOWS16  : pFileInfo.FileOS = "Win16 API"; break; // The file was designed for the Win16 API.
               case VOS__PM16       : pFileInfo.FileOS = "PM16 API"; break;
               case VOS__PM32       : pFileInfo.FileOS = "PM32 API"; break;
               case VOS__WINDOWS32  : pFileInfo.FileOS = "Win32 API"; break; // The file was designed for the Win32 API.
               case VOS_DOS_WINDOWS16  : pFileInfo.FileOS = "Win16 API running on MS-DOS"; break;
               case VOS_DOS_WINDOWS32  : pFileInfo.FileOS = "Win32 API running on MS-DOS"; break;
               case VOS_OS216_PM16     : pFileInfo.FileOS = "OS2-16 / PM16"; break;
               case VOS_OS232_PM32     : pFileInfo.FileOS = "OS2-32 / PM32"; break;
               case VOS_NT_WINDOWS32   : pFileInfo.FileOS = "Win32 API running on NT"; break;
               default : pFileInfo.FileOS = "Unkown";
            }
            pFileInfo.FileType = "";
            switch (MoreFileInfo->dwFileType)
            {
               case VFT_APP	 :pFileInfo.FileType = "App";  break;//The file contains an application.
               case VFT_DLL	 :pFileInfo.FileType = "Dynamic-Link Lib (DLL)"; break;//The file contains a dynamic-link library (DLL).
               case VFT_DRV	 :pFileInfo.FileType = "Device Driver";//The file contains a device driver. If dwFileType is VFT_DRV, dwFileSubtype contains a more specific description of the driver.
                    switch (MoreFileInfo->dwFileSubtype)
                    {
                            case VFT2_DRV_PRINTER	:pFileInfo.FileType += " - Printer"; break;//The file contains a printer driver.
                            case VFT2_DRV_KEYBOARD	:pFileInfo.FileType += " - Keyboard"; break;//The file contains a keyboard driver.
                            case VFT2_DRV_LANGUAGE	:pFileInfo.FileType += " - Language"; break;//The file contains a language driver.
                            case VFT2_DRV_DISPLAY	:pFileInfo.FileType += " - Display"; break;//The file contains a display driver.
                            case VFT2_DRV_MOUSE	:pFileInfo.FileType += " - Mouse"; break;//The file contains a mouse driver.
                            case VFT2_DRV_NETWORK	:pFileInfo.FileType += " - Network"; break;//The file contains a network driver.
                            case VFT2_DRV_SYSTEM	:pFileInfo.FileType += " - System";break; //The file contains a system driver.
                            case VFT2_DRV_INSTALLABLE:pFileInfo.FileType += " - Installable"; break;//The file contains an installable driver.
                            case VFT2_DRV_SOUND	:pFileInfo.FileType += " - Sound"; break;//The file contains a sound driver.
                            default	:pFileInfo.FileType += " - unknown"; //The driver type is unknown by Windows.
                    }
                    break;
               case VFT_FONT   :pFileInfo.FileType = "Font";//	The file contains a font. If dwFileType is VFT_FONT, dwFileSubtype contains a more specific description of the font file.
                    switch (MoreFileInfo->dwFileSubtype)
                    {
                            case VFT2_FONT_RASTER	:pFileInfo.FileType += " - Raster"; break;//The file contains a printer driver.
                            case VFT2_FONT_VECTOR	:pFileInfo.FileType += " - Vector"; break;//The file contains a keyboard driver.
                            case VFT2_FONT_TRUETYPE	:pFileInfo.FileType += " - TrueType"; break;//The file contains a language driver.
                            default	:pFileInfo.FileType += " - unknown"; //The font type is unknown by Windows.
                    }
                    break;
               case VFT_VXD	 :pFileInfo.FileType = "Virtual Device (VXD)"; break;//The file contains a virtual device.
               case VFT_STATIC_LIB	 :pFileInfo.FileType = "Static-link Lib"; break;//The file contains a static-link library.
               default  :pFileInfo.FileType = "Unknown"; // to Windows.

           }

            switch (MoreFileInfo->dwFileFlags)
            {
               case VS_FF_DEBUG         : pFileInfo.FileFlags = "Debug Build"; break;// or compiled with debugging features enabled";
               case VS_FF_INFOINFERRED  : pFileInfo.FileFlags = "Contains inferred information"; break;// which may not be correct"; //Version structure created dynamically -- some of the members in this structure may be empty or incorrect. ";
               case VS_FF_PATCHED       : pFileInfo.FileFlags = "Patched file"; break;// file has been modified and is not identical to the original shipping file of the same version number.
               case VS_FF_PRERELEASE    : pFileInfo.FileFlags = "Prerelease Build"; break;//	The file is a development version, not a commercially released product.
               case VS_FF_PRIVATEBUILD  : pFileInfo.FileFlags = "Private Build"; break;//	The file was not built using standard release procedures. If this flag is set, the StringFileInfo structure should contain a PrivateBuild entry.
               case VS_FF_SPECIALBUILD  : pFileInfo.FileFlags = "Special Build"; break;//	The file was built by the original company using standard release procedures but is a variation of the normal file of the same version number. If this flag is set, the StringFileInfo structure should contain a SpecialBuild entry.
               default : pFileInfo.FileFlags = "Unknown";
            }

    //        delete [] MoreFileInfo;
    //    delete [] VersionInfo;
        free(VersionInfo);

        return 0;
    } // end if
    else
      return -1;  // unable to obtain information for this file
}  // end GetVersionInfo

//---------------------------------------------------------------------------

void __fastcall TFormDLLLibUtil::FormActivate(TObject *Sender)
{
  // let's get the System directory

  char system_dir[MAX_PATH + 1];
  system_dir[MAX_PATH] = '\0';
  GetSystemDirectory(system_dir, MAX_PATH);
  DirectoryListBox1->Directory = AnsiString(system_dir);

  char temp_dir[MAX_PATH + 1];
  temp_dir[MAX_PATH] = '\0';
  GetTempPath(MAX_PATH, temp_dir);

  TempDir = AnsiString(temp_dir);

  PageControl1Change(Sender);
}

//---------------------------------------------------------------------------
bool __fastcall TFormDLLLibUtil::LoadText(AnsiString filename, TRichEdit *richedit, AnsiString operation)
{
   char data[200];
   bool result = false;

   richedit->Lines->Clear();
   if (FileExists(filename))  // EditFilenameLIB->Text
   {
       richedit->Lines->LoadFromFile(filename);
       richedit->SelStart = 0;
       richedit->SelLength = 0;
       sprintf(data,"%s ----> %s Complete",operation,Infilename);
//       EditError->Text = data; //"Completed!";
       MemoStatus->Lines->Add(data);
       MemoStatus->Lines->Add("");
       result = true;
   }
   else
   {
       sprintf(data,"%s ----> %s Failed - Output file could not be found.",operation,Infilename);
       MessageBeep(MB_OK);
//       EditError->Text = data; //"Completed!";
       MemoStatus->Lines->Add(data);
   }
   return result;
}

//---------------------------------------------------------------------------
bool __fastcall TFormDLLLibUtil::LoadText(AnsiString filename, TMemo *memo, AnsiString operation)
{
   char data[200];
   bool result = false;
   memo->Lines->Clear();
   if (FileExists(filename))
   {
       memo->Lines->LoadFromFile(filename);
       memo->SelStart = 0;
       memo->SelLength = 0;
       sprintf(data,"%s ----> %s Complete",operation,Infilename);
//       EditError->Text = data; //"Completed!";
       MemoStatus->Lines->Add(data);
       MemoStatus->Lines->Add("");
       result = true;
   }
   else
   {
       sprintf(data,"%s ----> %s Failed - Output file could not be found.",operation,Infilename);
       MessageBeep(MB_OK);
//       EditError->Text = data; //"Completed!";
       MemoStatus->Lines->Add(data);
   }
   return result;
}



//---------------------------------------------------------------------------
void __fastcall TFormDLLLibUtil::ExamineLIB(AnsiString filename, TRichEdit *richedit)
{
  struct ffblk ffblk;
  char Newfilename[256];
  int Done;
  char Cmd[256];
  char drive[MAXDRIVE];
  char dir[MAXDIR];
  char file[MAXFILE];
  char ext[MAXEXT];
  char Filepath[MAXDRIVE+MAXDIR+MAXFILE+MAXEXT];

  char data[200];

 // let's make sure the file exists
  if (filename.Length() == 0)
  {
        MessageBeep(MB_OK);
        MemoStatus->Lines->Add("Please select a LIB file!");        
        return;
  }

/*
  // let's make sure the file exists
 if (!FileExists(filename))  // EditFilenameLIB->Text
 {
    ShowMessage(AnsiString("Please select a file, and try again. "));
    MessageBeep(MB_OK);
    return;
 }
*/

  Process_Command_Line(filename,EditImpdefOptions->Text);
  if(strlen(Infilename) != 0)
  {
   drive[0] = dir[0] = file[0] = ext[0] = '\0';
   fnsplit(Infilename,drive,dir,file,ext);
   strcpy(Filepath, drive);
   strcat(Filepath, dir);
   Done = findfirst(Infilename,&ffblk,0);
   while(!Done)
   {
     strcpy(Infilename, Filepath);
     strcat(Infilename, ffblk.ff_name);
     if(!strchr(Infilename,'.')) /* Add default extension */
       strcat(Infilename,".LIB");

     AnsiString outputfile = TempDir + "output.txt";
      if (FileExists(outputfile))  DeleteFile(outputfile.c_str());

     /* Run IMPDEF.exe on the input .DLL file */
     sprintf(Cmd,"TLIB /0 \"%s\", \"%s\"", Infilename,outputfile);
     if(SystemCommand(AnsiString(Cmd),true) != -1)
     { /* Successful .DEF file creation */
         LoadText(outputfile,richedit,"TLIB");
     }
     else
     {
       sprintf(data,"%s ----> TLIB Failed - Illegal command line.",Infilename);
       MessageBeep(MB_OK);
//       EditError->Text = data; //"Completed!";
       MemoStatus->Lines->Add(data);
       break;
     }
     Done = findnext(&ffblk);
   } /* while */
 }
}

//---------------------------------------------------------------------------

void __fastcall TFormDLLLibUtil::ButtonExamineLIBClick(TObject *Sender)
{
  MemoStatus->Lines->Clear();
  MemoStatus->Lines->Add("Examine LIB...");
  MemoStatus->Lines->Add("");

  RichEditLIBList->Lines->Clear();

  // check to see if the user thinks it's a Visual LIB

  if (CheckBoxVC->Checked)
  {
      AnsiString outputfile = TempDir + "temp_bor.lib";
      if (FileExists(outputfile))
        DeleteFile(outputfile.c_str());

      PerformComm2Omf(FileListBox1->FileName, outputfile.c_str(), "-v", RichEditLIBList);
  }
  else
       ExamineLIB(FileListBox1->FileName,RichEditLIBList);
}
//---------------------------------------------------------------------------

void __fastcall TFormDLLLibUtil::PageControl1Change(TObject *Sender)
{
  CheckBoxVC->Visible = false;
  if (PageControl1->ActivePage == TabSheetExamineLIB)
  {
        EditMask->Text = "*.lib";
        LabelType->Caption =  "(LIB)";
        CheckBoxVC->Visible = true;
        CheckBoxVC->Caption = "Check this if the file is a Visual OMF LIB";
        if (CheckBoxVC->Checked)
                LabelType->Caption =  "(Visual OMF File)";
        else
                LabelType->Caption =  "(Borland COFF File)";

  }
  else if (PageControl1->ActivePage == TabSheetExamineDLL)
  {
        EditMask->Text = "*.dll";
        LabelType->Caption =  "(DLL)";
  }
  else if (PageControl1->ActivePage == TabSheetExamineEXE)
  {
        EditMask->Text = "*.exe";
        LabelType->Caption =  "(EXE)";
  }
  else if (PageControl1->ActivePage == TabSheetCoff2OMF)
  {
        EditMask->Text = "*.lib";
        LabelType->Caption =  "(LIB)";
  }
  else
  {
        CheckBoxVC->Visible = true;
        EditMask->Text = "*.dll";
        CheckBoxVC->Caption = "Check this if the file is a Visual OMF DLL";
        if (CheckBoxVC->Checked)
                LabelType->Caption =  "(Visual OMF File)";
        else
                LabelType->Caption =  "(Borland COFF File)";
  }
  SpeedButtonApplyMaskClick(Sender);
}



//---------------------------------------------------------------------------



void __fastcall TFormDLLLibUtil::FindDialog1Find(TObject *Sender)
{
  int FoundAt, StartPos, ToEnd;
  // begin the search after the current selection 
  // if there is one 
  // otherwise, begin at the start of the text
  if (RichEditLIBList->SelLength)
    StartPos = RichEditLIBList->SelStart + RichEditLIBList->SelLength;
  else
    StartPos = 0;

  // ToEnd is the length from StartPos 
  // to the end of the text in the rich edit control
  ToEnd = RichEditLIBList->Text.Length() - StartPos;

  FoundAt = RichEditLIBList->FindText(FindDialog1->FindText, StartPos, ToEnd, TSearchTypes()<< stMatchCase);
  if (FoundAt != -1)
  {
    RichEditLIBList->SetFocus();
    RichEditLIBList->SelStart = FoundAt;
    RichEditLIBList->SelLength = FindDialog1->FindText.Length();
  }
}
//---------------------------------------------------------------------------

void __fastcall TFormDLLLibUtil::ButtonFindTextClick(TObject *Sender)
{
  FindDialog1->Position = Point(RichEditLIBList->Left + RichEditLIBList->Width, RichEditLIBList->Top);
  FindDialog1->Execute();
}


//---------------------------------------------------------------------------

bool  __fastcall TFormDLLLibUtil::ShowDependencies(AnsiString Filename, AnsiString Options, TMemo * memo)
{
    char Cmd[256];
     bool result = false;

//     AnsiString outputfile = TempDir + "output.txt";
     AnsiString outputfile = "output.txt";
      if (FileExists(outputfile))  DeleteFile(outputfile.c_str());

     sprintf(Cmd,"TDUMP %s \"%s\" \"%s\"", Options,Filename,outputfile.c_str());
     if(SystemCommand(AnsiString(Cmd),false) != -1)
     { /* Successful output file creation */
           result = LoadText(outputfile,memo,"TDUMP");
     }
     return result;
}


//---------------------------------------------------------------------------

void __fastcall TFormDLLLibUtil::ButtonExamineEXEClick(TObject *Sender)
{
  MemoStatus->Lines->Clear();
  MemoStatus->Lines->Add("Examine EXE...");
  MemoStatus->Lines->Add("");

  struct ffblk ffblk;
  char Newfilename[256];
  int Done;
  char Cmd[256];
  char drive[MAXDRIVE];
  char dir[MAXDIR];
  char file[MAXFILE];
  char ext[MAXEXT];
  char Filepath[MAXDRIVE+MAXDIR+MAXFILE+MAXEXT];

  char data[200];

  // let's make sure the file exists
  if (FileListBox1->FileName.Length() == 0)
  {
        MessageBeep(MB_OK);
        MemoStatus->Lines->Add("Please select an EXE file!");
        return;
  }

  if (!FileExists(FileListBox1->FileName))
  {
    ShowMessage(AnsiString("Please select a file, and try again. "));
    MessageBeep(MB_OK);
    return;
  }

  Process_Command_Line(FileListBox1->FileName,"-em.");

  if(strlen(Infilename) != 0)
  {
     drive[0] = dir[0] = file[0] = ext[0] = '\0';
     fnsplit(Infilename,drive,dir,file,ext);
     strcpy(Filepath, drive);
     strcat(Filepath, dir);
     Done = findfirst(Infilename,&ffblk,0);
     while(!Done)
     {
         strcpy(Infilename, Filepath);
         strcat(Infilename, ffblk.ff_name);
         if(!strchr(Infilename,'.')) /* Add default extension */
           strcat(Infilename,".DLL");

         /* Build a new filename with .LIB extension */
         strcpy(Newfilename,EditFileLib->Text.c_str());

         /* Get File info */
         ShowFileInfo(FileListBox1->FileName,MemoInfoEXE);

         if (!ShowDependencies(Infilename,ImpOptions,MemoDependEXE))
         {
           sprintf(data,"%s ----> TDUMP Failed. - Expected output file does not exist.",Infilename);
           MessageBeep(MB_OK);
           MemoStatus->Lines->Add(data);
         }
         Done = findnext(&ffblk);
     } /* while */
  } /* if */
}
//---------------------------------------------------------------------------

void __fastcall TFormDLLLibUtil::EditFileDllChange(TObject *Sender)
{
/*
   if ((PageControl1->ActivePage ==  TabSheetGenerateBCBLib) ||
       (PageControl1->ActivePage ==  TabSheetCoff2OMF) ||
       (PageControl1->ActivePage ==  TabSheetExamineDLL) ||
       (PageControl1->ActivePage ==  TabSheetExamineLIB))
   {
*/
       // if it's a .dll,
      char oldfilename[MAX_PATH];
      char newfilename[MAX_PATH];
      char drive[MAXDRIVE];
      char dir[MAXDIR];
      char file[MAXFILE];
      char ext[MAXEXT];
      char Filepath[MAXDRIVE+MAXDIR+MAXFILE+MAXEXT];

      sprintf(oldfilename,"%s",EditFileDll->Text.c_str());

      if(strlen(oldfilename) != 0)
      {
       drive[0] = dir[0] = file[0] = ext[0] = '\0';
       fnsplit(oldfilename,drive,dir,file,ext);
       strcpy(Filepath, drive);
       strcat(Filepath, dir);
       sprintf(newfilename,"%s%s_bor.lib",Filepath,file);

       EditFileLib->Text = newfilename;
       EditFileOmfLib->Text = newfilename;
      }
//  }
}
//---------------------------------------------------------------------------

void __fastcall TFormDLLLibUtil::CheckBoxVCClick(TObject *Sender)
{
        if (CheckBoxVC->Checked)
                LabelType->Caption =  "(Visual COFF File)";
        else
                LabelType->Caption =  "(Borland OMF File)";
}

//---------------------------------------------------------------------------

bool __fastcall TFormDLLLibUtil::PerformComm2Omf(
                                          AnsiString inputfilename,
                                          AnsiString outputfilename,
                                          AnsiString options,
                                          TRichEdit* richedit)
{
     char Cmd[256];

     /* Run IMPDEF.exe on the input .DLL file */

     sprintf(Cmd,"COFF2OMF %s \"%s\" \"%s\"",options.c_str(),inputfilename.c_str(),outputfilename.c_str());

     if(SystemCommand(AnsiString(Cmd),true) != -1)    /* Successful .DEF file creation */
     { /* Successful .DEF file creation */
         /* Run implib on def file to produce .lib output */
         ExamineLIB(outputfilename,richedit);
         return true;
     } // if (system)
     else
     {
       MemoStatus->Lines->Add("Error processing file - Unable to perform Coff2Omf");
       return false;
     }
}

//---------------------------------------------------------------------------

void __fastcall TFormDLLLibUtil::ButtonCoff2OmfClick(TObject *Sender)
{
  MemoStatus->Lines->Clear();
  MemoStatus->Lines->Add("VC COFF Lib -> BCB OMF Lib...");
  MemoStatus->Lines->Add("");

  struct ffblk ffblk;
  char Newfilename[256];
//  int Done;
  char Cmd[256];
  char drive[MAXDRIVE];
  char dir[MAXDIR];
  char file[MAXFILE];
  char ext[MAXEXT];
  char Filepath[MAXDRIVE+MAXDIR+MAXFILE+MAXEXT];

  char data[200];

  if (FileListBox1->FileName.Length() == 0)
  {
        MessageBeep(MB_OK);
        MemoStatus->Lines->Add("Please select a LIB file!");
        return;
  }

  Process_Command_Line(FileListBox1->FileName, EditCoff2OmfOptions->Text);

  if(strlen(Infilename) != 0)
  {
   drive[0] = dir[0] = file[0] = ext[0] = '\0';
   fnsplit(Infilename,drive,dir,file,ext);
   strcpy(Filepath, drive);
   strcat(Filepath, dir);
   findfirst(Infilename,&ffblk,0);
//   Done = findfirst(Infilename,&ffblk,0);
//   while(!Done)
//   {
     strcpy(Infilename, Filepath);
     strcat(Infilename, ffblk.ff_name);
     if(!strchr(Infilename,'.')) /* Add default extension */
       strcat(Infilename,".LIB");

//     SystemCommand(AnsiString(drive),false); // position into target drive
//     SystemCommand(AnsiString("cd " + AnsiString(Filepath)),false);  // position into target folder

     /* Build a new filename with .LIB extension */
     strcpy(Newfilename,EditTarget2->Text.c_str());
     strcat(Newfilename,EditFileOmfLib->Text.c_str());

     PerformComm2Omf(Infilename, Newfilename, ImpOptions, RichEditCoff2Omf);


//     Done = findnext(&ffblk);
//   } /* while */
  }
}
//---------------------------------------------------------------------------

void __fastcall TFormDLLLibUtil::Button2Click(TObject *Sender)
{
  FindDialog1->Position = Point(RichEditNewLIBList->Left + RichEditNewLIBList->Width, RichEditNewLIBList->Top);
  FindDialog1->Execute();

}
//---------------------------------------------------------------------------

void __fastcall TFormDLLLibUtil::Button4Click(TObject *Sender)
{
  FindDialog1->Position = Point(RichEditCoff2Omf->Left + RichEditCoff2Omf->Width, RichEditCoff2Omf->Top);
  FindDialog1->Execute();
}
//---------------------------------------------------------------------------

void __fastcall TFormDLLLibUtil::ButtonTarget1Click(TObject *Sender)
{
  SaveDialog1->FileName = EditTarget1->Text + EditFileLib->Text;
  if (SaveDialog1->Execute())
  {
        EditTarget1->Text = ExtractFilePath(SaveDialog1->FileName);
        EditTarget2->Text = ExtractFilePath(SaveDialog1->FileName);
        EditFileLib->Text = ExtractFileName(SaveDialog1->FileName);
  }
}
//---------------------------------------------------------------------------

void __fastcall TFormDLLLibUtil::ButtonTarget2Click(TObject *Sender)
{
  SaveDialog1->FileName = EditTarget2->Text + EditFileOmfLib->Text;
  if (SaveDialog1->Execute())
  {
        EditTarget1->Text = ExtractFilePath(SaveDialog1->FileName);
        EditTarget2->Text = ExtractFilePath(SaveDialog1->FileName);
        EditFileOmfLib->Text = ExtractFileName(SaveDialog1->FileName);
  }
}
//---------------------------------------------------------------------------

void __fastcall TFormDLLLibUtil::EditMaskKeyDown(TObject *Sender,
      WORD &Key, TShiftState Shift)
{
        // look for return key
        if (Key == 13)
            SpeedButtonApplyMaskClick(Sender);
}
//---------------------------------------------------------------------------

