/*---------------------------------------------------------------------------
  DllLibUtilForm.h
        C++Builder Developer's Guide
        Chapter 14 - DLL LIB Util
        (c) Paul Gustavson, 2002
        Used to examine DLL and LIB files and create BCB compliant LIBs
---------------------------------------------------------------------------*/
#ifndef DllLibUtilFormH
#define DllLibUtilFormH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\Dialogs.hpp>
#include <vcl\ExtCtrls.hpp>
#include <ComCtrls.hpp>
#include <FileCtrl.hpp>
#include <Buttons.hpp>
//---------------------------------------------------------------------------
struct  TFixedFileInfo
{
    int Signature;
    int StructVersion;
    short MinorVersion;
    short MajorVersion;
    short Build;
    short Release;
};

struct TLanguage_CodePage
{
  WORD Language;
  WORD CodePage;
};


struct TFileInfo
{
    AnsiString CompanyName;
    AnsiString FileDescription;
    AnsiString FileVersion;
    AnsiString InternalName;
    AnsiString LegalCopyright;
    AnsiString LegalTrademarks;
    AnsiString OriginalFilename;
    AnsiString ProductName;
    AnsiString ProductVersion;
    AnsiString Comments;
//--
    AnsiString Version;
    AnsiString FileOS;
    AnsiString FileType;
    AnsiString FileFlags;
    void Init();
};

class TFormDLLLibUtil : public TForm
{
__published:	// IDE-managed Components
	TOpenDialog *OpenDialog1;
        TPanel *Panel3;
        TDirectoryListBox *DirectoryListBox1;
        TFileListBox *FileListBox1;
        TSplitter *Splitter1;
        TPanel *Panel4;
        TPageControl *PageControl1;
        TTabSheet *TabSheetGenerateBCBLib;
        TLabel *Label8;
        TPanel *Panel2;
        TTabSheet *TabSheetExamineDLL;
        TSplitter *Splitter2;
        TPanel *Panel5;
        TLabel *Label4;
        TLabel *LabelType;
        TEdit *EditFileDll;
        TPanel *Panel6;
        TEdit *EditMask;
        TLabel *Label10;
        TSpeedButton *SpeedButtonApplyMask;
        TPanel *Panel1;
        TTabSheet *TabSheetExamineLIB;
        TPanel *Panel7;
        TDriveComboBox *DriveComboBox1;
        TFindDialog *FindDialog1;
        TRichEdit *RichEditLIBList;
        TPanel *Panel8;
        TButton *ButtonFindText;
        TPanel *Panel9;
        TButton *ButtonExamineLIB;
        TTabSheet *TabSheetExamineEXE;
        TRichEdit *RichEditNewLIBList;
        TPanel *Panel10;
        TLabel *Label5;
        TLabel *Label2;
        TEdit *EditFileLib;
        TButton *ButtonImpIt;
        TEdit *EditImplibOptions;
        TLabel *Label3;
        TPanel *Panel11;
        TButton *Button2;
        TLabel *Label1;
        TLabel *Label36;
        TCheckBox *CheckBoxVC;
        TTabSheet *TabSheetCoff2OMF;
        TPanel *Panel12;
        TLabel *Label37;
        TLabel *Label38;
        TLabel *Label39;
        TLabel *Label41;
        TEdit *EditFileOmfLib;
        TButton *ButtonCoff2Omf;
        TEdit *EditCoff2OmfOptions;
        TPanel *Panel13;
        TButton *Button4;
        TRichEdit *RichEditCoff2Omf;
        TPanel *Panel14;
        TButton *ButtonExamineEXE;
        TPanel *Panel15;
        TLabel *Label6;
        TMemo *MemoInfoEXE;
        TPanel *Panel16;
        TLabel *Label35;
        TMemo *MemoDependEXE;
        TSplitter *Splitter3;
        TPanel *Panel17;
        TLabel *Label9;
        TEdit *EditImpdefOptions;
        TButton *ButtonExamineDLL;
        TPanel *Panel20;
        TPanel *Panel18;
        TLabel *Label42;
        TMemo *MemoInfoDLL;
        TSplitter *Splitter4;
        TPanel *Panel19;
        TLabel *Label40;
        TMemo *MemoDependDLL;
        TPanel *Panel21;
        TLabel *Label22;
        TMemo *MemoExportsDLL;
        TSplitter *Splitter5;
        TLabel *Label11;
        TMemo *MemoStatus;
        TSplitter *Splitter6;
        TEdit *EditTarget1;
        TLabel *Label7;
        TButton *ButtonTarget1;
        TSaveDialog *SaveDialog1;
        TEdit *EditTarget2;
        TLabel *Label12;
        TButton *ButtonTarget2;
	void __fastcall ButtonImpItClick(TObject *Sender);
        void __fastcall ButtonExamineDLLClick(TObject *Sender);
        void __fastcall SpeedButtonApplyMaskClick(TObject *Sender);
        int __fastcall GetFileInfo(AnsiString &pFile,TFileInfo  &pFileInfo);
        void __fastcall FormActivate(TObject *Sender);
        void __fastcall ButtonExamineLIBClick(TObject *Sender);
        void __fastcall PageControl1Change(TObject *Sender);
        void __fastcall FindDialog1Find(TObject *Sender);
        void __fastcall ButtonFindTextClick(TObject *Sender);
        void __fastcall ButtonExamineEXEClick(TObject *Sender);
        void __fastcall EditFileDllChange(TObject *Sender);
        void __fastcall CheckBoxVCClick(TObject *Sender);
        void __fastcall ButtonCoff2OmfClick(TObject *Sender);
        void __fastcall Button2Click(TObject *Sender);
        void __fastcall Button4Click(TObject *Sender);
        void __fastcall ButtonTarget1Click(TObject *Sender);
        void __fastcall ButtonTarget2Click(TObject *Sender);
        void __fastcall EditMaskKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
private:	// User declarations
    AnsiString TempDir;
    char ImpOptions[64];
    char Infilename[MAX_PATH];
    void Process_Command_Line(AnsiString file, AnsiString options);
    int ConvertDef(char *in_filename, char *out_filename);
    int ProcessDefFile_Filter(char *Filename);
public:		// User declarations
    bool __fastcall SystemCommand(AnsiString command, bool hidden = true);
    void __fastcall ExamineLIB(AnsiString filename, TRichEdit *richedit);
    bool __fastcall ShowDependencies(AnsiString filename, AnsiString Options, TMemo * memo);
    bool __fastcall ShowFileInfo(AnsiString filename, TMemo* memo);
    bool IsWindowsNT();
    bool __fastcall LoadText(AnsiString filename, TRichEdit *richedit, AnsiString operation);
    bool __fastcall LoadText(AnsiString filename, TMemo *memo, AnsiString operation);
    bool __fastcall PerformComm2Omf(AnsiString inputfilename,
                                    AnsiString outputfilename,
                                    AnsiString options,
                                    TRichEdit* richedit);

    __fastcall TFormDLLLibUtil(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern TFormDLLLibUtil *FormDLLLibUtil;
//---------------------------------------------------------------------------
#endif
