/*---------------------------------------------------------------------------
  MMTimerForm.cpp
        C++Builder Developer's Guide
        Chapter 14 - Multimedia Timer Example
        (c) Paul Gustavson, 2002
        Used to Compare MMedia API to TTimer
---------------------------------------------------------------------------*/
#include <vcl.h>
#pragma hdrstop

#include "MMTimerForm.h"
#include <mmsystem.h>
#include <time.h>

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"


TForm1 *Form1;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
    MMTimerID = 0;
    MMlasttime = 0;
    STANlasttime = 0;
    clicksMM = 0;
    clicksST = 0;
    // define custom messages
    WM_HANDLE_MMTIMER = RegisterWindowMessage("WM_HANDLE_MMTIMER");
    WindowProc = MyWndProc;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MyWndProc(Messages::TMessage &Message)
{
  // If the window receives a notification message then
  // pass it to the appropriate windows messaging function. Otherwise 
  // let the default processing for the message take place.

  if (Message.Msg == WM_HANDLE_MMTIMER)
        HandleMMTimer();
  else
        WndProc(Message) ;
}

//---------------------------------------------------------------------------

void __fastcall TForm1::Timer1Timer(TObject *Sender)   // TTimer handler code
{

        unsigned int clocktime = clock();
        EditStandardTimer->Text = AnsiString(clocktime - STANlasttime);
        STANlasttime = clocktime;
        clicksST++;
        EditClicksST->Text = clicksST;
}


//---------------------------------------------------------------------------

void __fastcall TForm1::HandleMMTimer()
{
        unsigned int clocktime = clock();
        Form1->EditMMTimer->Text = AnsiString(clocktime - Form1->MMlasttime);
        Form1->MMlasttime = clocktime;
        Form1->clicksMM++;
        Form1->EditClicksMM->Text = Form1->clicksMM;
}

//---------------------------------------------------------------------------

void CALLBACK TForm1::TimerProc(unsigned int uID, unsigned int uMsg, DWORD dwUser,
    DWORD dw1, DWORD dw2)
{
    if (!Form1->CheckBoxPostMessage->Checked)
            Form1->HandleMMTimer();
    else
        PostMessage(Form1->Handle, Form1->WM_HANDLE_MMTIMER,NULL,NULL); // improves NT/XP performance
}

//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButtonMMTimerClick(TObject *Sender)
{
 if (SpeedButtonMMTimer->Down)
 {
    int Interval = EditInterval->Text.ToIntDef(0);
    int Resolution = EditResolution->Text.ToIntDef(0); // the greatest possible accuracy is 0
    if (Timer1->Interval > 0)
    {
            MMlasttime = clock();
            MMTimerID =  timeSetEvent(Interval, Resolution, TimerProc,NULL, TIME_PERIODIC);
    }
    clicksMM = 0;
 }
 else
 {
    timeKillEvent(MMTimerID);
    MMTimerID = 0;
 }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButtonStandardTimerClick(TObject *Sender)
{
   if (SpeedButtonStandardTimer->Down)
   {
        Timer1->Interval = EditInterval->Text.ToIntDef(0);
        STANlasttime = clock();
        if (Timer1->Interval > 0)
                Timer1->Enabled = true;
        clicksST = 0;
   }
   else
   {
        Timer1->Enabled = false;
   }

}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
    if (MMTimerID) timeKillEvent(MMTimerID);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonStartAllClick(TObject *Sender)
{
    SpeedButtonStandardTimer->Down = true;
    SpeedButtonMMTimer->Down = true;

        SpeedButtonStandardTimerClick(Sender);
        SpeedButtonMMTimerClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonStopAllClick(TObject *Sender)
{
  // stop all the timers
    SpeedButtonStandardTimer->Down = false;
    SpeedButtonMMTimer->Down = false;

        SpeedButtonStandardTimerClick(Sender);
        SpeedButtonMMTimerClick(Sender);
}
//---------------------------------------------------------------------------

