/*---------------------------------------------------------------------------
  NetworkInfoForm.cpp
        C++Builder Developer's Guide
        Chapter 14 - Network Info Example
        (c) Paul Gustavson, 2002
        ses WinSock Calls to provide Network Status
---------------------------------------------------------------------------*/
#include <vcl.h>
#include <winsock.h>
#include <stdio.h>
#pragma hdrstop

#  define  UC(b)  (((int)b)&0xff)

#include "NetworkInfoForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFormWinSockIPInfo *FormWinSockIPInfo;
//---------------------------------------------------------------------------
__fastcall TFormWinSockIPInfo::TFormWinSockIPInfo(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TFormWinSockIPInfo::ButtonGetInfoClick(TObject *Sender)
{
    WSADATA             localWSA;
    if (WSAStartup ((MAKEWORD(1,1)), &localWSA) != 0)
    {
       MessageBox (NULL, "Sorry - Unable to load Windows Sockets - "
                         "Please close other applications and try again.",
                         "UDP Network Interface", MB_OK | MB_ICONASTERISK);
       WSACleanup ();
       return;
    }
    LabelMaxSize->Caption = AnsiString(localWSA.iMaxUdpDg) + " bytes";
    LabelSockets->Caption = localWSA.iMaxSockets;
    LabelVersion->Caption = AnsiString(localWSA.szDescription);

    char szHost[MAX_PATH];  // should be big enough.
    memset(szHost, 0, MAX_PATH);  // clear it
    gethostname(szHost, MAX_PATH);

    struct hostent *hp;
    hp = gethostbyname(szHost);
    if( ! hp )
           return;
    LabelName->Caption = hp->h_name;

    char szIpAddress[96];
    sprintf(szIpAddress, "%d.%d.%d.%d",
                          UC(hp->h_addr[0]), UC(hp->h_addr[1]),
                          UC(hp->h_addr[2]), UC(hp->h_addr[3]));
//    sprintf(szIpAddress, "%d.%d.%d.%d",
//                          (hp->h_addr[0]), (hp->h_addr[1]),
//                          (hp->h_addr[2]), (hp->h_addr[3]));
    LabelIPAddress->Caption = AnsiString(szIpAddress);

    // clean-up
    WSACleanup ();
}
//---------------------------------------------------------------------------

