/*---------------------------------------------------------------------------
  ShellForm.cpp
        C++Builder Developer's Guide
        Chapter 14 - Shell Example
        (c) Paul Gustavson, 2002
        Uses Shell Library Calls
---------------------------------------------------------------------------*/
#include <vcl.h>
//#include <shlobj.h>
#pragma hdrstop
#include <stdio.h>

#include "ShellForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonBrowserClick(TObject *Sender)
{
  if (EditURL->Text.Length() > 0)
  {
    if (! ShellExecute(NULL, "open", EditURL->Text.c_str(),
                        NULL, NULL, SW_SHOW))
    {
        char data[100];
        sprintf(data,"Could not run browser with URL '%s'",EditURL->Text);
        MessageBox(NULL,data,"Operation Error!",MB_OK);
    }
  }
  else
    MessageBeep(MB_OK);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormActivate(TObject *Sender)
{
  // let's get the System directory

  char win_dir[MAX_PATH + 1];
  win_dir[MAX_PATH] = '\0';
  GetWindowsDirectory(win_dir, MAX_PATH);
  DirectoryListBoxSource->Directory = AnsiString(win_dir);

}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
	// OpenDialog
      	//OpenDialog1->FileName = "";
        if (OpenDialog1->Execute())
    	{
          EditFile->Text = OpenDialog1->FileName;
        }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonLaunchAppClick(TObject *Sender)
{
  char temp[MAX_PATH];
  char params[MAX_PATH];
  sprintf(temp,"%s\0",EditFile->Text.c_str());
  sprintf(params,"%s\0",EditParams->Text.c_str());

  // Select the program and how it will be run.
  SHELLEXECUTEINFO execinfo ;
  memset (&execinfo, 0, sizeof (execinfo)) ;
  execinfo.cbSize = sizeof (execinfo) ;
  execinfo.lpVerb = "open" ;
  execinfo.lpFile = temp;
  execinfo.lpParameters = params;
  execinfo.fMask = SEE_MASK_NOCLOSEPROCESS ;
  execinfo.nShow = SW_SHOWDEFAULT ;

  // Run the program.
  if (! ShellExecuteEx (&execinfo))
  {
    char data[100];
    sprintf(data,"Could not run program '%s'",EditFile->Text.c_str());
    MessageBox(NULL,data,"Operation Error!",MB_OK);
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonCopyDirClick(TObject *Sender)
{
    // initialize
    MemoFilesToMove->Clear();
    ListBoxFilesToMove->Clear();
    LabelMoveResults->Caption = "";

    //Declare the SHFILEOPSTRUCT structure to fill in information for use
    //of SHFileOperation function.
    SHFILEOPSTRUCT op;

    //Clear out any thing within the structure for safe keeping
    ZeroMemory(&op, sizeof(op));

    char source[MAX_PATH];
    memset(source, 0, MAX_PATH);
    char dest[MAX_PATH];
    memset(dest, 0, MAX_PATH);

    op.hwnd = Handle;     //This is a handle to the main window, used 0 for ours
    op.wFunc= FO_COPY;    //Tell SHFileOperation to COPY files
    sprintf(source,"%s\0",LabelSourceDir->Caption.c_str());  //Source directory
    op.pFrom = source;
    sprintf(dest,"%s\0",LabelTargetDir->Caption.c_str());   //Destination directory
    op.pTo = dest;
    op.fFlags= FOF_NOCONFIRMATION + FOF_ALLOWUNDO;

    TCursor Save_Cursor = Screen->Cursor;

    Screen->Cursor = crHourGlass;    // Show hourglass cursor

    try
    {
        if (SHFileOperation(&op) == 0)  // so far looks good
        {
            if (op.fAnyOperationsAborted)
               LabelMoveResults->Caption = "Copy process halted!";
            else
               LabelMoveResults->Caption = "Copy operation successful!";
        }
        else  // had a problem
            LabelMoveResults->Caption = "Copy process unsuccessful.";
    }
    __finally
    {
      Screen->Cursor = Save_Cursor; // always restore the cursor
    }
    DirectoryListBoxTarget->Update();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PageControl1Change(TObject *Sender)
{
        if (PageControl1->ActivePage == TabSheetShellMove)
        {
                FileListBoxSource->MultiSelect = true;
                EditMask->Text = "*.*";
                SpeedButton1Click(Sender);
        }
        else if (PageControl1->ActivePage == TabSheetShellExecute)
        {
                FileListBoxSource->MultiSelect = false;
                EditMask->Text = "*.exe";
                SpeedButton1Click(Sender);
        }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton1Click(TObject *Sender)
{
  FileListBoxSource->Mask = EditMask->Text;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton2Click(TObject *Sender)
{
  FileListBoxTarget->Mask = EditMaskTarget->Text;        
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
    // initialize
    MemoFilesToMove->Clear();
    ListBoxFilesToMove->Clear();
    LabelMoveResults->Caption = "";

    // copy selected files to listbox
    FileListBoxSource->CopySelection(ListBoxFilesToMove);

    // now copy to Memo (with file names)
    for (int i= 0; i < ListBoxFilesToMove->Items->Count; i++)
    {
        AnsiString fullpath =  LabelSourceDir->Caption + "\\" +
                ListBoxFilesToMove->Items->Strings[i] + '\0';
        MemoFilesToMove->Lines->Add(fullpath);
    }

    //Declare the SHFILEOPSTRUCT structure to fill in information for use
    //of SHFileOperation function.
    SHFILEOPSTRUCT op;
    ZeroMemory(&op, sizeof(op));      //Clear out any thing within the structure

    int length1 = MemoFilesToMove->Text.Length()+1;
    char *source = new char[length1];
    memset(source, 0, length1);

    int length = 0;
    for (int i= 0; i < ListBoxFilesToMove->Items->Count; i++)
    {
        if (i > 0)
        {
            char* current = new char[length];
            memcpy(current,source,length);

            // make it comma delimmited
            sprintf(source,"%s,%s",current,
                    MemoFilesToMove->Lines->Strings[i].c_str());

        }
        else
        {
            sprintf(source,"%s",MemoFilesToMove->Lines->Strings[i].c_str());
        }
        length += MemoFilesToMove->Lines->Strings[i].Length() + 1;
    }

    // turn commas into \0
    for (int i=0; i < length; i++)
        if (source[i] == ',')
                source[i] = '\0';
    strcat(source,"\0"); // add the full null terminator

    char dest[MAX_PATH];
    memset(dest, 0, MAX_PATH);
    sprintf(dest,"%s\0",LabelTargetDir->Caption.c_str());   //Destination dir

    op.hwnd = Handle;     //This is a handle to the main window, used 0 for ours
    op.wFunc= FO_COPY;    //Tell SHFileOperation to COPY files
    op.pFrom = source;
    op.pTo = dest;
    if (ListBoxFilesToMove->Items->Count > 1)
         op.fFlags= FOF_MULTIDESTFILES + FOF_NOCONFIRMATION +
                    FOF_ALLOWUNDO + FOF_RENAMEONCOLLISION;
    else // only one file
         op.fFlags= FOF_NOCONFIRMATION +
                    FOF_ALLOWUNDO + FOF_RENAMEONCOLLISION;

    TCursor Save_Cursor = Screen->Cursor;
    Screen->Cursor = crHourGlass;    // Show hourglass cursor
    try
    {
        if (SHFileOperation(&op) == 0)  // so far looks good
        {
            if (op.fAnyOperationsAborted)
               LabelMoveResults->Caption = "Copy process halted!";
            else
               LabelMoveResults->Caption = "Copy operation successful!";
        }
        else  // had a problem
            LabelMoveResults->Caption = "Copy process unsuccessful.";
    }
    __finally
    {
      Screen->Cursor = Save_Cursor; // always restore the cursor
    }
    // to see files, we need to rebuld the drive list.
    AnsiString temp = DirectoryListBoxTarget->Directory;
    DirectoryListBoxTarget->Directory = "c:\\";
    DirectoryListBoxTarget->Directory = temp;
    DirectoryListBoxTarget->Update();

    // clean up
    delete[] source;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonSendToRecycleBinClick(TObject *Sender)
{
    // initialize
    MemoFilesToMove->Clear();
    ListBoxFilesToMove->Clear();
    LabelMoveResults->Caption = "";

    AnsiString DelDir;    //Our directory handle
    int index = DirectoryListBoxSource->ItemIndex; //keep track of index

    //Get the CURRENTLY selected item in the list...
    DelDir = DirectoryListBoxSource->Directory;

    AnsiString alert;
    alert =  "Are you sure you wish to remove the folder \"" + DelDir + "\" "
             "and all its contents?";

    int response =
        Application->MessageBox(alert.c_str(), "Remove Folder", MB_YESNO);

    if (response == ID_NO)
        return; // get out

    DelDir.SetLength(DelDir.Length() + 1);
           DelDir[DelDir.Length()] = '\0';
    DelDir.SetLength(DelDir.Length() + 1);
           DelDir[DelDir.Length()] = '\0';

    // before we send the folder and it's contents to the recycle
    // bin, lets drop back one folder. This keeps from having a sharing
    // violation
    DirectoryListBoxSource->Directory = DirectoryListBoxSource->Items->Strings[index-1];
    DirectoryListBoxSource->Update();

    SHFILEOPSTRUCT op;  //Declare structure variable

    //Clear out memory
    ZeroMemory(&op, sizeof(op));
    //Set up structure for SHFIleOperation for source and destination...
    op.hwnd = 0;
    op.wFunc= FO_DELETE;     //Delete files flag
    op.pFrom = DelDir.c_str();
    op.fFlags=FOF_ALLOWUNDO;
    int copy_done = SHFileOperation(&op);

    if (copy_done == 0)
    {
      if (op.fAnyOperationsAborted)
         LabelMoveResults->Caption = "You have halted the removal of the folder. Some files may"
                     "have been moved to the Recycle Bin. Go to Recycle Bin"
                     "to restore those files.";
      else
         LabelMoveResults->Caption  = "Folder removal successful!";
    }
    else
       LabelMoveResults->Caption  = "Folder removal failed.";

    //Update DirectoryListbox
    DirectoryListBoxSource->Update();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonEmptyRecycleBinClick(TObject *Sender)
{

    //Now, delete all entries in Recycle Bin. Confirm user too!
    SHEmptyRecycleBin(0,0,SHERB_NOPROGRESSUI);


}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonQueryRecycleBinClick(TObject *Sender)
{
    //Declare structure variable
    SHQUERYRBINFO RCinfo;
    RCinfo.cbSize = sizeof(SHQUERYRBINFO);

    //Total size of objects in Recycle Bin expressed in bytes
    //We'll set it to Zero for now
    RCinfo.i64Size = 0;
    //Total count of items in the Recycle Bin
    RCinfo.i64NumItems  = 0;

    // Ask the Recycle Bin how many items and put the value into the structure.
//    if(S_OK !=SHQueryRecycleBin("C:\\", &RCinfo) )
    // in NT you can't pass null for the directory - it will fail
    char folder[MAX_PATH];
    memset(folder,0,MAX_PATH);
//    sprintf(folder,"%s\\\0",DirectoryListBoxSource->Directory.c_str());
    sprintf(folder,"%s","c\0");
    if(S_OK !=SHQueryRecycleBin(folder, &RCinfo) )
    {
     LabelMoveResults->Caption = "Error!";
     return;
    }

    int one = RCinfo.i64NumItems;
    int two = RCinfo.i64Size;
    LabelNumItems->Caption = one;
    LabelSize->Caption = two;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
/*
    BROWSEINFO BrowsingInfo;
    char FolderName[MAX_PATH];
    LPITEMIDLIST ItemID;

    AnsiString Directory;

    memset(&BrowsingInfo, 0, sizeof(BROWSEINFO));
    BrowsingInfo.hwndOwner      = Handle;
    BrowsingInfo.pszDisplayName = FolderName;
    BrowsingInfo.lpszTitle      = "Choose your folder:";
    ItemID = SHBrowseForFolder(&BrowsingInfo);
    if(ItemID) {
        char DirPath[MAX_PATH]="";
        SHGetPathFromIDList(ItemID, DirPath);
        // path is now in DirPath
    Directory = DirPath;
    }

    LabelSourceDir->Caption = Directory;
*/
}
//---------------------------------------------------------------------------

