/*---------------------------------------------------------------------------
  WinManUtilForm.h
        C++Builder Developer's Guide
        Chapter 14 - Windows Management Utility
        (c) Paul Gustavson, 2002
        Enumerates and Manages External Windows
---------------------------------------------------------------------------*/
#ifndef WinManUtilFormH
#define WinManUtilFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
#include <ComCtrls.hpp>


enum EAlign	{AERROR = -1, NONE = 0, TOP,BOTTOM,LEFT,RIGHT,CLIENT};	// alignment enumeration list
const int MOVEUP = 0;
const int MOVEDOWN = 1;
const int MOVELEFT = 2;
const int MOVERIGHT = 3;

const int STRETCHVERT = 0;
const int STRETCHHORZ = 1;
const int SHRINKVERT = 2;
const int SHRINKHORZ = 3;
/*
const int WM_MOVE_A_WINDOW = WM_USER + 2002;
const int WM_STRETCH_A_WINDOW = WM_USER + 2003;
*/
const unsigned int WINHANDLE = 1;
const unsigned int PROCESSID = 2;
const unsigned int DEVICECONTEXT = 3;
const unsigned int INSTANCEHANDLE = 4;

const unsigned int PROCESS = 1;
const unsigned int INSTANCE = 2;
const unsigned int WINDOW = 3;

class TAppInfo
{
 public:
   HWND                 WindowHandle;
   int                  InstanceHandle;
   HDC                  DeviceContext;
   unsigned long        ProcessID;
   AnsiString           Title;
   AnsiString           Class;
//   RECT                 Rect;
   HWND                 ParentWindowHandle;
   TAppInfo()
   {
      WindowHandle    = 0;
      InstanceHandle = 0;
      DeviceContext = NULL;
      ProcessID = 0;
      Title     = "";
      Class     = "";
   };
};

typedef TAppInfo* PAppInfo;

//---------------------------------------------------------------------------
class TFormWinMan : public TForm
{
__published:	// IDE-managed Components
        TPageControl *PageControl1;
        TTabSheet *TabSheet1;
        TTabSheet *TabSheet2;
        TListBox *ListBoxApps;
        TButton *ButtonAddApp;
        TButton *ButtonLaunchApp;
        TLabel *Label2;
        TEdit *EditFullFileName;
        TTreeView *TreeView1;
        TButton *ButtonEnumWindows;
        TLabel *Label6;
        TRadioButton *RadioButtonProcess;
        TRadioButton *RadioButtonInstance;
        TRadioButton *RadioButtonWindow;
        TRadioButton *RadioButtonNone;
        TCheckBox *CheckBoxIncludeParent;
        TCheckBox *CheckBoxProcessRootNode;
        TCheckBox *CheckBoxIgnoreWindowsNoTitles;
        TSplitter *Splitter1;
        TPanel *Panel9;
        TOpenDialog *OpenDialog1;
        TTimer *TimerGetHandle;
        TPanel *PanelFocus;
        TButton *ButtonBringToFocus;
        TCheckBox *CheckBoxTop;
        TPanel *Panel7;
        TLabel *Label4;
        TLabel *Label1;
        TEdit *EditTitle;
        TEdit *EditClass;
        TButton *ButtonChangeTitle;
        TPanel *Panel5;
        TPanel *Panel8;
        TLabel *Label5;
        TLabel *Label7;
        TLabel *Label12;
        TLabel *Label3;
        TEdit *EditIHandle;
        TEdit *EditWHandle;
        TEdit *EditPWHandle;
        TEdit *EditProcessID;
        TPanel *Panel10;
        TButton *ButtonMinimize;
        TButton *ButtonMaximize;
        TButton *ButtonHide;
        TButton *ButtonClose;
        TButton *ButtonShowNormal;
        TButton *ButtonMinimize2;
        TPanel *Panel11;
        TPanel *Panel1;
        TLabel *Label13;
        TButton *ButtonMoveLeft;
        TButton *ButtonMoveUp;
        TButton *ButtonMoveRight;
        TButton *ButtonMoveDown;
        TPanel *Panel2;
        TLabel *Label16;
        TLabel *Label15;
        TButton *ButtonStretchLeft;
        TButton *ButtonStretchDown;
        TButton *ButtonStretchRight;
        TButton *ButtonStretchUp;
        TPanel *Panel3;
        TLabel *Label19;
        TButton *ButtonAlignTop;
        TButton *ButtonAlignClient;
        TButton *ButtonAlignRight;
        TButton *ButtonAlignBottom;
        TButton *ButtonAlignLeft;
        TPanel *Panel13;
        TPanel *Panel6;
        TLabel *Label8;
        TLabel *Label10;
        TLabel *Label11;
        TLabel *Label9;
        TEdit *EditLeft;
        TEdit *EditWidth;
        TEdit *EditHeight;
        TEdit *EditTop;
        TPanel *Panel4;
        TLabel *Label14;
        TLabel *Label17;
        TLabel *Label18;
        TButton *ButtonFlash;
        TEdit *EditCount;
        TEdit *EditDur;
        TPanel *Panel12;
        TLabel *Label21;
        TLabel *Label22;
        TEdit *EditAnimDur;
        TButton *Button1;
        void __fastcall ButtonAddAppClick(TObject *Sender);
        void __fastcall ButtonLaunchAppClick(TObject *Sender);
        void __fastcall TimerGetHandleTimer(TObject *Sender);
        void __fastcall ButtonMinimizeClick(TObject *Sender);
        void __fastcall ButtonCloseClick(TObject *Sender);
        void __fastcall ButtonAlignLeftClick(TObject *Sender);
        void __fastcall ButtonAlignRightClick(TObject *Sender);
        void __fastcall ButtonAlignTopClick(TObject *Sender);
        void __fastcall ButtonAlignBottomClick(TObject *Sender);
        void __fastcall ButtonAlignClientClick(TObject *Sender);
        void __fastcall ButtonHideClick(TObject *Sender);
        void __fastcall ButtonMinimize2Click(TObject *Sender);
        void __fastcall ButtonMaximizeClick(TObject *Sender);
        void __fastcall ButtonShowNormalClick(TObject *Sender);
        void __fastcall ButtonEnumWindowsClick(TObject *Sender);
        void __fastcall ButtonMoveRightMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall ButtonMoveRightMouseUp(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall ButtonMoveLeftMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall ButtonMoveLeftMouseUp(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall ButtonMoveUpMouseUp(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall ButtonMoveDownMouseUp(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall ButtonMoveDownMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall ButtonMoveUpMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall ButtonChangeTitleClick(TObject *Sender);
        void __fastcall TreeView1Change(TObject *Sender, TTreeNode *Node);
        void __fastcall Button1Click(TObject *Sender);
        void __fastcall ButtonStretchRightMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall ButtonStretchRightMouseUp(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall ButtonStretchLeftMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall ButtonStretchLeftMouseUp(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall ButtonStretchUpMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall ButtonStretchUpMouseUp(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall ButtonStretchDownMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall ButtonStretchDownMouseUp(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall ButtonBringToFocusClick(TObject *Sender);
        void __fastcall ButtonFlashClick(TObject *Sender);
protected:

        void __fastcall MyWndProc(Messages::TMessage &Message) ;
  	void __fastcall wmMoveAWindow(TMessage Msg);
  	void __fastcall wmStretchAWindow(TMessage Msg);

/*
        // if WM_MOVE_A_WINDOW and WM_STRETCH_A_WINDOW were predefined constants
        // we could do this instead of using MyWndProc...

        BEGIN_MESSAGE_MAP
            VCL_MESSAGE_HANDLER(WM_MOVE_A_WINDOW, TMessage, wmMoveAWindow)
            VCL_MESSAGE_HANDLER(WM_STRETCH_A_WINDOW, TMessage, wmStretchAWindow)
        END_MESSAGE_MAP(TForm);
*/
private:	// User declarations
        bool ButtonDown;
        HWND swProcess;
        HWND winhandle;
        unsigned long processid;
        HANDLE __fastcall LaunchApp(AnsiString fullfilename);
        unsigned long RunProgramEx (char* file, char* parameters);
        HWND LookForWindowHandle(unsigned long processid);
        static BOOL CALLBACK GetWinHandle_Specific(HWND hwnd, unsigned long hproc);
        static BOOL CALLBACK GetWinHandle_All(HWND hwnd, unsigned long hproc);
        void __fastcall Align(HWND winhandle,EAlign align);
        void __fastcall UpdateAppInfo(HWND winhandle);

        unsigned int GetCorrelationChoice();
        TTreeNode* __fastcall ProcessHandleInformation(HWND H_Window,
                                             unsigned int correlation_type = 0);
        TTreeNode*  __fastcall GetNode_AppInfoValue(TTreeNodes *tree,
                                                    TTreeNode *start,
                                                    unsigned int valuetype,
                                                    unsigned long value);
        TTreeNode*  __fastcall GetNode_AppInfoValue2(TTreeNodes *tree,
                                                    TTreeNode *start,
                                                    unsigned int valuetype1,
                                                    unsigned long value1,
                                                    unsigned int valuetype2,
                                                    unsigned long value2);
        TTreeNode*  __fastcall GetNode_Process(TTreeNodes *tree,
                                                unsigned long value);
public:		// User declarations
        int WM_MOVE_A_WINDOW;
        int WM_STRETCH_A_WINDOW;
        __fastcall TFormWinMan(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TFormWinMan *FormWinMan;
//---------------------------------------------------------------------------
#endif
