/*---------------------------------------------------------------------------
  WinSysUtilForm.h                                  
        C++Builder Developer's Guide
        Chapter 14 - Windows System Services Viewer
        Displays System, Memory, Drive and File information
        (c) Paul Gustavson, 2002
---------------------------------------------------------------------------*/

#ifndef WinSysUtilFormH
#define WinSysUtilFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Dialogs.hpp>
#include <FileCtrl.hpp>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
class TFormSystemService : public TForm
{
__published:	// IDE-managed Components
        TOpenDialog *OpenDialog1;
        TPanel *PanelTop;
        TGroupBox *GroupBox2;
        TLabel *Label1;
        TLabel *Label2;
        TLabel *LabelUser;
        TLabel *Label11;
        TLabel *Label12;
        TLabel *Label13;
        TLabel *LabelOS;
        TLabel *LabelVersion;
        TLabel *LabelOther;
        TLabel *Label14;
        TLabel *LabelProcessor;
        TLabel *Label19;
        TLabel *LabelNumProcessors;
        TLabel *Label18;
        TLabel *LabelScreenSize;
        TLabel *Label26;
        TLabel *LabelWinDir;
        TLabel *Label27;
        TLabel *LabelSysDir;
        TLabel *Label28;
        TLabel *LabelTempDir;
        TButton *ButtonSystemInfo;
        TEdit *EditComputer;
        TButton *ButtonChangeComputer;
        TSplitter *Splitter1;
        TGroupBox *GroupBox1;
        TLabel *Label4;
        TLabel *LabelSerialNum;
        TLabel *LabelFreeSpace;
        TLabel *Label5;
        TLabel *Label6;
        TLabel *Label7;
        TLabel *LabelFileSystemFlags;
        TLabel *LabelMaxComponentLength;
        TLabel *LabelFileSystemNameBuffer;
        TLabel *Label8;
        TLabel *Label9;
        TLabel *Label10;
        TLabel *Label15;
        TLabel *LabelVolumeSize;
        TLabel *Label16;
        TLabel *LabelUsed;
        TLabel *Label17;
        TLabel *LabelDriveType;
        TButton *ButtonGetDriveInfo;
        TDriveComboBox *DriveComboBox1;
        TButton *ButtonChangeVolumeLabel;
        TEdit *EditVolumeInfo;
        TPanel *PanelBottom;
        TGroupBox *GroupBox3;
        TLabel *Label3;
        TLabel *Label20;
        TLabel *Label21;
        TLabel *Label22;
        TLabel *LabelPFree;
        TLabel *LabelPTotal;
        TLabel *LabelVFree;
        TLabel *LabelVTotal;
        TLabel *LabelPgFree;
        TLabel *LabelPgTotal;
        TLabel *LabelFree;
        TLabel *Label23;
        TLabel *Label24;
        TLabel *Label25;
        TBevel *Bevel1;
        TBevel *Bevel2;
        TButton *ButtonGetMemInfo;
        TSplitter *Splitter2;
        TGroupBox *GroupBox4;
        TLabel *Label29;
        TLabel *Label30;
        TLabel *Label31;
        TLabel *Label32;
        TLabel *Label33;
        TLabel *Label34;
        TLabel *Label36;
        TLabel *LabelFileType;
        TLabel *LabelLocation;
        TLabel *LabelFileID;
        TLabel *LabelFileSize;
        TLabel *LabelDateTime;
        TLabel *LabelAttrib;
        TButton *ButtonGetFileInfo;
        TEdit *EditFilename;
        void __fastcall ButtonSystemInfoClick(TObject *Sender);
        void __fastcall ButtonGetDriveInfoClick(TObject *Sender);
        void __fastcall DriveComboBox1Change(TObject *Sender);
        void __fastcall ButtonGetMemInfoClick(TObject *Sender);
        void __fastcall ButtonChangeComputerClick(TObject *Sender);
        void __fastcall ButtonGetFileInfoClick(TObject *Sender);
        void __fastcall ButtonChangeVolumeLabelClick(TObject *Sender);
        void __fastcall Splitter2Moved(TObject *Sender);
        void __fastcall Splitter1Moved(TObject *Sender);
private:	// User declarations
public:		// User declarations
        AnsiString __fastcall FormatSize(double value);
        AnsiString __fastcall LoginUserName();
        AnsiString __fastcall ComputerName();
        bool __fastcall WindowsVersion(char * os, char * version, char * other);
        int  __fastcall ProcessorInfo(bool NT, char* processor);
        AnsiString ScreenSize();
        AnsiString __fastcall MemFree();
        __fastcall TFormSystemService(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TFormSystemService *FormSystemService;
//---------------------------------------------------------------------------
#endif
