/*---------------------------------------------------------------------------
  FormMain.h
        Chapter 15 - Analog Clock Example
        modified by Paul Gustavson, 2002
---------------------------------------------------------------------------*/

//---------------------------------------------------------------------------

#ifndef FormMainH
#define FormMainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
    TTimer *Timer1;
    TImage *HiddenImage;
    TPopupMenu *PopupMenu1;
    TMenuItem *BackgroundBrushStyle1;
    TMenuItem *bsSolid1;
    TMenuItem *bsBDiagonal1;
    TMenuItem *bsFDiagonal1;
    TMenuItem *bsCross1;
    TMenuItem *bsHorizontal1;
    TMenuItem *bsVertical1;
    void __fastcall Timer1Timer(TObject *Sender);
    void __fastcall FormPaint(TObject *Sender);
    void __fastcall bsSolid1Click(TObject *Sender);
    void __fastcall bsBDiagonal1Click(TObject *Sender);
    void __fastcall bsFDiagonal1Click(TObject *Sender);
    void __fastcall bsCross1Click(TObject *Sender);
    void __fastcall bsHorizontal1Click(TObject *Sender);
    void __fastcall bsVertical1Click(TObject *Sender);
private:	// User declarations
    TDateTime LastTime;
    TPoint Center;
    int Radius;
    TBrushStyle BrushStyle;
    void __fastcall InitializeImage();
    void __fastcall DrawClockToHiddenImage(const TDateTime &Time, bool erase = false);
    void __fastcall UncheckAllBrushItems();
public:		// User declarations
    __fastcall TForm1(TComponent* Owner);
    __fastcall TForm1::~TForm1();
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
