/*---------------------------------------------------------------------------
  GDIForm.cpp
        Chapter 15 - GDI / TCanvas Example
        created by Paul Gustavson, 2002
---------------------------------------------------------------------------*/

//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "GDIForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;


//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
  DrawSelectRegion = false;
}

//---------------------------------------------------------------------------

bool __fastcall TForm1::Contains(TPoint point, TRect rect)
{
   MessageBox(NULL,"Test","Test",MB_OK);
   if (((point.x >= rect.left) && (point.x <= rect.right)) &&
       ((point.y >= rect.top)  && (point.y <= rect.bottom)))
        return true;
   return false;
}

//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonDrawCanvasClick(TObject *Sender)
{
   Canvas->Rectangle(10, 10, 100, 100);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonDrawGDIClick(TObject *Sender)
{
  HDC hDC = GetDC(Handle);
  Rectangle(hDC,10,10,100,100);
  ReleaseDC(Handle, hDC);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonDrawCanvasGDIClick(TObject *Sender)
{
   Rectangle(Canvas->Handle, 10, 10, 100, 100);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
   TPoint point;
   point.x = EditX->Text.ToIntDef(0);
   point.y = EditY->Text.ToIntDef(0);
//   if (rect.Contains( point));
//      MessageBox(NULL,"Got it","Contains Test",MB_OK);

}
//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonDrawRectClick(TObject *Sender)
{
   TRect MyRect(50,50,100,100);
   Canvas->Pen->Color = clBlue;
   Canvas->Pen->Style = psSolid; // solid line
   Canvas->Pen->Width = 2;
   Canvas->Brush->Color = clYellow;
   Canvas->Brush->Style = bsSolid;
   Canvas->Rectangle(MyRect);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
   TRect MyRect(50,50,100,100);
   Canvas->Pen->Color = clBlue;
   Canvas->Pen->Style = psSolid; // solid line
   Canvas->Pen->Width = 2;
   Canvas->Brush->Color = clYellow;
   Canvas->Brush->Style = bsSolid;
   Canvas->Ellipse(MyRect);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonTextOutClick(TObject *Sender)
{
     Canvas->Font->Color = clNavy;
     Canvas->TextOut(20,20,"Here's how you write text ");
     Canvas->TextOut(Canvas->PenPos.x,Canvas->PenPos.y,
                "and how you continue to write text.");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonTextRectClick(TObject *Sender)
{
    Canvas->Font->Color = clNavy;
    TRect MyRect(10,10,200,100);
    Canvas->Pen->Color = clBlue;
    Canvas->Pen->Style = psSolid; // solid line
    Canvas->Pen->Width = 2;
    Canvas->Brush->Color = clYellow;
    Canvas->Brush->Style = bsSolid;
    Canvas->Rectangle(MyRect);
    Canvas->TextRect(MyRect,10,10,"Here's how you write text within a rectangle.");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormMouseDown(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
  if (Button == mbLeft)
  {
     oX = X;
     oY = Y;
     lX = X;
     lY = Y;
     Canvas->Pen->Color = clBlack;
     Canvas->Pen->Style = psDash; // dashed line
     Canvas->Pen->Width = 1;
     Canvas->Pen->Mode  = pmNotXor;
     Canvas->Brush->Style = bsClear;
     DrawSelectRegion = true;
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormMouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
  TRect MyRect;
  if (DrawSelectRegion)
  {
     MyRect = TRect(oX,oY,lX,lY);
     Canvas->Rectangle(MyRect);
     lX = X;
     lY = Y;
     MyRect = TRect(oX,oY,lX,lY);
     Canvas->Rectangle(MyRect);
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormMouseUp(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
  if (DrawSelectRegion)
  {
     TRect MyRect = TRect(oX,oY,lX,lY);
     Canvas->Rectangle(MyRect);
     DrawSelectRegion = false;
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
    TRect MyRect(150,150,400,200);
    Canvas->Pen->Color    = clBlue;
    Canvas->Pen->Style    = psSolid;
    Canvas->Pen->Width    = 6;
    Canvas->Brush->Color  = clYellow;
    Canvas->Brush->Style  = bsSolid;
    Canvas->Font->Color   = clNavy;
    Canvas->Font->Name    = "Arial";
    Canvas->Font->Style   = TFontStyles()<< fsBold << fsUnderline;
    Canvas->Font->Size    = 12;
    Canvas->Rectangle(MyRect);
    Canvas->TextRect(MyRect,160,160,"Here's how you write text ");

}
//---------------------------------------------------------------------------


