/*---------------------------------------------------------------------------
  ImageCanvasForm.cpp
        Chapter 15 - Bitmap on Canvas Example
        created by Paul Gustavson, 2002
---------------------------------------------------------------------------*/

//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "ImageCanvasForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonAssignBitmapToCanvasClick(TObject *Sender)
{
    OpenDialog1->Filter = "Bmp files (*.bmp)|*.BMP";
    if (OpenDialog1->Execute())
    {
        Graphics::TBitmap *BrushBmp = new Graphics::TBitmap;

        try
        {
          BrushBmp->LoadFromFile(OpenDialog1->FileName);
          Canvas->Brush->Bitmap = BrushBmp;
          TRect rect;
          rect.Left = 0;
          rect.Top  = 0;
          rect.Right = ClientWidth;
          rect.Bottom = ClientHeight;
          if (CheckBoxStretch->Checked)
                Canvas->StretchDraw(rect, BrushBmp);
          else
                Canvas->FillRect(rect);
        }
        __finally
        {
          Canvas->Brush->Bitmap = NULL;
          delete BrushBmp;
        }
    }
}
//---------------------------------------------------------------------------
 