//><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
#ifndef MCI_DEVICE_H
#define MCI_DEVICE_H

#include <mmsystem.h>
//><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>

class MCIDevice
{
protected:
    bool Report_;
    MCIDEVICEID DeviceID_;
    HWND HCallback_;
    
protected:
    virtual int doGetNumDevices(int ADevType = 0) const;
    virtual bool doOpen(const char* AFileName, const char* ADeviceType);
    virtual bool doClose();
    virtual bool doPlay(long AStart, long AStop);
    virtual bool doStop();
    virtual bool doPause();
    virtual bool doSeek(long APosition);
    virtual bool doSetTimeFormat(long ATimeFormat);
    virtual DWORD doStatus(long AQueryGroup, long AQueryItem,
        long AQueryTrack) const;
    virtual bool isOpened() const;
    virtual bool isPaused() const;
    virtual bool isPlaying() const;
    virtual bool isStopped() const;
    
public:
    MCIDevice() : Report_(true), DeviceID_(NULL), HCallback_(NULL) {}
    virtual ~MCIDevice();

public:
    bool report() const { return Report_; }
    void report(bool AReport) { Report_ = AReport; }
    MCIDEVICEID deviceID() const { return DeviceID_; }
    HWND callbackWnd() const { return HCallback_; }
    void callbackWnd(HWND AHCallback) { HCallback_ = AHCallback; }

public:
    int getNumDevices() const { return doGetNumDevices(); }
    bool close() { return doClose(); }
    bool stop() { return doStop(); }
    bool pause() { return doPause(); }
    bool opened() { return isOpened(); }
    bool playing() { return isPlaying(); }
    bool stopped() { return isStopped(); }
    bool paused() { return isPaused(); }    
    bool seek(long APosition) { return doSeek(APosition); }
};

//><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
#endif
//><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
