
/****************************************************************************\

    MP3Device.cpp -- Copyright (c) 2000,
                     Damon Chandler <dmc27@cornell.edu>

    An audio media-tuned MCIDevice descendant class

 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************

\****************************************************************************/

#include <windows.h>
#pragma hdrstop

#include <math.h>
#include "MP3Device.h"
#pragma link "MCIDevice"
//><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>

bool MP3Device::doStop()
{
    return (MCIDevice::doStop() && seek(0));
}
//---------------------------------------------------------------------------

long MP3Device::doLength()
{
    return MCIDevice::doStatus(MCI_STATUS_ITEM, MCI_STATUS_LENGTH, NULL);
}
//---------------------------------------------------------------------------

long MP3Device::doPosition()
{
    return MCIDevice::doStatus(MCI_STATUS_ITEM, MCI_STATUS_POSITION, NULL);
}
//---------------------------------------------------------------------------

bool MP3Device::open(const char* AFileName)
{
    if (opened() || playing()) close();

    if (MCIDevice::doOpen(AFileName, NULL))
    {
        return MCIDevice::doSetTimeFormat(MCI_FORMAT_MILLISECONDS);
    }
    return false;
}
//---------------------------------------------------------------------------

bool MP3Device::play()
{
    return MCIDevice::doPlay(-1, -1);
}
//---------------------------------------------------------------------------


//><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
//  [EOF]
//><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>


