//---------------------------------------------------------------------------
#ifndef WndFrameH
#define WndFrameH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <Dialogs.hpp>

#include <vfw.h>  // Video For Windows
//---------------------------------------------------------------------------

//
// introduced event type -- TMCIPosChangedEvent
//
typedef void __fastcall (__closure *TMCIPosChangedEvent)(TObject* ASender,
	long APosition);

//
// class TMCIWndFrame
//
class TMCIWndFrame : public TFrame
{
__published:
private:
   /* internal */
   HWND HMCIWnd_;

   /* DisplayString property */
   AnsiString __fastcall GetDisplayString();

   /* Error property */
   bool error_;

   /* FileName property */
   AnsiString filename_;
   void __fastcall SetFileName(AnsiString AValue);

   /* FullScreen property */
   TRect SavedBoundsRect_;
   DWORD SavedStyle_;
   bool fullscreen_;
   void __fastcall SetFullScreen(bool AValue);

   /* Position property */
   long position_;
   void __fastcall SetPosition(long AValue);

   /* Speed property */
   long __fastcall GetSpeed();
   void __fastcall SetSpeed(long AValue);

   /* VideoLength property */
   long __fastcall GetLength();

   /* Volume property */
   long __fastcall GetVolume();
   void __fastcall SetVolume(long AValue);

   /* OnPosChanged event */
   TMCIPosChangedEvent OnPosChanged_;
   MESSAGE void __fastcall MCINotifyPos(TMessage& AMsg);

protected: /* inherited */
   virtual void __fastcall CreateWnd();
   virtual void __fastcall DestroyWnd();
   virtual void __fastcall SetBounds(int ALeft, int ATop, int AWidth,
      int AHeight);

protected: /* introduced */
   RECT __fastcall DoCalcDestRect();
   virtual void __fastcall DoSetTimeFormat();
   virtual void __fastcall DoSetTimers();
   virtual void __fastcall DoResize();
   virtual void __fastcall DoPlay();
   virtual void __fastcall DoSeek(long APosition);
   virtual void __fastcall DoHideToolBar(bool AHide);   
   virtual void __fastcall DoSetFullScreen(bool AFullScreen);
   
public:
   __fastcall TMCIWndFrame(TComponent* Owner);
   __fastcall ~TMCIWndFrame();

   /* public member functions */
   void __fastcall Play() { DoPlay(); }
   void __fastcall Seek(DWORD APosition) { DoSeek(APosition); }

public:
   /* properties */
   __property AnsiString DisplayString =
      {read = GetDisplayString};
   __property bool Error =
      {read = error_};
   __property AnsiString FileName =
      {read = filename_, write = SetFileName};
   __property bool FullScreen =
      {read = fullscreen_, write = SetFullScreen};
   __property long Position =
      {read = position_, write = SetPosition};
   // not used by demo, but useful nonetheless
   __property long Speed =
      {read = GetSpeed, write = SetSpeed};
   __property long VideoLength =
      {read = GetLength};
   // not used by demo, but useful nonetheless
   __property long Volume =
      {read = GetVolume, write = SetVolume};

   /* events */
   __property TMCIPosChangedEvent OnPosChanged =
      {read = OnPosChanged_, write = OnPosChanged_};

BEGIN_MESSAGE_MAP
   // notification of position change
   VCL_MESSAGE_HANDLER(MCIWNDM_NOTIFYPOS, TMessage, MCINotifyPos)
END_MESSAGE_MAP(TFrame)
};

//---------------------------------------------------------------------------
extern PACKAGE TMCIWndFrame *MCIWndFrame;
//---------------------------------------------------------------------------
#endif
