//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "ParentForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TParent *Parent;
//---------------------------------------------------------------------------
__fastcall TParent::TParent(TComponent* Owner)
    : TForm(Owner)
{
    Dll = NULL;
    Package = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TParent::New1Click(TObject *Sender)
{
    typedef void __declspec(dllimport)SHOWMDICHILD(HWND);
    SHOWMDICHILD *ShowMDIChild;

    // See if the DLL is loaded already.
    if (!Dll)
        Dll = LoadLibrary("MDIChild_DLL.dll");

    // Check and make sure the Dll loaded
    if (Dll)
    {
        // Get the address of the function.
        ShowMDIChild = (SHOWMDICHILD *)GetProcAddress(Dll, "_ShowMDIChildForm");
        // Make sure we have the address then call the function.
        if (ShowMDIChild)
            ShowMDIChild(Handle);
        else
        {
            ShowMessage(SysErrorMessage(GetLastError()));
            // If we couldn't get the address of the function
            // we want to free the Dll.
            FreeLibrary(Dll);
        }
    }
    else
    {
        ShowMessage(SysErrorMessage(GetLastError()));
        ShowMessage("Unable to load the DLL");
    }
}
//---------------------------------------------------------------------------
void __fastcall TParent::FormClose(TObject *Sender, TCloseAction &Action)
{
    //Make sure all the children forms are closed
    while (MDIChildCount)
        MDIChildren[0]->Free();

    if (Dll)
        FreeLibrary(Dll);
    if (Package)
        UnloadPackage(Package);
}
//---------------------------------------------------------------------------
void __fastcall TParent::NewPackage1Click(TObject *Sender)
{
    typedef void __declspec(dllimport)ShowChildPkType(void);
    ShowChildPkType *ShowPackageChild;
    if (!Package)
        Package = LoadPackage("MDIChildPackage.bpl");
    // Check and make sure the Package loaded
    if (Package)
    {
        // Get the address of the function.
        ShowPackageChild = (ShowChildPkType *)GetProcAddress((HINSTANCE)Package, "_ShowMDIChildPkForm");
        // Make sure we have the address then call the function.
        if (ShowPackageChild)
            ShowPackageChild();
        else
        {
            ShowMessage(SysErrorMessage(GetLastError()));
            // If we couldn't get the address of the function
            // we want to free the Package.
            UnloadPackage(Package);
        }

    }
    else
    {
        ShowMessage(SysErrorMessage(GetLastError()));
        ShowMessage("Unable to load the Package");
    }
}
//---------------------------------------------------------------------------

void __fastcall TParent::ShowSDIFormModalClick(TObject *Sender)
{
    typedef void __declspec(dllimport)SHOWSDIFORM(void);
    SHOWSDIFORM *ShowSDIForm;

    // See if the DLL is loaded already.
    if (!Dll)
        Dll = LoadLibrary("MDIChild_DLL.dll");

    // Check and make sure the Dll loaded
    if (Dll)
    {
        // Get the address of the function.
        ShowSDIForm = (SHOWSDIFORM *)GetProcAddress(Dll, "_ShowSDIFormModal");
        // Make sure we have the address then call the function.
        if (ShowSDIForm)
            ShowSDIForm();
        else
        {
            ShowMessage(SysErrorMessage(GetLastError()));
            // If we couldn't get the address of the function
            // we want to free the Dll.
            FreeLibrary(Dll);
        }

    }
    else
    {
        ShowMessage(SysErrorMessage(GetLastError()));
        ShowMessage("Unable to load the DLL");
    }
}
//---------------------------------------------------------------------------


void __fastcall TParent::Exit1Click(TObject *Sender)
{
        Close();        
}
//---------------------------------------------------------------------------

