/*---------------------------------------------------------------------------
  DealerForm.cpp
        C++Builder Developer's Guide
        Chapter 16 - Shared Segmentation DLL Example
        Paul Gustavson, 2002
---------------------------------------------------------------------------*/
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "DealerForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

#define SHAREDSEG_LINK
//#define VISUALCPP_DLL   //remove comment to load Visual C++ DLL 
                        //rather than BCB DLL - make sure you do this
                        //to FactoryForm.cpp too

#ifdef SHAREDSEG_LINK
HINSTANCE SHAREDSEGDLL;


#define all -1
#define accord 0
#define civic 1
#define crv 2
#define pilot 3

typedef int (*CARCOUNT)(int, int);
CARCOUNT CarCount;

typedef int (*BUYSELLCAR)(int, int);
BUYSELLCAR BuySellCar;

typedef int (*BUILDRETURNCAR)(int, int);
BUILDRETURNCAR BuildReturnCar;

typedef int (*OPENFORBUSINESS)(HWND);
OPENFORBUSINESS OpenForBusiness;


#endif


//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
        myid = -1;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
#ifdef SHAREDSEG_LINK
    if (SHAREDSEGDLL != NULL)
    {
         FreeLibrary(SHAREDSEGDLL);
    }
#endif
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
    #ifdef SHAREDSEG_LINK

    #ifdef VISUALCPP_DLL
      SHAREDSEGDLL = LoadLibrary("InventoryVC");
    #else
      SHAREDSEGDLL = LoadLibrary("Inventory");
    #endif
    if (SHAREDSEGDLL != NULL)
    {
        CarCount = (CARCOUNT)GetProcAddress(SHAREDSEGDLL,"CarCount");
        BuySellCar =
            (BUYSELLCAR)GetProcAddress(SHAREDSEGDLL,"BuySellCar");
        BuildReturnCar =
           (BUILDRETURNCAR)GetProcAddress(SHAREDSEGDLL,"BuildReturnCar");
        OpenForBusiness =
            (OPENFORBUSINESS)GetProcAddress(SHAREDSEGDLL,"OpenForBusiness");


        if ((!CarCount) || (!BuySellCar))
        {
          // handle the error
            MessageBeep(MB_OK);
            FreeLibrary(SHAREDSEGDLL);
            SHAREDSEGDLL = NULL;
        }
        else
        {
           myid = OpenForBusiness(Handle);
           if (myid == 0)
           {
               MessageBox(NULL,
                    "Factory must be in operation before dealership can open",
                    "Improper Business Operation", MB_OK);
               Close();
               Application->Terminate();
               return;
           }

           Caption = "Dealer #" + AnsiString(myid);
           // let's get all the dealer information..
/*
            TMessage msg;
            msg.WParam = myid;
            msg.LParam = accord;
            wmCarChange(msg);
            msg.LParam = civic;
            wmCarChange(msg);
            msg.LParam = crv;
            wmCarChange(msg);
            msg.LParam = pilot;
            wmCarChange(msg);
*/
            BuySellCar(accord,10);
            BuySellCar(civic,10);
            BuySellCar(crv,10);
            BuySellCar(pilot,10);
        }
    }
    else
       MessageBox(NULL,"Couldn't find the necessary DLL","Test One",MB_OK);
    #endif
}

//---------------------------------------------------------------------------

void __fastcall TForm1::wmCarChange(TMessage Msg)
{
    int id = Msg.WParam;
    int car = (Msg.LParam);

    int count = 0;
    if (id == myid)
    {
        count = CarCount(car, 0);
        // let's figure out what model it is...
        switch (car)
        {
           case accord  : EditLocalAccords->Text = AnsiString(count); break;
           case civic   : EditLocalCivics->Text = AnsiString(count); break;
           case crv     : EditLocalCRVs->Text = AnsiString(count); break;
           case pilot   : EditLocalPilots->Text = AnsiString(count); break;
        }
    }
    count = CarCount(car, 1);    // all dealers
    switch (car)
    {
           case accord  : EditAllAccords->Text = AnsiString(count); break;
           case civic   : EditAllCivics->Text = AnsiString(count); break;
           case crv     : EditAllCRVs->Text = AnsiString(count); break;
           case pilot   : EditAllPilots->Text = AnsiString(count); break;
     }
    count = CarCount(car, 2);    // factory
    switch (car)
    {
           case accord  : EditFactoryAccords->Text = AnsiString(count); break;
           case civic   : EditFactoryCivics->Text = AnsiString(count); break;
           case crv     : EditFactoryCRVs->Text = AnsiString(count); break;
           case pilot   : EditFactoryPilots->Text = AnsiString(count); break;
     }
    count = CarCount(car, 3);    // sold
    switch (car)
    {
           case accord  : EditSoldAccords->Text = AnsiString(count); break;
           case civic   : EditSoldCivics->Text = AnsiString(count); break;
           case crv     : EditSoldCRVs->Text = AnsiString(count); break;
           case pilot   : EditSoldPilots->Text = AnsiString(count); break;
     }
}



//---------------------------------------------------------------------------



void __fastcall TForm1::Button1Click(TObject *Sender)
{
     myid = BuySellCar(accord,1);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
     myid = BuySellCar(civic,1);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
     myid = BuySellCar(crv,1);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
     myid = BuySellCar(pilot,1);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button5Cick(TObject *Sender)
{
     myid = BuySellCar(accord,-1);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button6Click(TObject *Sender)
{
     myid = BuySellCar(civic,-1);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button7Click(TObject *Sender)
{
     myid = BuySellCar(crv,-1);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button8Click(TObject *Sender)
{
     myid = BuySellCar(pilot,-1);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonOpenNewDealershipClick(TObject *Sender)
{
//  WinExec(ParamStr(0).c_str(), SW_SHOWNORMAL);
  WinExec ("Dealership.exe", SW_SHOWNORMAL);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonCloseClick(TObject *Sender)
{
        Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonReturnAccordsClick(TObject *Sender)
{
     myid = BuildReturnCar(accord,-1);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonReturnCivicsClick(TObject *Sender)
{
     myid = BuildReturnCar(civic,-1);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonReturnCRVsClick(TObject *Sender)
{
     myid = BuildReturnCar(crv,-1);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonReturnPilotsClick(TObject *Sender)
{
     myid = BuildReturnCar(pilot,-1);

}
//---------------------------------------------------------------------------


