//---------------------------------------------------------------------------

#include <windows.h>
#include <stdio.h>
#include "simple.h"
//---------------------------------------------------------------------------
//   Important note about DLL memory management when your DLL uses the
//   static version of the RunTime Library:
//
//   If your DLL exports any functions that pass String objects (or structs/
//   classes containing nested Strings) as parameter or function results,
//   you will need to add the library MEMMGR.LIB to both the DLL project and
//   any other projects that use the DLL.  You will also need to use MEMMGR.LIB
//   if any other projects which use the DLL will be performing new or delete
//   operations on any non-TObject-derived classes which are exported from the
//   DLL. Adding MEMMGR.LIB to your project will change the DLL and its calling
//   EXE's to use the BORLNDMM.DLL as their memory manager.  In these cases,
//   the file BORLNDMM.DLL should be deployed along with your DLL.
//
//   To avoid using BORLNDMM.DLL, pass string information using "char *" or
//   ShortString parameters.
//
//   If your DLL uses the dynamic version of the RTL, you do not need to
//   explicitly add MEMMGR.LIB as this will be done implicitly for you
//---------------------------------------------------------------------------

#pragma argsused



//BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fwdreason, LPVOID lpvReserved)
int WINAPI DllEntryPoint(HINSTANCE hinstDLL, unsigned long fwdreason, void* lpvReserved)
{
    switch(fwdreason)
    {
	case DLL_PROCESS_ATTACH:
            if (lpvReserved)
                  MessageBox(NULL,"Process has attached to DLL (Static Load)",
                      "DLLMain",MB_OK);
            else
                  MessageBox(NULL,"Process has attached to DLL (Dynamic Load)",
                        "DLLMain",MB_OK);
            break;
	case DLL_THREAD_ATTACH:
            MessageBox(NULL,"Thread has attached to DLL","DLLMain",MB_OK);
            break;
	case DLL_THREAD_DETACH:
            MessageBox(NULL,"Thread has detached to DLL","DLLMain",MB_OK);
            break;
	case DLL_PROCESS_DETACH:
            MessageBox(NULL,"Process has detached to DLL","DLLMain",MB_OK);
            break;
    }
/*
    char filename[MAX_PATH];
    char message[MAX_PATH];
    GetModuleFileName(hinstDLL,filename,MAX_PATH);

    switch(fwdreason)
    {
    case DLL_PROCESS_ATTACH:
      sprintf(message,"Process has attached to DLL.\n\nFile Name = %s\n%u",
              filename,(unsigned int)hinstDLL);
      break;
    case DLL_THREAD_ATTACH:
      sprintf(message,"Thread has attached to DLL.\n\nFile Name = %s - %u",
              filename,(unsigned int)hinstDLL);
      break;
    case DLL_THREAD_DETACH:
      sprintf(message,"Thread has detached from DLL.\n\nFile Name = %s - %u",
              filename,(unsigned int)hinstDLL);
      break;
    case DLL_PROCESS_DETACH:
      sprintf(message,"Process has detached from DLL.\n\nFile Name = %s - %u",
              filename,(unsigned int)hinstDLL);
      break;
    }
    MessageBox(NULL,message,"simple.dll - Entry Point",MB_OK);
*/
    return 1; // always return true;
}

//---------------------------------------------------------------------------

__fastcall TSimpleClass::TSimpleClass()
{
   FVersion = 1.1;
}

//---------------------------------------------------------------------------

__fastcall TSimpleClass::~TSimpleClass()
{

}

//---------------------------------------------------------------------------

double TSimpleClass::GetLibVersion()  //Retrieves the current library version of the DLL.
{
	return FVersion;
}


double TSimpleClass::feet_to_meters(double feet)
{
	return (feet * 0.3048);
}

//---------------------------------------------------------------------------

double TSimpleClass::meters_to_feet(double meters)
{
	return (meters * 3.2808);
}

