/*---------------------------------------------------------------------------
  AppDynamicForm.cpp
        C++Builder Developer's Guide
        Chapter 16 - Dynamic Load DLL Example
        Paul Gustavson, 2002
---------------------------------------------------------------------------*/
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "AppDynamicForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"




TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
        dllhandle = 0;
}

//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonLoadLibraryClick(TObject *Sender)
{
    dllhandle = LoadLibrary("simple.dll"); // keep track of the handle
    EditDLLHandle->Text = AnsiString((int)dllhandle);
    if (dllhandle)
    {
        ButtonUnloadLibrary->Enabled = true;
        ButtonProcAddress->Enabled = true;

    }
    else
    {
        ShowMessage("Unable to load the DLL");
    }
}

//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonUnloadLibraryClick(TObject *Sender)
{
    if (dllhandle)
    {
        FreeLibrary(dllhandle);
        ButtonUnloadLibrary->Enabled = false;
        ButtonProcAddress->Enabled = false;
        ButtonGetVersion->Enabled = false;
        ButtonConvertToMeters->Enabled = false;
        ButtonConvertToFeet->Enabled = false;
        EditDLLHandle->Text = "";
    }
}

//---------------------------------------------------------------------------



void __fastcall TForm1::ButtonProcAddressClick(TObject *Sender)
{
  if (dllhandle)
  {
    simpleGetLibVersion  =
        (SIMPLEGETLIBVERSION)GetProcAddress(dllhandle, "_simpleGetLibVersion");
    if (simpleGetLibVersion)  ButtonGetVersion->Enabled = true;
    meters_to_feet  =
        (METERS_TO_FEET)GetProcAddress(dllhandle, "_meters_to_feet");
    if (meters_to_feet)  ButtonConvertToMeters->Enabled = true;
    feet_to_meters  =
        (FEET_TO_METERS)GetProcAddress(dllhandle, "_feet_to_meters");
    if (feet_to_meters)  ButtonConvertToFeet->Enabled = true;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonGetVersionClick(TObject *Sender)
{

  if (dllhandle)
  {
    EditVersion->Text = AnsiString(simpleGetLibVersion());
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonConvertToMetersClick(TObject *Sender)
{
     double meters =  feet_to_meters(EditFeet->Text.ToDouble());
     EditMeters->Text = AnsiString(meters);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonConvertToFeetClick(TObject *Sender)
{
     double feet =  meters_to_feet(EditMeters->Text.ToDouble());
     EditFeet->Text = AnsiString(feet);
}
//---------------------------------------------------------------------------

