// AUTOINVENTORYIMPL.H : Declaration of the TAutoInventoryImpl

#ifndef AutoInventoryImplH
#define AutoInventoryImplH

#define ATL_APARTMENT_THREADED

#include "InventoryServer_TLB.h"
#include "Inventory_OCX.h"



/////////////////////////////////////////////////////////////////////////////
// TAutoInventoryImpl     Implements IAutoInventory, default interface of AutoInventory
// ThreadingModel : Apartment
// Dual Interface : TRUE
// Event Support  : FALSE
// Default ProgID : Project1.AutoInventory
// Description    : Implementation of IAutoInterface Interface
/////////////////////////////////////////////////////////////////////////////
class ATL_NO_VTABLE TAutoInventoryImpl : 
  public CComObjectRootEx<CComSingleThreadModel>,
  public CComCoClass<TAutoInventoryImpl, &CLSID_AutoInventory>,
  public IDispatchImpl<IAutoInventory, &IID_IAutoInventory, &LIBID_InventoryServer>,
  DUALINTERFACE_IMPL(AutoInventory, IProcess)
{
public:
  TAutoInventoryImpl()
  {
  }

  // Data used when registering Object 
  //
  DECLARE_THREADING_MODEL(otApartment);
  DECLARE_PROGID("InventoryServer.AutoInventory");
  DECLARE_DESCRIPTION("Implementation of IAutoInterface Interface");

  // Function invoked to (un)register object
  //
  static HRESULT WINAPI UpdateRegistry(BOOL bRegister)
  {
    TTypedComServerRegistrarT<TAutoInventoryImpl> 
    regObj(GetObjectCLSID(), GetProgID(), GetDescription());
    return regObj.UpdateRegistry(bRegister);
  }


BEGIN_COM_MAP(TAutoInventoryImpl)
  COM_INTERFACE_ENTRY(IAutoInventory)
  COM_INTERFACE_ENTRY2(IDispatch, IAutoInventory)
  DUALINTERFACE_ENTRY(IProcess)
END_COM_MAP()

// IAutoInventory
public:
 
  STDMETHOD(BuildReturnCar(int model, int quantity));
  STDMETHOD(BuySellCar(int model, int quantity));
  STDMETHOD(CarCount(int model, int Inventory));
  STDMETHOD(NumDealerships());
  STDMETHOD(OpenForBusiness(unsigned hWindow));
  STDMETHOD(Attach());
  STDMETHOD(Detach());
};

#endif //AutoInventoryImplH
