//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "DealerForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

#define all -1
#define accord 0
#define civic 1
#define crv 2
#define pilot 3


//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
        myid = -1;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
    AutoInventory->Leave();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
    AutoInventory = Inventorykeeperserver_tlb::CoInventoryKeeper::Create();
    AutoInventory->Join();

    myid = AutoInventory->OpenForBusiness((unsigned int)Handle);

    if (myid == 0)
    {
       MessageBox(NULL,
            "Factory must be in operation before dealership can open",
            "Improper Business Operation", MB_OK);
       Close();
       Application->Terminate();
       return;
    }

    Caption = "Dealer #" + AnsiString(myid);
    // let's get all the dealer information..
    AutoInventory->BuySellCar(accord,10);
    AutoInventory->BuySellCar(civic,10);
    AutoInventory->BuySellCar(crv,10);
    AutoInventory->BuySellCar(pilot,10);
}

//---------------------------------------------------------------------------

void __fastcall TForm1::wmCarChange(TMessage Msg)
{
    int id = Msg.WParam;
    int car = (Msg.LParam);

    int count = 0;
    if (id == myid)
    {
        count = AutoInventory->CarCount(car, 0);
        // let's figure out what model it is...
        switch (car)
        {
           case accord  : EditLocalAccords->Text = AnsiString(count); break;
           case civic   : EditLocalCivics->Text = AnsiString(count); break;
           case crv     : EditLocalCRVs->Text = AnsiString(count); break;
           case pilot   : EditLocalPilots->Text = AnsiString(count); break;
        }
    }
    count = AutoInventory->CarCount(car, 1);    // all dealers
    switch (car)
    {
           case accord  : EditAllAccords->Text = AnsiString(count); break;
           case civic   : EditAllCivics->Text = AnsiString(count); break;
           case crv     : EditAllCRVs->Text = AnsiString(count); break;
           case pilot   : EditAllPilots->Text = AnsiString(count); break;
     }
    count = AutoInventory->CarCount(car, 2);    // factory
    switch (car)
    {
           case accord  : EditFactoryAccords->Text = AnsiString(count); break;
           case civic   : EditFactoryCivics->Text = AnsiString(count); break;
           case crv     : EditFactoryCRVs->Text = AnsiString(count); break;
           case pilot   : EditFactoryPilots->Text = AnsiString(count); break;
     }
    count = AutoInventory->CarCount(car, 3);    // sold
    switch (car)
    {
           case accord  : EditSoldAccords->Text = AnsiString(count); break;
           case civic   : EditSoldCivics->Text = AnsiString(count); break;
           case crv     : EditSoldCRVs->Text = AnsiString(count); break;
           case pilot   : EditSoldPilots->Text = AnsiString(count); break;
     }
}



//---------------------------------------------------------------------------



void __fastcall TForm1::Button1Click(TObject *Sender)
{
     myid = AutoInventory->BuySellCar(accord,1);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
     myid = AutoInventory->BuySellCar(civic,1);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
     myid = AutoInventory->BuySellCar(crv,1);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
     myid = AutoInventory->BuySellCar(pilot,1);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button5Cick(TObject *Sender)
{
     myid = AutoInventory->BuySellCar(accord,-1);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button6Click(TObject *Sender)
{
     myid = AutoInventory->BuySellCar(civic,-1);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button7Click(TObject *Sender)
{
     myid = AutoInventory->BuySellCar(crv,-1);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button8Click(TObject *Sender)
{
     myid = AutoInventory->BuySellCar(pilot,-1);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonOpenNewDealershipClick(TObject *Sender)
{
  WinExec (ParamStr(0).c_str(), SW_SHOWNORMAL);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonCloseClick(TObject *Sender)
{
        Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonReturnAccordsClick(TObject *Sender)
{
     myid = AutoInventory->BuildReturnCar(accord,-1);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonReturnCivicsClick(TObject *Sender)
{
     myid = AutoInventory->BuildReturnCar(civic,-1);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonReturnCRVsClick(TObject *Sender)
{
     myid = AutoInventory->BuildReturnCar(crv,-1);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonReturnPilotsClick(TObject *Sender)
{
     myid = AutoInventory->BuildReturnCar(pilot,-1);

}
//---------------------------------------------------------------------------


