// INVENTORYKEEPERIMPL.H : Declaration of the TInventoryKeeperImpl

#ifndef InventoryKeeperImplH
#define InventoryKeeperImplH

#define ATL_APARTMENT_THREADED

#include "InventoryKeeperServer_TLB.H"
#include "Inventory_OCX.h"


/////////////////////////////////////////////////////////////////////////////
// TInventoryKeeperImpl     Implements IAutoInventory, default interface of InventoryKeeper
//                  and IAutoInventoryEvents, the default source interface
// ThreadingModel : Apartment
// Dual Interface : TRUE
// Event Support  : TRUE
// Default ProgID : InventoryKeeperServer.InventoryKeeper
// Description    : Implemenation of IAutoInventory Interface
/////////////////////////////////////////////////////////////////////////////
class ATL_NO_VTABLE TInventoryKeeperImpl : 
  public CComObjectRootEx<CComSingleThreadModel>,
  public CComCoClass<TInventoryKeeperImpl, &CLSID_InventoryKeeper>,
  public IConnectionPointContainerImpl<TInventoryKeeperImpl>,
  public TEvents_InventoryKeeper<TInventoryKeeperImpl>, 
  public IDispatchImpl<IAutoInventory, &IID_IAutoInventory, &LIBID_InventoryKeeperServer>
{
public:
  TInventoryKeeperImpl()
  {
  }

  // Data used when registering Object 
  //
  DECLARE_THREADING_MODEL(otApartment);
  DECLARE_PROGID("InventoryKeeperServer.InventoryKeeper");
  DECLARE_DESCRIPTION("Implemenation of IAutoInventory Interface");

  // Function invoked to (un)register object
  //
  static HRESULT WINAPI UpdateRegistry(BOOL bRegister)
  {
    TTypedComServerRegistrarT<TInventoryKeeperImpl> 
    regObj(GetObjectCLSID(), GetProgID(), GetDescription());
    return regObj.UpdateRegistry(bRegister);
  }


BEGIN_COM_MAP(TInventoryKeeperImpl)
  COM_INTERFACE_ENTRY(IAutoInventory)
  COM_INTERFACE_ENTRY2(IDispatch, IAutoInventory)
  COM_INTERFACE_ENTRY_IMPL(IConnectionPointContainer)
END_COM_MAP()

BEGIN_CONNECTION_POINT_MAP(TInventoryKeeperImpl)
  CONNECTION_POINT_ENTRY(DIID_IInventoryKeeperEvents)
END_CONNECTION_POINT_MAP()

// IAutoInventory
public:
 
  STDMETHOD(BuildReturnCar(int model, int quantity));
  STDMETHOD(BuySellCar(int model, int quantity));
  STDMETHOD(CarCount(int model, int Inventory));
  STDMETHOD(Join());
  STDMETHOD(Leave());
  STDMETHOD(NumDealerships());
  STDMETHOD(OpenForBusiness(unsigned hWindow));
};

#endif //InventoryKeeperImplH
