//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "InventoryKeeperUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
    DealerID = 0;
    NextDealerID = 0;
}

//---------------------------------------------------------------------------


int TForm1::Attach()
{
    numAutoDealers++;
    DealerID = NextDealerID;
    NextDealerID++;
    for (int model = 0; model < MaxModels; model++) // initialize arrays
    {
        if (DealerID == 0)
        {
            Factory[model]    = 100; // start off with 100 items (cars)
            AllDealers[model] = 0;  // first dealer in, let's initialize
            TotalSold[model] = 0;
        }
        LocalDealer[DealerID][model] = 0;
    }
    return numAutoDealers;
}

//---------------------------------------------------------------------------
int TForm1::Detach()
{
    DealerFactory[DealerID].Open = false;
    for (int model = 0; model < MaxModels; model++)
    {
        AllDealers[model] -= LocalDealer[DealerID][model];
        Factory[model] += LocalDealer[DealerID][model]; // factory gets 'em back
        LocalDealer[DealerID][model] = 0;
        // notify other dealers that dealership and it's cars are gone
        for (int i= 0; i< MaxDealers; i++)
        {
            if (DealerFactory[i].Open) // tell all dealers...
                   PostMessage(DealerFactory[i].hwnd,
                            WM_CAR_CHANGE,
                            (WPARAM) i,	// what dealer id changed
                            (LPARAM) model);// what car changed
        }
    }
    numAutoDealers--;
    return numAutoDealers;
}


//---------------------------------------------------------------------------
