// CUSTOMERACTIONIMPL : Implementation of TCustomerActionImpl
// (CoClass: CustomerAction, Interface: ICustomerAction)
// written by Paul Gustavson, 2002.

#include <vcl.h>
#pragma hdrstop

#include "CUSTOMERACTIONIMPL.H"
#include "RestaurantForm.h"

/////////////////////////////////////////////////////////////////////////////
// TCustomerActionImpl

static TCOMCriticalSection CS;


STDMETHODIMP TCustomerActionImpl::EnterRestaurant(long* customerID)
{
   long result = Form1->AddCustomer(this);
   *customerID = result;
   return S_OK;
}

STDMETHODIMP TCustomerActionImpl::RequestSeating(long customerID)
{
   Form1->RequestSeating(customerID);
   return S_OK;
}

STDMETHODIMP TCustomerActionImpl::PlaceOrder(long customerID, TOrder Order)
{
   Form1->PlaceOrder(customerID,Order);
   return S_OK;
}

STDMETHODIMP TCustomerActionImpl::RequestCheck(long customerID)
{
   Form1->RequestCheck(customerID);
   return S_OK;
}

STDMETHODIMP TCustomerActionImpl::PayBill(long customerID,
  PaymentType Type, double Amount)
{
   Form1->PayBill(customerID,Type, Amount);
   return S_OK;
}

STDMETHODIMP TCustomerActionImpl::LeaveTip(long customerID, double Amount)
{
   Form1->LeaveTip(customerID,Amount);
   return S_OK;
}

STDMETHODIMP TCustomerActionImpl::ExitRestaurant(long customerID)
{
   Form1->RemoveCustomer(customerID);
   return S_OK;
}


