// CUSTOMERACTIONIMPL.H : Declaration of the TCustomerActionImpl

#ifndef CustomerActionImplH
#define CustomerActionImplH

//#define ATL_APARTMENT_THREADED
#define ATL_FREE_THREADED

#include "RestaurantWaiter_TLB.h"


/////////////////////////////////////////////////////////////////////////////
// TCustomerActionImpl     Implements ICustomerAction, default interface of CustomerAction
//                  and ICustomerActionEvents, the default source interface
// ThreadingModel : Free// Apartment
// Dual Interface : TRUE
// Event Support  : TRUE
// Default ProgID : Project2.CustomerAction
// Description    : 
/////////////////////////////////////////////////////////////////////////////
class ATL_NO_VTABLE TCustomerActionImpl : 
  public CComObjectRootEx<CComSingleThreadModel>,
  public CComCoClass<TCustomerActionImpl, &CLSID_CustomerAction>,
  public IConnectionPointContainerImpl<TCustomerActionImpl>,
  public TEvents_CustomerAction<TCustomerActionImpl>, 
  public IDispatchImpl<ICustomerAction, &IID_ICustomerAction, &LIBID_RestaurantWaiter>
{
public:
  TCustomerActionImpl()
  {
  }

  // Data used when registering Object 
  //
/*
  otSingle,                 //
  otApartment,
  otFree,
  otBoth,
  otNeutral,
*/

  DECLARE_THREADING_MODEL(otFree);
  DECLARE_PROGID("RestaurantWaiter.CustomerAction");
  DECLARE_DESCRIPTION("");

  // Function invoked to (un)register object
  //
  static HRESULT WINAPI UpdateRegistry(BOOL bRegister)
  {
    TTypedComServerRegistrarT<TCustomerActionImpl> 
    regObj(GetObjectCLSID(), GetProgID(), GetDescription());
    return regObj.UpdateRegistry(bRegister);
  }


BEGIN_COM_MAP(TCustomerActionImpl)
  COM_INTERFACE_ENTRY(ICustomerAction)
  COM_INTERFACE_ENTRY2(IDispatch, ICustomerAction)
  COM_INTERFACE_ENTRY_IMPL(IConnectionPointContainer)
END_COM_MAP()

BEGIN_CONNECTION_POINT_MAP(TCustomerActionImpl)
  CONNECTION_POINT_ENTRY(DIID_ICustomerActionEvents)
END_CONNECTION_POINT_MAP()

// ICustomerAction
public:
 
  STDMETHOD(PlaceOrder(long customerID, TOrder Order));
  STDMETHOD(RequestCheck(long customerID));
  STDMETHOD(PayBill(long customerID, PaymentType Type, double Amount));
  STDMETHOD(LeaveTip(long customerID, double Amount));
  STDMETHOD(EnterRestaurant(long* customerID));
  STDMETHOD(ExitRestaurant(long customerID));
  STDMETHOD(RequestSeating(long customerID));
};

#endif //CustomerActionImplH
