//---------------------------------------------------------------------------

#ifndef RestaurantFormH
#define RestaurantFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "RestaurantWaiter_TLB.h"
#include "CustomerActionImpl.h"
#include <Grids.hpp>
#include <ExtCtrls.hpp>  //<-
//---------------------------------------------------------------------------

#define MAX_CUSTOMERS 100;

struct TCustomer
{
  CustomerStatusType status;
  long customerID;
  TOrder order;
  double bill;
  double change;
  bool   paid;
  double tip;
  TTimer *timer;
  void __fastcall timerevent(TObject *Sender);
  unsigned long timein;
  unsigned long timeout;
  unsigned long duration;
  TCustomerActionImpl* customeraction;
  TCustomer(unsigned long time = 0);
};

TCustomer::TCustomer(unsigned long time)
{
   bill = 10; // $ten dollars
   change = 10;
   tip  = 0;
   paid = false;
   timer = NULL;
   customerID = 0;
   timein = time;
   timeout = 0;
   duration = 0;
}


class TForm1 : public TForm
{
__published:	// IDE-managed Components
        TTimer *TimerClock;
        TPanel *PanelGrid;
        TLabel *Label2;
        TStringGrid *StringGridCustomers;
        TPanel *PanelOrder;
        TLabel *Label3;
        TLabel *Label4;
        TLabel *Label5;
        TLabel *Label6;
        TLabel *Label7;
        TLabel *LabelDessert;
        TLabel *LabelSideDish;
        TLabel *LabelEntree;
        TLabel *LabelAppetizer;
        TLabel *LabelDrink;
        TLabel *Label8;
        TPanel *PanelStatus;
        TLabel *Label27;
        TLabel *LabelClock;
        TLabel *Label1;
        TLabel *LabelNumCustomers;
        TLabel *Label23;
        TLabel *LabelCustomersServed;
        TButton *ButtonOpenNewCustomer;
        TPanel *PanelSimSettings;
        TLabel *Label10;
        TLabel *Label13;
        TLabel *Label11;
        TLabel *Label14;
        TLabel *Label15;
        TLabel *LabelSimTime;
        TLabel *Label16;
        TLabel *Label12;
        TLabel *Label18;
        TLabel *Label20;
        TLabel *Label21;
        TLabel *Label17;
        TLabel *Label19;
        TLabel *Label22;
        TLabel *Label25;
        TLabel *Label26;
        TEdit *EditSeatTime;
        TEdit *EditMultiplier;
        TEdit *EditServeFoodTime;
        TEdit *EditGetCheckTime;
        TEdit *EditSeats;
        TEdit *EditReturnChangeTime;
        TEdit *EditOrderTime;
        TLabel *Label9;
        void __fastcall StringGridCustomersSelectCell(TObject *Sender,
          int ACol, int ARow, bool &CanSelect);
        void __fastcall ButtonOpenNewCustomerClick(TObject *Sender);
        void __fastcall EditMultiplierChange(TObject *Sender);
        void __fastcall EditSeatsChange(TObject *Sender);
        void __fastcall EditSeatTimeChange(TObject *Sender);
        void __fastcall EditServeFoodTimeChange(TObject *Sender);
        void __fastcall EditGetCheckTimeChange(TObject *Sender);
        void __fastcall EditReturnChangeTimeChange(TObject *Sender);
        void __fastcall EditOrderTimeChange(TObject *Sender);
        void __fastcall TimerClockTimer(TObject *Sender);
private:	// User declarations
  int nextcustomerid;
  int numcustomers;
  int numseats;
  unsigned long lasttimesec;

  AnsiString SimulationTime(unsigned long timesec);  
  TCustomer customer[MAX_PATH];
  AnsiString GetEntreeName(EntreeType entreetype);
  AnsiString GetAppetizerName(AppetizerType appetizertype);
  AnsiString GetDrinkName(DrinkType drinktype);
  AnsiString GetSideDishName(SideOrderType sidedish);
  AnsiString GetDessertName(DessertType dessert);

public:		// User declarations
  int multiplier;  // clock multipler -- to operate faster than realtime.
  int time_ToSeat;           // minutes
  int time_ReadyToOrder;     // minutes
  int time_ToServeMeal;      // minutes
  int time_ToGetCheck;       // minutes
  int time_ToReturnChange;   // minutes

    long __fastcall AddCustomer(TCustomerActionImpl* ca);   // Enter
    void __fastcall RemoveCustomer(long customerID); // Exit
    void __fastcall PlaceOrder(long customerID, TOrder order);
    void __fastcall RequestCheck(long customerID);
    void __fastcall RequestSeating(long customerID);
    void __fastcall PayBill(long customerID, PaymentType Type,
                        double Amount);
    void __fastcall LeaveTip(long customerID, double Amount);
    __fastcall TForm1(TComponent* Owner);
    
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
