/*---------------------------------------------------------------------------
  MP3FileViewerForm.cpp
        Chapter 17 - COM Automation Controller Example
        created by Paul Gustavson, 2002
---------------------------------------------------------------------------*/

#include <vcl.h>
#pragma hdrstop

#include "MP3FileViewerForm.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
   MP3Player = NULL;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
  // let's make sure the file exists
  if (FileListBox1->FileName.Length() == 0)
  {
        MessageBeep(MB_OK);
        return;
  }

  // if (!FileExists(EditFileDll->Text))
  if (!FileExists(FileListBox1->FileName))
  {
    ShowMessage(AnsiString("Please select a file, and try again. "));
    MessageBeep(MB_OK);
    return;
  }

  // instantiate COM object
  if (!MP3Player) // if we haven't instantiated MP3 COM object, do it now
      MP3Player = Proj_mp3demo_tlb::CoMP3Object::Create();
  else // stop anything already playing
      MP3Player->Stop();

  MP3Player->Open(FileListBox1->FileName.c_str());
  MP3Player->Play();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
  if (MP3Player)
     MP3Player->Stop();  // make sure it's stopped.
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButtonApplyMaskClick(TObject *Sender)
{
  FileListBox1->Mask = EditMask->Text;
}
//---------------------------------------------------------------------------


