// MP3OBJECTIMPL.H : Declaration of the TMP3ObjectImpl

#ifndef MP3ObjectImplH
#define MP3ObjectImplH

#define ATL_APARTMENT_THREADED

#include "Proj_mp3Demo_TLB.H"


/////////////////////////////////////////////////////////////////////////////
// TMP3ObjectImpl     Implements IMP3Object, default interface of MP3Object
// ThreadingModel : Apartment
// Dual Interface : TRUE
// Event Support  : FALSE
// Default ProgID : Proj_mp3Demo.MP3Object
// Description    : Interface implemenatation for IMP3Object
/////////////////////////////////////////////////////////////////////////////
class ATL_NO_VTABLE TMP3ObjectImpl : 
  public CComObjectRootEx<CComSingleThreadModel>,
  public CComCoClass<TMP3ObjectImpl, &CLSID_MP3Object>,
  public IDispatchImpl<IMP3Object, &IID_IMP3Object, &LIBID_Proj_mp3Demo>
{
public:
  TMP3ObjectImpl()
  {
  }

  // Data used when registering Object 
  //
  DECLARE_THREADING_MODEL(otApartment);
  DECLARE_PROGID("Proj_mp3Demo.MP3Object");
  DECLARE_DESCRIPTION("Interface implemenatation for IMP3Object");

  // Function invoked to (un)register object
  //
  static HRESULT WINAPI UpdateRegistry(BOOL bRegister)
  {
    TTypedComServerRegistrarT<TMP3ObjectImpl> 
    regObj(GetObjectCLSID(), GetProgID(), GetDescription());
    return regObj.UpdateRegistry(bRegister);
  }


BEGIN_COM_MAP(TMP3ObjectImpl)
  COM_INTERFACE_ENTRY(IMP3Object)
  COM_INTERFACE_ENTRY2(IDispatch, IMP3Object)
END_COM_MAP()

// IMP3Object
public:
 
  STDMETHOD(Open(LPSTR File));
  STDMETHOD(Play());
  STDMETHOD(Stop());
};

#endif //MP3ObjectImplH
