// METRICCONVERSIONIMPL.H : Declaration of the TMetricConversionImpl

#ifndef MetricConversionImplH
#define MetricConversionImplH

#define ATL_APARTMENT_THREADED

#include "MetricConversionServerDLL_TLB.h"
#include "MetricConversion_OCX.h"


/////////////////////////////////////////////////////////////////////////////
// TMetricConversionImpl     Implements IMetricConversion, default interface of MetricConversion
// ThreadingModel : Apartment
// Dual Interface : TRUE
// Event Support  : FALSE
// Default ProgID : Project1.MetricConversion
// Description    : Implementation of IMetricConversion Interface
/////////////////////////////////////////////////////////////////////////////
class ATL_NO_VTABLE TMetricConversionImpl : 
  public CComObjectRootEx<CComSingleThreadModel>,
  public CComCoClass<TMetricConversionImpl, &CLSID_MetricConversion>,
  public IDispatchImpl<IMetricConversion, &IID_IMetricConversion, &LIBID_MetricConversionServerDLL>
{
public:
  TMetricConversionImpl()
  {
  }

  // Data used when registering Object 
  //
  DECLARE_THREADING_MODEL(otApartment);
  DECLARE_PROGID("MetricConversionServerDLL.MetricConversion");
  DECLARE_DESCRIPTION("Implementation of IMetricConversion Interface");

  // Function invoked to (un)register object
  //
  static HRESULT WINAPI UpdateRegistry(BOOL bRegister)
  {
    TTypedComServerRegistrarT<TMetricConversionImpl> 
    regObj(GetObjectCLSID(), GetProgID(), GetDescription());
    return regObj.UpdateRegistry(bRegister);
  }


BEGIN_COM_MAP(TMetricConversionImpl)
  COM_INTERFACE_ENTRY(IMetricConversion)
  COM_INTERFACE_ENTRY2(IDispatch, IMetricConversion)
END_COM_MAP()

// IMetricConversion
public:
 
  STDMETHOD(feet_to_meters(double feet, double* meters));
  STDMETHOD(meters_to_feet(double meters, double* feet));
};

#endif //MetricConversionImplH
