// METRICCONVERSIONIMPL.H : Declaration of the TMetricConversionImpl

#ifndef MetricConversionImplEXEH
#define MetricConversionImplEXEH

#define ATL_APARTMENT_THREADED

#include "MetricConversionServerEXE_TLB.h"
#include "MetricConversion_OCX.h"


/////////////////////////////////////////////////////////////////////////////
// TMetricConversionImpl     Implements IMetricConversion, default interface of MetricConversion
// ThreadingModel : Apartment
// Dual Interface : TRUE
// Event Support  : FALSE
// Default ProgID : Project1.MetricConversion
// Description    : Implementation for IMetricConversion Interface
/////////////////////////////////////////////////////////////////////////////
class ATL_NO_VTABLE TMetricConversion2Impl :
  public CComObjectRootEx<CComSingleThreadModel>,
  public CComCoClass<TMetricConversion2Impl, &CLSID_MetricConversion2>,
  public IDispatchImpl<IMetricConversion, &IID_IMetricConversion, &LIBID_MetricConversionServerEXE>
{
public:
  TMetricConversion2Impl()
  {
  }

  // Data used when registering Object 
  //
  DECLARE_THREADING_MODEL(otApartment);
  DECLARE_PROGID("MetricConversionServerEXE.MetricConversion2");
  DECLARE_DESCRIPTION("Implementation for IMetricConversion Interface");

  // Function invoked to (un)register object
  //
  static HRESULT WINAPI UpdateRegistry(BOOL bRegister)
  {
    TTypedComServerRegistrarT<TMetricConversion2Impl>
    regObj(GetObjectCLSID(), GetProgID(), GetDescription());
    return regObj.UpdateRegistry(bRegister);
  }


BEGIN_COM_MAP(TMetricConversion2Impl)
  COM_INTERFACE_ENTRY(IMetricConversion)
  COM_INTERFACE_ENTRY2(IDispatch, IMetricConversion)
END_COM_MAP()

// IMetricConversion
public:
 
  STDMETHOD(feet_to_meters(double feet, double* meters));
  STDMETHOD(meters_to_feet(double meters, double* feet));
};

#endif //MetricConversionImplH
