// TMETRICCONVERSIONIMPL.H : Declaration of the TTMetricConversionImpl

#ifndef TMetricConversionImplH
#define TMetricConversionImplH

#define ATL_APARTMENT_THREADED

#include "MetricConversionServerDLL_TLB.h"
#include "MetricConversion_OCX.h"


/////////////////////////////////////////////////////////////////////////////
// TTMetricConversionImpl     Implements IMetricConversion, default interface of TMetricConversion
//                  and IMetricConversionEvents, the default source interface
// ThreadingModel : Apartment
// Dual Interface : TRUE
// Event Support  : TRUE
// Default ProgID : Project1.TMetricConversion
// Description    : Class implement IMetricConversin interface
/////////////////////////////////////////////////////////////////////////////
class ATL_NO_VTABLE TTMetricConversionImpl : 
  public CComObjectRootEx<CComSingleThreadModel>,
  public CComCoClass<TTMetricConversionImpl, &CLSID_TMetricConversion>,
  public IConnectionPointContainerImpl<TTMetricConversionImpl>,
  public TEvents_TMetricConversion<TTMetricConversionImpl>, 
  public IDispatchImpl<IMetricConversion, &IID_IMetricConversion, &LIBID_MetricConversionServerDLL>
{
public:
  TTMetricConversionImpl()
  {
  }

  // Data used when registering Object 
  //
  DECLARE_THREADING_MODEL(otApartment);
  DECLARE_PROGID("MetricConversionServerDLL.TMetricConversion");
  DECLARE_DESCRIPTION("Class implement IMetricConversin interface");

  // Function invoked to (un)register object
  //
  static HRESULT WINAPI UpdateRegistry(BOOL bRegister)
  {
    TTypedComServerRegistrarT<TTMetricConversionImpl> 
    regObj(GetObjectCLSID(), GetProgID(), GetDescription());
    return regObj.UpdateRegistry(bRegister);
  }


BEGIN_COM_MAP(TTMetricConversionImpl)
  COM_INTERFACE_ENTRY(IMetricConversion)
  COM_INTERFACE_ENTRY2(IDispatch, IMetricConversion)
  COM_INTERFACE_ENTRY_IMPL(IConnectionPointContainer)
END_COM_MAP()

BEGIN_CONNECTION_POINT_MAP(TTMetricConversionImpl)
  CONNECTION_POINT_ENTRY(DIID_ITMetricConversionEvents)
END_CONNECTION_POINT_MAP()

// IMetricConversion
public:
 
  STDMETHOD(feet_to_meters(double feet, double* meters));
  STDMETHOD(meters_to_feet(double meters, double* feet));
};

#endif //TMetricConversionImplH
