// ************************************************************************ //
// Implementation class for interface ICmInch
// ************************************************************************ //
#include <vcl.h>
#pragma hdrstop

#if !defined(CmInchH)
#include "CmInch.h"
#endif

// ************************************************************************ //
//  TCmInchImpl implements interface ICmInch
// ************************************************************************ //
class TCmInchImpl : public TInvokableClass, public ICmInch
{
public:

  /* IUnknown */
  HRESULT STDMETHODCALLTYPE QueryInterface(const GUID& IID, void **Obj)
                        { return GetInterface(IID, Obj) ? S_OK : E_NOINTERFACE; }
  ULONG STDMETHODCALLTYPE AddRef() { return TInterfacedObject::_AddRef();  }
  ULONG STDMETHODCALLTYPE Release(){ return TInterfacedObject::_Release(); }

  /* ICmInch */
  virtual float STDMETHODCALLTYPE Cm2Inch(float Cm);
  virtual float STDMETHODCALLTYPE Inch2Cm(float Inch);

  /* Ensures that the class is not abstract */
  void checkValid() { delete new TCmInchImpl(); }
};


const float CmPerInch = 2.54;

float STDMETHODCALLTYPE TCmInchImpl::Cm2Inch(float Cm)
{
  return Cm / CmPerInch;
};

float STDMETHODCALLTYPE TCmInchImpl::Inch2Cm(float Inch)
{
  return Inch * CmPerInch;
};


static void __fastcall CmInchFactory(System::TObject* &obj)
{
  static _di_ICmInch iInstance;
  static TCmInchImpl *instance = 0;
  if (!instance)
  {
    instance = new TCmInchImpl();
    instance->GetInterface(iInstance);
  }
  obj = instance;
}

// ************************************************************************ //
//  The following routine registers the interface and implementation class.
// ************************************************************************ //
static void RegTypes()
{
  InvRegistry()->RegisterInterface(__interfaceTypeinfo(ICmInch));
  InvRegistry()->RegisterInvokableClass(__classid(TCmInchImpl) /*, CmInchFactory */);
}
#pragma startup RegTypes 32

