// ************************************************************************ //
// The types declared in this file were generated from data read from the
// WSDL File described below:
// WSDL     : G:\usr\BCB6\source\19\GoogleSearch.wsdl
// Version  : 1.0
// (2002-08-15 14:07:35 - $Revision:   1.0.1.0.1.82  $)
// ************************************************************************ //

#ifndef   GoogleSearchH
#define   GoogleSearchH

#include <System.hpp>
#include <InvokeRegistry.hpp>
#include <XSBuiltIns.hpp>
#include <SoapHTTPClient.hpp>


namespace NS_GoogleSearch {

// ************************************************************************ //
// The following types, referred to in the WSDL document are not being represented
// in this file. They are either aliases[@] of other types represented or were referred
// to but never[!] declared in the document. The types from the latter category
// typically map to predefined/known XML or Borland types; however, they could also 
// indicate incorrect WSDL documents that failed to declare or import a schema type.
// ************************************************************************ //
// !:boolean         - "http://www.w3.org/2001/XMLSchema"
// !:string          - "http://www.w3.org/2001/XMLSchema"
// !:int             - "http://www.w3.org/2001/XMLSchema"
// !:double          - "http://www.w3.org/2001/XMLSchema"
// !:base64Binary    - "http://www.w3.org/2001/XMLSchema"

class  DirectoryCategory;
class  ResultElement;
class  GoogleSearchResult;



// ************************************************************************ //
// Namespace : urn:GoogleSearch
// ************************************************************************ //
class DirectoryCategory : public TRemotable {
private:
  AnsiString      FfullViewableName;
  AnsiString      FspecialEncoding;
public:
__published:
  __property AnsiString fullViewableName = { read=FfullViewableName, write=FfullViewableName };
  __property AnsiString specialEncoding = { read=FspecialEncoding, write=FspecialEncoding };
};




// ************************************************************************ //
// Namespace : urn:GoogleSearch
// ************************************************************************ //
class ResultElement : public TRemotable {
private:
  AnsiString      Fsummary;
  AnsiString      FURL;
  AnsiString      Fsnippet;
  AnsiString      Ftitle;
  AnsiString      FcachedSize;
  bool            FrelatedInformationPresent;
  AnsiString      FhostName;
  DirectoryCategory* FdirectoryCategory;
  AnsiString      FdirectoryTitle;
public:
  __fastcall ~ResultElement();
__published:
  __property AnsiString    summary = { read=Fsummary, write=Fsummary };
  __property AnsiString        URL = { read=FURL, write=FURL };
  __property AnsiString    snippet = { read=Fsnippet, write=Fsnippet };
  __property AnsiString      title = { read=Ftitle, write=Ftitle };
  __property AnsiString cachedSize = { read=FcachedSize, write=FcachedSize };
  __property bool       relatedInformationPresent = { read=FrelatedInformationPresent, write=FrelatedInformationPresent };
  __property AnsiString   hostName = { read=FhostName, write=FhostName };
  __property DirectoryCategory* directoryCategory = { read=FdirectoryCategory, write=FdirectoryCategory };
  __property AnsiString directoryTitle = { read=FdirectoryTitle, write=FdirectoryTitle };
};


typedef DynamicArray<ResultElement*> ResultElementArray; /* "urn:GoogleSearch" */
typedef DynamicArray<DirectoryCategory*> DirectoryCategoryArray; /* "urn:GoogleSearch" */


// ************************************************************************ //
// Namespace : urn:GoogleSearch
// ************************************************************************ //
class GoogleSearchResult : public TRemotable {
private:
  bool            FdocumentFiltering;
  AnsiString      FsearchComments;
  int             FestimatedTotalResultsCount;
  bool            FestimateIsExact;
  ResultElementArray FresultElements;
  AnsiString      FsearchQuery;
  int             FstartIndex;
  int             FendIndex;
  AnsiString      FsearchTips;
  DirectoryCategoryArray FdirectoryCategories;
  double          FsearchTime;
public:
  __fastcall ~GoogleSearchResult();
__published:
  __property bool       documentFiltering = { read=FdocumentFiltering, write=FdocumentFiltering };
  __property AnsiString searchComments = { read=FsearchComments, write=FsearchComments };
  __property int        estimatedTotalResultsCount = { read=FestimatedTotalResultsCount, write=FestimatedTotalResultsCount };
  __property bool       estimateIsExact = { read=FestimateIsExact, write=FestimateIsExact };
  __property ResultElementArray resultElements = { read=FresultElements, write=FresultElements };
  __property AnsiString searchQuery = { read=FsearchQuery, write=FsearchQuery };
  __property int        startIndex = { read=FstartIndex, write=FstartIndex };
  __property int          endIndex = { read=FendIndex, write=FendIndex };
  __property AnsiString searchTips = { read=FsearchTips, write=FsearchTips };
  __property DirectoryCategoryArray directoryCategories = { read=FdirectoryCategories, write=FdirectoryCategories };
  __property double     searchTime = { read=FsearchTime, write=FsearchTime };
};



// ************************************************************************ //
// Namespace : urn:GoogleSearch
// soapAction: urn:GoogleSearchAction
// transport : http://schemas.xmlsoap.org/soap/http
// style     : rpc
// binding   : GoogleSearchBinding
// service   : GoogleSearchService
// port      : GoogleSearchPort
// URL       : http://api.google.com/search/beta2
// ************************************************************************ //
__interface INTERFACE_UUID("{0B396A82-A4DD-69A7-A771-6D80F8831A71}") GoogleSearchPort : public IInvokable
{
public:
  virtual TByteDynArray   doGetCachedPage(const AnsiString key, const AnsiString url) = 0; 
  virtual AnsiString      doSpellingSuggestion(const AnsiString key, const AnsiString phrase) = 0; 
  virtual GoogleSearchResult* doGoogleSearch(const AnsiString key, const AnsiString q, const int start, const int maxResults, const bool filter, const AnsiString restrict, const bool safeSearch, const AnsiString lr, const AnsiString ie, const AnsiString oe) = 0; 
};
typedef DelphiInterface<GoogleSearchPort> _di_GoogleSearchPort;

_di_GoogleSearchPort GetGoogleSearchPort(bool useWSDL=false, AnsiString addr="");



#endif // __GoogleSearch_h__

};     // NS_GoogleSearch

#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using  namespace NS_GoogleSearch;
#endif

 