// SIMPLEDATASNAPSERVERIMPL.H : Declaration of the SimpleDataSnapServer

#ifndef SimpleDataSnapServerImplH
#define SimpleDataSnapServerImplH

#define ATL_FREE_THREADED
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <MidConst.hpp>

#include "SimpleDataSnapServer_TLB.h"
#include <DB.hpp>
#include <DBTables.hpp>
#include <Provider.hpp>
#include <atl/atlvcl.h>



// Forward ref. of IAppServer implementor


/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
class TSimpleDataSnapServer : public TCRemoteDataModule
{
__published:  // IDE-managed Components
        TSession *Session1;
        TTable *tblCustomer;
        TDataSetProvider *dspCustomer;
private:      // User declarations
public:       // User declarations
  __fastcall TSimpleDataSnapServer(TComponent* Owner);

__published:
};


/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
extern PACKAGE TSimpleDataSnapServer *SimpleDataSnapServer;


/////////////////////////////////////////////////////////////////////////////
// TSimpleDataSnapServerImpl     Implements ISimpleDataSnapServer, default interface of SimpleDataSnapServer
// ThreadingModel : Apartment
// Dual Interface : TRUE
// Event Support  : FALSE
// Default ProgID : Project1.SimpleDataSnapServer
// Description    : C++Builder 6 Developer's Guide simple DataSnap Server
/////////////////////////////////////////////////////////////////////////////
class ATL_NO_VTABLE TSimpleDataSnapServerImpl: REMOTEDATAMODULE_IMPL(TSimpleDataSnapServerImpl, SimpleDataSnapServer, TSimpleDataSnapServer, ISimpleDataSnapServer)
{
public:

BEGIN_COM_MAP(TSimpleDataSnapServerImpl)
  RDMOBJECT_COM_INTERFACE_ENTRIES(ISimpleDataSnapServer)
END_COM_MAP()

  // Data used when registering Object 
  //
  DECLARE_THREADING_MODEL(otApartment);
  DECLARE_PROGID(_T("SimpleDataSnapServer.SimpleDataSnapServer"));
  DECLARE_DESCRIPTION(_T("C++Builder 6 Developer's Guide simple DataSnap Server"));

  // Function invoked to (un)register object
  //
  static HRESULT WINAPI UpdateRegistry(BOOL bRegister)
  {
    TRemoteDataModuleRegistrar regObj(GetObjectCLSID(), GetProgID(), GetDescription());
    // Disable these flags in order to disable use by socket or web connections.
    // Also set other flags to configure the behavior of your application server.
    // For more information, see atlmod.h and atlvcl.cpp.
    regObj.Singleton = false;
    regObj.EnableWeb = true;
    regObj.EnableSocket = true;
    return regObj.UpdateRegistry(bRegister);
  }


// ISimpleDataSnapServer
protected:
};

#endif  // SimpleDataSnapServerImplH

