/*---------------------------------------------------------------------------
  NotifierObject.h
        Paul Gustavson,  2002
        Developed for...
                C++Builder Developer's Guide
                Chapter 23 - OT Wizard Example
---------------------------------------------------------------------------*/
//---------------------------------------------------------------------------

#ifndef NotifierObjectH
#define NotifierObjectH
//---------------------------------------------------------------------------

#include <ToolsAPI.hpp>
#include <typeinfo>

// macro for implementing interfaces
#define QUERY_INTERFACE(T, iid, obj)   \
  if ((iid) == __uuidof(T))            \
  {                                    \
    *(obj) = static_cast<T*>(this);    \
    static_cast<T*>(*(obj))->AddRef(); \
    return S_OK;                       \
  }

#ifdef DLL
#define BorlandIDEServices LocalIDEServices
extern _di_IBorlandIDEServices LocalIDEServices;
#endif


class PACKAGE TNotifierObject : public IOTANotifier {
public:
  __fastcall TNotifierObject() : ref_count(0) {}
  virtual __fastcall ~TNotifierObject();
  void __fastcall AfterSave();
  void __fastcall BeforeSave();
  void __fastcall Destroyed();
  void __fastcall Modified();
protected:
  // IInterface
  virtual HRESULT __stdcall QueryInterface(const GUID&, void**);
  virtual ULONG __stdcall AddRef();
  virtual ULONG __stdcall Release();
private:
  long ref_count;
};


template<typename T>
void Cast(_di_IInterface instance, T& intf)
{
  if (! instance->Supports(intf))
    throw EIntfCastError(AnsiString("Interface not supported: ") + typeid(T).name());
}

template<typename T>
DelphiInterface<T> interface_cast(_di_IInterface instance)
{
  DelphiInterface<T> result;
  Cast(instance, result);
  return result;
}
#endif
 