/*---------------------------------------------------------------------------
  wizard_memstatus.cpp
        Paul Gustavson,  (c) 2002
        Developed for...
                C++Builder Developer's Guide
                Chapter 23 - OT Wizard Example
---------------------------------------------------------------------------*/

//---------------------------------------------------------------------------

#include <Windows.hpp>
#include <SysUtils.hpp>
#include <ToolsAPI.hpp>
#pragma hdrstop

#pragma resource "*.res"

#include "wizard_memstatus.h"
#include "NotifierObject.h"
#include "MemStatusForm.h"
#include <cstdarg>

//---------------------------------------------------------------------------

#pragma package(smart_init)


ULONG   __stdcall MemStatusWizard::AddRef()  { return inherited::AddRef(); }
ULONG   __stdcall MemStatusWizard::Release() { return inherited::Release(); }
HRESULT __stdcall MemStatusWizard::QueryInterface(const GUID& iid, void** obj)
{
  QUERY_INTERFACE(IOTAMenuWizard, iid, obj);
  QUERY_INTERFACE(IOTAWizard, iid, obj);
  return inherited::QueryInterface(iid, obj);
}

void __fastcall MemStatusWizard::AfterSave()  {}
void __fastcall MemStatusWizard::BeforeSave() {}
void __fastcall MemStatusWizard::Destroyed()  {}
void __fastcall MemStatusWizard::Modified()   {}

//---------------------------------------------------------------------------

AnsiString __fastcall MemStatusWizard::GetIDString()
{
  return "CBuilderDevelopersGuide.MemStat Wizard";
}

//---------------------------------------------------------------------------

AnsiString __fastcall MemStatusWizard::GetName()
{
  return "MemStat Wizard";
}

//---------------------------------------------------------------------------

TWizardState __fastcall MemStatusWizard::GetState()
{
  TWizardState result;
  result << wsEnabled;
  return result;
}

//---------------------------------------------------------------------------

AnsiString __fastcall MemStatusWizard::GetMenuText()
{
  return "MemStat Wizard...";
}

//---------------------------------------------------------------------------

void __fastcall MemStatusWizard::Execute()
{
  TFormMemStat* FormMemStat = new TFormMemStat(0);
  FormMemStat->ShowModal();
  delete FormMemStat;
}

//---------------------------------------------------------------------------

void __fastcall MemStatusWizard::action_execute(TObject* Sender)
{
  Execute();
}


void __fastcall MemStatusWizard::action_update(TObject* Sender)
{
  // Enable the action item only if a file is open.
  action->Enabled = interface_cast<IOTAModuleServices>(BorlandIDEServices)->CurrentModule() != 0;
}



//---------------------------------------------------------------------------

__fastcall MemStatusWizard::MemStatusWizard()
: action(0), menu_item(0)
{

  _di_INTAServices services;
  Cast(BorlandIDEServices, services);
/*
  // Add an image to the image list.
  Graphics::TBitmap* bitmap(new Graphics::TBitmap());
  bitmap->LoadFromResourceID(reinterpret_cast<unsigned>(HInstance), 1);
  int image = services->AddMasked(bitmap, bitmap->TransparentColor, "Tempest Software.intro wizard image");
  delete bitmap;

  // Create an action item for the demo action.
  action = new TAction(0);
  action->ActionList = services->ActionList;
  action->Caption = GetMenuText();
  action->Hint = "Display a silly dialog box";
  action->ImageIndex = image;
  action->Name = "WizDemoCommand";
  action->OnExecute = action_execute;
  action->OnUpdate = action_update;

  // Create a menu item at the top of the View menu.
  for (int i = 0; i < services->MainMenu->Items->Count; ++i)
  {
    TMenuItem* item = services->MainMenu->Items->Items[i];
    if (CompareText(item->Name, "ViewsMenu") == 0)
    {
      menu_item = new TMenuItem(0);
      menu_item->Action = action;
      menu_item->Name = "WizDemoItem";
      item->Insert(0, menu_item);
    }
  }
*/
}

static void remove_action_from_toolbar(TAction* action, TToolBar* toolbar)
{
  for (int i = toolbar->ButtonCount; --i >= 0; )
  {
    TToolButton* button = toolbar->Buttons[i];
    if (button->Action == action)
    {
      toolbar->Perform(CM_CONTROLCHANGE, WPARAM(button), 0);
      delete button;
    }
  }
}

//---------------------------------------------------------------------------

__fastcall MemStatusWizard::~MemStatusWizard()
{
/*
  _di_INTAServices services;
  Cast(BorlandIDEServices, services);
  // Check all the toolbars, and remove any buttons that use this action.
  remove_action_from_toolbar(action, services->ToolBar[sCustomToolBar]);
  remove_action_from_toolbar(action, services->ToolBar[sDesktopToolBar]);
  remove_action_from_toolbar(action, services->ToolBar[sStandardToolBar]);
  remove_action_from_toolbar(action, services->ToolBar[sDebugToolBar]);
  remove_action_from_toolbar(action, services->ToolBar[sViewToolBar]);
  remove_action_from_toolbar(action, services->ToolBar[sInternetToolBar]);
  remove_action_from_toolbar(action, services->ToolBar[sCORBAToolBar]);

  delete menu_item;
  delete action;
*/
}

//---------------------------------------------------------------------------

#ifndef DLL  // it's a package
namespace Wizard_memstatus
{
  void __fastcall PACKAGE Register()
  {
    RegisterPackageWizard(new MemStatusWizard());
  }
}
#endif

