/*---------------------------------------------------------------------------
  memstatus.cpp
        Paul Gustavson, (c) 2002
        Developed for...
                C++Builder Developer's Guide
                Chapter 23 - OT Wizard Example
---------------------------------------------------------------------------*/
#include "memstatus.h"


//---------------------------------------------------------------------------
sMemStatus::sMemStatus()           // constructor
{
     Clear();
}

//---------------------------------------------------------------------------

AnsiString __fastcall sMemStatus::FormatSize(double value)
{
    AnsiString str_to_return;

    if ((value < -1000) || (value > 10000))
    {
       value = value / 1024;
       str_to_return = FloatToStrF(value,ffFixed,15,2) + " MB";
    }
    else
      str_to_return = AnsiString((int)value) + " KB";

    return str_to_return;
}

//---------------------------------------------------------------------------

int __fastcall sMemStatus::GetFreesystemResources(int Mode)  // mode 0 = system, 1 = gdi, 2 = user
{
    int Result = 100;
/*
    typedef int __stdcall (*MyFreeResourcesProc)(int Mode);
    MyFreeResourcesProc MyGetFreeSystemResources32;
    HANDLE RSRC32DLL;



    RSRC32DLL = LoadLibrary("RSRC32.DLL");
    if(RSRC32DLL != NULL)
    {
        MyGetFreeSystemResources32 = (MyFreeResourcesProc)GetProcAddress(GetModuleHandle("RSRC32.DLL"),"_MyGetFreeSystemResources32@4");
        if(MyGetFreeSystemResources32 != NULL)
            Result = MyGetFreeSystemResources32(Mode);
        FreeLibrary(RSRC32DLL);
    }
    else
    {
*/
        MEMORYSTATUS *memory = new MEMORYSTATUS;
      try
      {
        memory->dwLength = sizeof (MEMORYSTATUS) ;
        GlobalMemoryStatus (memory) ;

//        double value1 = double(double(memory.dwAvailPhys*100)/memory.dwTotalPhys);
        double value1 = double(double(memory->dwAvailPhys*100.0)/memory->dwTotalPhys);
        double value = 100.0-memory->dwMemoryLoad;
        delete memory;

        if (value1 > value)
           value = long(value1);

        Result = value; //100-memory.dwMemoryLoad;
      }
        catch (Exception &exception)
        {
                 Application->ShowException(&exception);
        }
//   }
    return Result;
}


//---------------------------------------------------------------------------
void __fastcall sMemStatus::Clear()
{
     // start
     M1_PhysFree = 0.0;
     M1_PageFree = 0.0;
     M1_VirtFree = 0.0;
     M1_LoadFree = 0.0;

     // stop / lap
     M2_PhysFree = 0.0;
     M2_PageFree = 0.0;
     M2_VirtFree = 0.0;
     M2_LoadFree = 0.0;

     // peak
     M3_PhysFree = 0.0;
     M3_PageFree = 0.0;
     M3_VirtFree = 0.0;
     M3_LoadFree = 0.0;
}


//---------------------------------------------------------------------------
AnsiString __fastcall sMemStatus::MemPhysTotal()
{
  AnsiString MemStr;
  MEMORYSTATUS *memory = new MEMORYSTATUS;

  try {
      memory->dwLength = sizeof (MEMORYSTATUS) ;
      GlobalMemoryStatus (memory) ;

      double value = double(memory->dwTotalPhys) / 1024.0;
      delete memory;
      MemStr = FormatSize(value);
  }  // try


        catch (Exception &exception)
        {
                 Application->ShowException(&exception);
        }
  return MemStr;
}

//---------------------------------------------------------------------------
AnsiString __fastcall sMemStatus::MemPageTotal()
{
  AnsiString MemStr;
  MEMORYSTATUS *memory = new MEMORYSTATUS;

  try {
      memory->dwLength = sizeof (MEMORYSTATUS) ;
      GlobalMemoryStatus (memory) ;

      double value = double(memory->dwTotalPageFile) / 1024;
      delete memory;
      MemStr = FormatSize(value);
  }  // try


        catch (Exception &exception)
        {
                 Application->ShowException(&exception);
        }
  return MemStr;
}



//---------------------------------------------------------------------------
AnsiString __fastcall sMemStatus::MemVirtTotal()
{
  AnsiString MemStr;
  MEMORYSTATUS *memory = new MEMORYSTATUS;

  try {
      memory->dwLength = sizeof (MEMORYSTATUS) ;
      GlobalMemoryStatus (memory) ;

      double value = double(memory->dwTotalVirtual) / 1024;
      delete memory;
      MemStr = FormatSize(value);
  }  // try
  catch (Exception &exception)
  {
           Application->ShowException(&exception);
  }
  return MemStr;
}


//---------------------------------------------------------------------------
AnsiString __fastcall sMemStatus::MemTotal()
{
  AnsiString MemStr;
  MEMORYSTATUS *memory = new MEMORYSTATUS;

  try {
      memory->dwLength = sizeof (MEMORYSTATUS) ;
      GlobalMemoryStatus (memory) ;

      double value = double(memory->dwTotalVirtual + memory->dwTotalPhys) / 1024;
      delete memory;
      MemStr = FormatSize(value);
  }  // try
  catch (Exception &exception)
  {
           Application->ShowException(&exception);
  }

  return MemStr;
}

//---------------------------------------------------------------------------
double __fastcall sMemStatus::GetMemPhysFree()
{
  MEMORYSTATUS *memory = new MEMORYSTATUS;
  double value = 0;
  try
  {
      memory->dwLength = sizeof (MEMORYSTATUS) ;
      GlobalMemoryStatus (memory) ;
      value = double(memory->dwAvailPhys) / 1024;
      delete memory;
//      MemStr = FormatSize(value);
  }
  catch (Exception &exception)
  {
           Application->ShowException(&exception);
  }

  return value;
}


//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
AnsiString __fastcall sMemStatus::MemPhysFree(int memcheck)
{
  AnsiString MemStr;
//  MEMORYSTATUS memory ;

//  memory.dwLength = sizeof (memory) ;
//  GlobalMemoryStatus (&memory) ;

  try {

      double value = GetMemPhysFree(); //double(memory.dwAvailPhys) / 1024;
      switch (memcheck)
      {
        case 1 : M1_PhysFree = value; break;
        case 2 : M2_PhysFree = value; break;
      }
      MemStr = FormatSize(value);
  }  // try
  catch (Exception &exception)
  {
           Application->ShowException(&exception);
  }
  return MemStr;
}




//---------------------------------------------------------------------------
AnsiString __fastcall sMemStatus::MemPageFree(int memcheck)
{
  AnsiString MemStr;
  MEMORYSTATUS *memory = new MEMORYSTATUS;

  try {
      memory->dwLength = sizeof (MEMORYSTATUS) ;
      GlobalMemoryStatus (memory) ;

      double value = double(memory->dwAvailPageFile) / 1024;
      delete memory;
      
      switch (memcheck)
      {
        case 1 : M1_PageFree = value; break;
        case 2 : M2_PageFree = value; break;
      }
      MemStr = FormatSize(value);
  }  // try
  catch (Exception &exception)
  {
           Application->ShowException(&exception);
  }
  return MemStr;
}



//---------------------------------------------------------------------------
AnsiString __fastcall sMemStatus::MemVirtFree(int memcheck)
{
  AnsiString MemStr;
  MEMORYSTATUS *memory = new MEMORYSTATUS;

  try {
      memory->dwLength = sizeof (MEMORYSTATUS) ;
      GlobalMemoryStatus (memory) ;

      double value = double(memory->dwAvailVirtual) / 1024;
      delete memory;

      switch (memcheck)
      {
        case 1 : M1_VirtFree = value; break;
        case 2 : M2_VirtFree = value; break;
      }
      MemStr = FormatSize(value);
  }  // try
  catch (Exception &exception)
  {
           Application->ShowException(&exception);
  }
  return MemStr;
}

//---------------------------------------------------------------------------
AnsiString __fastcall sMemStatus::MemTotalFree(int memcheck)
{
  AnsiString MemStr;
  MEMORYSTATUS *memory = new MEMORYSTATUS;

  try {
      memory->dwLength = sizeof (MEMORYSTATUS) ;
      GlobalMemoryStatus (memory) ;

      double valuep = double(memory->dwAvailPhys) / 1024;
      double valuev = double(memory->dwAvailVirtual) / 1024;
      double valuepg = double(memory->dwAvailPageFile) / 1024;
      double value = double(memory->dwAvailPhys + memory->dwAvailVirtual + memory->dwAvailPageFile) / 1024;
      delete memory;
      switch (memcheck)
      {
        case 1 : M1_VirtFree = valuev;
                 M1_PhysFree = valuep;
                 M1_PageFree = valuepg;
                 break;
        case 2 : M2_VirtFree = valuev;
                 M2_PhysFree = valuep;
                 M2_PageFree = valuepg;
                 break;
      }
      MemStr = FormatSize(value);
  }  // try
  catch (Exception &exception)
  {
           Application->ShowException(&exception);
  }
  return MemStr;
}
//---------------------------------------------------------------------------
double __fastcall sMemStatus::GetMemPhysLoadFree()
{
  double value = GetFreesystemResources(0);
/*
  MEMORYSTATUS memory ;

  memory.dwLength = sizeof (memory) ;
  GlobalMemoryStatus (&memory) ;

  double value1 = double(double(memory.dwAvailPhys*100)/memory.dwTotalPhys);
  double value = 100-memory.dwMemoryLoad;
  if (value1 > value)
     value = long(value1);
*/
  return value;
}

//---------------------------------------------------------------------------
AnsiString __fastcall sMemStatus::MemPhysLoadFree(int memcheck)
{
  AnsiString MemStr;

  try {
      double value = GetMemPhysLoadFree();
      switch (memcheck)
      {
        case 1 : M1_LoadFree = value; break;
        case 2 : M2_LoadFree = value; break;
      }
      MemStr = AnsiString(value) + " % free";
  }  // try
  catch (Exception &exception)
  {
           Application->ShowException(&exception);
  }
  return MemStr;
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------

double sMemStatus::Delta(double M1, double M2, double &M3)
{
    double value =  M1 - M2;
    if (M3 < value) M3 = value;
    return value;
}


//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
AnsiString __fastcall sMemStatus::MemPhysLoss()
{
  AnsiString MemStr;
  try {

      double value =  Delta(M2_PhysFree,M1_PhysFree,M3_PhysFree);
      MemStr = FormatSize(value);
  }  // try
  catch (Exception &exception)
  {
           Application->ShowException(&exception);
  }
  return MemStr;
}



//---------------------------------------------------------------------------
AnsiString __fastcall sMemStatus::MemPageLoss()
{
  AnsiString MemStr;
  try {

      double value =  Delta(M2_PageFree, M1_PageFree,M3_PageFree);
      MemStr = FormatSize(value);
  }  // try
  catch (Exception &exception)
  {
           Application->ShowException(&exception);
  }
  return MemStr;
}



//---------------------------------------------------------------------------
AnsiString __fastcall sMemStatus::MemVirtLoss()
{
  AnsiString MemStr;
  try {

      double value =  Delta(M2_VirtFree,M1_VirtFree,M3_VirtFree);
      MemStr = FormatSize(value);
  }  // try
  catch (Exception &exception)
  {
           Application->ShowException(&exception);
  }
  return MemStr;
}

//---------------------------------------------------------------------------
AnsiString __fastcall sMemStatus::MemTotalLoss()
{
  AnsiString MemStr;
  try {
      double value =  Delta((M2_VirtFree + M2_PhysFree),(M1_VirtFree + M1_PhysFree),M3_TotalFree);
      MemStr = FormatSize(value);
  }  // try
  catch (Exception &exception)
  {
      Application->ShowException(&exception);
  }
  return MemStr;
}



//---------------------------------------------------------------------------
AnsiString __fastcall sMemStatus::MemPhysLoadLoss()
{
  AnsiString MemStr;
  try {
      double value =  Delta(M2_LoadFree,M1_LoadFree,M3_LoadFree);;
      MemStr = AnsiString((int)value) + " % delta";
  }  // try
  catch (Exception &exception)
  {
           Application->ShowException(&exception);
  }
  return MemStr;
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------



AnsiString __fastcall sMemStatus::MemPhysUsed()
{
  AnsiString MemStr;

  try {
      double value =  Delta(M1_PhysFree,M2_PhysFree,M3_PhysFree);

      MemStr = FormatSize(value);
  }  // try
  catch (Exception &exception)
  {
      Application->ShowException(&exception);
  }
  return MemStr;
}

//---------------------------------------------------------------------------

AnsiString __fastcall sMemStatus::MemPageUsed()
{
  AnsiString MemStr;
  try {

      double value =  Delta(M1_PageFree,M2_PageFree,M3_PageFree);

      MemStr = FormatSize(value);
  }  // try
  catch (Exception &exception)
  {
      Application->ShowException(&exception);
  }
  return MemStr;
}

//---------------------------------------------------------------------------

AnsiString __fastcall sMemStatus::MemVirtUsed()
{
  AnsiString MemStr;

  try {

      double value =  Delta(M1_VirtFree,M2_VirtFree,M3_VirtFree);

      MemStr = FormatSize(value);
  }  // try
  catch (Exception &exception)
  {
           Application->ShowException(&exception);
  }
  return MemStr;
}



//---------------------------------------------------------------------------
AnsiString __fastcall sMemStatus::MemTotalUsed()
{
  AnsiString MemStr;

  try {

      double value =  Delta((M1_VirtFree + M1_PhysFree), (M2_VirtFree + M2_PhysFree),M3_TotalFree);

      MemStr = FormatSize(value);
  }  // try
  catch (Exception &exception)
  {
           Application->ShowException(&exception);
  }
  return MemStr;
}



//---------------------------------------------------------------------------
AnsiString __fastcall sMemStatus::MemPhysLoadUsed()
{
  AnsiString MemStr;
  try {
      double value =  Delta(M1_LoadFree,M2_LoadFree,M3_LoadFree);

      MemStr = AnsiString((int)value) + " % delta";
  }  // try
  catch (Exception &exception)
  {
           Application->ShowException(&exception);
  }
  return MemStr;
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
AnsiString __fastcall sMemStatus::MemPhysPeakUsed()
{
  AnsiString MemStr;

  try {
      MemStr = FormatSize(M3_PhysFree);
  }  // try
  catch (Exception &exception)
  {
      Application->ShowException(&exception);
  }
  return MemStr;
}

//---------------------------------------------------------------------------

AnsiString __fastcall sMemStatus::MemPagePeakUsed()
{
  AnsiString MemStr;
  try {

      MemStr = FormatSize(M3_PageFree);
  }  // try
  catch (Exception &exception)
  {
      Application->ShowException(&exception);
  }
  return MemStr;
}

//---------------------------------------------------------------------------

AnsiString __fastcall sMemStatus::MemVirtPeakUsed()
{
  AnsiString MemStr;

  try {
      MemStr = FormatSize(M3_VirtFree);
  }  // try
  catch (Exception &exception)
  {
           Application->ShowException(&exception);
  }
  return MemStr;
}

//---------------------------------------------------------------------------
AnsiString __fastcall sMemStatus::MemTotalPeakUsed()
{
  AnsiString MemStr;

  try {

      MemStr = FormatSize(M3_TotalFree);
  }  // try
  catch (Exception &exception)
  {
           Application->ShowException(&exception);
  }
  return MemStr;
}



//---------------------------------------------------------------------------
AnsiString __fastcall sMemStatus::MemPhysLoadPeakUsed()
{
  AnsiString MemStr;
  try {
      MemStr = AnsiString((int)M3_LoadFree) + " % delta";
  }  // try
  catch (Exception &exception)
  {
           Application->ShowException(&exception);
  }
  return MemStr;
}

//---------------------------------------------------------------------------
bool __fastcall sMemStatus::CheckForEnoughMemory(int valuetocheck, AnsiString filename)
{
    double memresources = GetMemPhysFree()/1024; //GetMemPhysLoadFree();
    if (memresources <= valuetocheck)
    {
    bool enoughmemory = false;
    try {
    AnsiString statement = " for PhotoVisor to complete the operation";
    if (filename.Length() != 0)
        statement = " to load the file \"" + filename + "\"";
    AnsiString textresources = "There is not enough physical memory currently available" + statement + ".\n\n"
                               "Physical Mem: "  + MemPhysFree() + " Free\n"
                               "Page Mem:     "  + MemPageFree() + " Free\n\n"
                               "To free up system resources, quit any programs that you are not using. \n"
                               "If you do not, it is possible your computer may stop responding.\n";
    AnsiString title = "Low Memory!"; //    (Physical Mem: "  + MemPhysFree() + " Free  |  Page Mem: " + MemPageFree() + " Free)";
    int value = Application->MessageBox(textresources.c_str(),title.c_str(),MB_RETRYCANCEL);
    if (value == IDRETRY)
    {
         statement = "";
         textresources = "";
         title = "";
         enoughmemory = CheckForEnoughMemory(valuetocheck,filename);
    }
    else
    {
         statement = "";
         textresources = "";
         title = "";
    }
    }
    __finally
    {
        return enoughmemory;
    }
    }
    return true;
}

