/*---------------------------------------------------------------------------
  MemStatusForm.cpp
        Paul Gustavson, (c) 2002
        Developed for...
                C++Builder Developer's Guide
                Chapter 23 - OT Wizard Example
---------------------------------------------------------------------------*/
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "MemStatusForm.h"


//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFormMemStat *FormMemStat;
//---------------------------------------------------------------------------
__fastcall TFormMemStat::TFormMemStat(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TFormMemStat::BitBtn1Click(TObject *Sender)
{
        LabelPFree->Caption      = MemStat.MemPhysFree();
        LabelPTotal->Caption     = MemStat.MemPhysTotal();
        LabelPgFree->Caption      = MemStat.MemPageFree();
        LabelPgTotal->Caption     = MemStat.MemPageTotal();
        LabelVFree->Caption     = MemStat.MemVirtFree();
        LabelVTotal->Caption    = MemStat.MemVirtTotal();
        LabelFree->Caption       = MemStat.MemPhysLoadFree();
        
  if ((CheckBoxMonitor->Checked) && (SpeedButtonStop->Enabled))
  {
        MemStat.MemPhysFree(2);
        MemStat.MemVirtFree(2);
        MemStat.MemPageFree(2);
        MemStat.MemPhysLoadFree(2);

        // calculate amount used  (also checks for peak usage)
        LabelLPFree->Caption      = MemStat.MemPhysUsed();
        LabelLVFree->Caption      = MemStat.MemVirtUsed();
        LabelLPgFree->Caption     = MemStat.MemPageUsed();
        LabelLFree->Caption       = MemStat.MemPhysLoadUsed();

        LabelPPeak->Caption      = MemStat.MemPhysPeakUsed();
        LabelVPeak->Caption      = MemStat.MemVirtPeakUsed();
        LabelPgPeak->Caption     = MemStat.MemPagePeakUsed();
        LabelPeak->Caption       = MemStat.MemPhysLoadPeakUsed();
   }
}
//---------------------------------------------------------------------------

void __fastcall TFormMemStat::Timer1Timer(TObject *Sender)
{
        BitBtn1Click(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TFormMemStat::FormActivate(TObject *Sender)
{
        BitBtn1Click(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TFormMemStat::SpeedButtonStartClick(TObject *Sender)
{
        MemStat.Clear();
        BitBtn1Click(Sender);

        LabelM1PFree->Caption      = MemStat.MemPhysFree(1);
        LabelM1VFree->Caption      = MemStat.MemVirtFree(1);
        LabelM1PgFree->Caption     = MemStat.MemPageFree(1);
        LabelM1Free->Caption       = MemStat.MemPhysLoadFree(1);

        SpeedButtonStop->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TFormMemStat::SpeedButtonStopClick(TObject *Sender)
{
        CheckBoxMonitor->Checked = false;  // automatically turn this off

        LabelM2PFree->Caption      = MemStat.MemPhysFree(2);
        LabelM2VFree->Caption      = MemStat.MemVirtFree(2);
        LabelM2PgFree->Caption     = MemStat.MemPageFree(2);
        LabelM2Free->Caption       = MemStat.MemPhysLoadFree(2);

        // calculate Loss
        LabelLPFree->Caption      = MemStat.MemPhysUsed();
        LabelLVFree->Caption      = MemStat.MemVirtUsed();
        LabelLPgFree->Caption     = MemStat.MemPageUsed();
        LabelLFree->Caption       = MemStat.MemPhysLoadUsed();
}
//---------------------------------------------------------------------------

AnsiString TFormMemStat::GetMemoryPeakUsage()
{
   AnsiString result;
   result = "Memory (Peak Usage)" \
             " - Physical = " + MemStat.MemPhysPeakUsed() +
             " - Virtual = " + MemStat.MemVirtPeakUsed() +
             " - Page = " + MemStat.MemPagePeakUsed() +
             " - Resources = " + MemStat.MemPhysLoadPeakUsed();
   return result;
}

//---------------------------------------------------------------------------

AnsiString TFormMemStat::GetMemoryFinalUsage()
{
   AnsiString result;
   result = "Memory (Final Usage)" \
             " - Physical = " + MemStat.MemPhysUsed() +
             " - Virtual = " + MemStat.MemVirtUsed() +
             " - Page = " + MemStat.MemPageUsed() +
             " - Resources = " + MemStat.MemPhysLoadUsed();
   return result;
}

//---------------------------------------------------------------------------

AnsiString TFormMemStat::GetMemoryCurrentFree()
{
   AnsiString result;
   result = "Memory (Cureent Free)" \
             " - Physical = " + MemStat.MemPhysFree() +
             " - Virtual = " + MemStat.MemVirtFree() +
             " - Page = " + MemStat.MemPageFree() +
             " - Resources = " + MemStat.MemPhysLoadFree();
   return result;
}

//---------------------------------------------------------------------------

AnsiString TFormMemStat::GetMemoryTotal()
{
   AnsiString result;
   result = "Memory (Total)" \
             " - Physical = " + MemStat.MemPhysTotal() +
             " - Virtual = " + MemStat.MemVirtTotal() +
             " - Page = " + MemStat.MemPageTotal() +
             " - Resources = " + MemStat.MemPhysLoadFree();
   return result;
}
//---------------------------------------------------------------------------

AnsiString TFormMemStat::GetMemoryStartFree()
{
   AnsiString result;
   result = "Memory (Start Free)" \
             " - Physical = " + LabelM1PFree->Caption +
             " - Virtual = " + LabelM1VFree->Caption +
             " - Page = " + LabelM1PgFree->Caption +
             " - Resources = " + LabelM1Free->Caption;
   return result;
}

//---------------------------------------------------------------------------

AnsiString TFormMemStat::GetMemoryStopFree()
{
   AnsiString result;
   result = "Memory (Stop Free)" \
             " - Physical  = " + LabelM2PFree->Caption +
             " - Virtual   = " + LabelM2VFree->Caption +
             " - Page      = " + LabelM2PgFree->Caption +
             " - Resources = " + LabelM2Free->Caption;
   return result;
}

