/*---------------------------------------------------------------------------
  ToolsAPIEx.cpp
        Paul Gustavson,  2002
        Developed for...
                C++Builder Developer's Guide
                Chapter 23 - OTA Wizard Example
---------------------------------------------------------------------------*/
//---------------------------------------------------------------------------

#pragma hdrstop

#include "ToolsAPIEx.h"

#pragma package(smart_init)

#ifdef DLL    // needed for a DLL
_di_IBorlandIDEServices LocalIDEServices;
#endif

HRESULT __stdcall
TNotifierObject::QueryInterface(const GUID& iid, void** obj)
{
  QUERY_INTERFACE(IInterface, iid, obj);
  QUERY_INTERFACE(IOTANotifier, iid, obj);
  return E_NOINTERFACE;
}

//---------------------------------------------------------------------------

ULONG __stdcall TNotifierObject::AddRef()
{
  return InterlockedIncrement(&ref_count);
}

//---------------------------------------------------------------------------

ULONG __stdcall TNotifierObject::Release()
{
  ULONG result = InterlockedDecrement(&ref_count);
  if (ref_count == 0)
    delete this;
  return result;
}

//---------------------------------------------------------------------------

__fastcall TNotifierObject::~TNotifierObject()  {}
void __fastcall TNotifierObject::AfterSave()  {}
void __fastcall TNotifierObject::BeforeSave() {}
void __fastcall TNotifierObject::Destroyed()  {}
void __fastcall TNotifierObject::Modified()   {}

//---------------------------------------------------------------------------


