/*---------------------------------------------------------------------------
  memstatus.h
        Paul Gustavson, (c) 2002
        Developed for...
                C++Builder Developer's Guide
                Chapter 23 - OT Wizard Example
---------------------------------------------------------------------------*/
#ifndef memstatusH
#define memstatusH

#include <StdCtrls.hpp>


class sMemStatus
{
private:
     // start
     double M1_PhysFree;
     double M1_PageFree;
     double M1_VirtFree;
     double M1_LoadFree;

     // stop / lap
     double M2_PhysFree;
     double M2_PageFree;
     double M2_VirtFree;
     double M2_LoadFree;

     // peak
     double M3_PhysFree;
     double M3_PageFree;
     double M3_VirtFree;
     double M3_LoadFree;
     double M3_TotalFree;

     AnsiString __fastcall FormatSize(double value);
     double Delta(double M1, double M2, double &M3);
     
public:
    sMemStatus();
    void __fastcall Clear();

    double __fastcall GetMemPhysFree();
    double __fastcall GetMemPhysLoadFree();
    int    __fastcall GetFreesystemResources(int Mode);

    AnsiString __fastcall MemPhysTotal();
    AnsiString __fastcall MemPageTotal();
    AnsiString __fastcall MemVirtTotal();
    AnsiString __fastcall MemTotal();

    AnsiString __fastcall MemPhysFree(int memcheck = 0);
    AnsiString __fastcall MemPageFree(int memcheck = 0);
    AnsiString __fastcall MemVirtFree(int memcheck = 0);
    AnsiString __fastcall MemTotalFree(int memcheck = 0);
    AnsiString __fastcall MemPhysLoadFree(int memcheck = 0);

    AnsiString __fastcall MemPhysLoss();
    AnsiString __fastcall MemPageLoss();
    AnsiString __fastcall MemVirtLoss();
    AnsiString __fastcall MemTotalLoss();
    AnsiString __fastcall MemPhysLoadLoss();

    AnsiString __fastcall MemPhysUsed();
    AnsiString __fastcall MemPageUsed();
    AnsiString __fastcall MemVirtUsed();
    AnsiString __fastcall MemTotalUsed();
    AnsiString __fastcall MemPhysLoadUsed();

    AnsiString __fastcall MemPhysPeakUsed();
    AnsiString __fastcall MemPagePeakUsed();
    AnsiString __fastcall MemVirtPeakUsed();
    AnsiString __fastcall MemTotalPeakUsed();
    AnsiString __fastcall MemPhysLoadPeakUsed();

    bool __fastcall CheckForEnoughMemory(int valuetocheck = 2, AnsiString filename = "");
};
#endif
