/*---------------------------------------------------------------------------
  wizard_memstatus.cpp
        Paul Gustavson,  (c) 2002
        Developed for...
                C++Builder Developer's Guide
                Chapter 23 - OTA Wizard Example
---------------------------------------------------------------------------*/

//---------------------------------------------------------------------------

#include <Windows.hpp>
#include <SysUtils.hpp>
#include <ToolsAPI.hpp>
#pragma hdrstop

#pragma resource "*.res"

#include "wizard_memstatus.h"
#include "ToolsAPIEx.h"
#include <stdio.h>
#include <cstdarg>
#include "MemStatusForm.h"
#include <systdate.h>

//---------------------------------------------------------------------------

#pragma package(smart_init)


//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
__fastcall File::File(const AnsiString source)
: ref_count(0), age(-1), source(source)
{
}

__fastcall File::~File()
{}

AnsiString __fastcall File::GetSource()
{
  return source;
}

System::TDateTime __fastcall File::GetAge()
{
  return age;
}

HRESULT __stdcall File::QueryInterface(const GUID& iid, void** obj)
{
  QUERY_INTERFACE(IOTAFile, iid, obj);
  QUERY_INTERFACE(IInterface, iid, obj);
  return E_NOINTERFACE;
}

ULONG __stdcall File::AddRef()
{
  return InterlockedIncrement(&ref_count);
}

ULONG __stdcall File::Release()
{
  ULONG result = InterlockedDecrement(&ref_count);
  if (ref_count == 0)
    delete this;
  return result;
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
__fastcall Creator::Creator(const AnsiString creator_type,
                     const MemStatusWizard*   wizard)
  : ref_count(0), creator_type(creator_type), wizard(wizard)
{
    #ifdef DebugMessages
    char value[MAX_PATH];
    sprintf(value," - [Debug] - Creator has been created.  Index = %d",index);
    wizard->MessageServices->AddTitleMessage(
       AnsiString(wizard->GetName() + value),wizard->MessageGroup);
    #endif
}


__fastcall Creator::~Creator(){}
/*
int __fastcall Creator::GetAdditionalFilesCount(){return 0;}

_di_IOTAFile __fastcall Creator::NewAdditionalFileSource(
        int I,
        const AnsiString ModuleIdent,
        const AnsiString FormIdent,
        const AnsiString AncestorIdent)
{
   const AnsiString form_source =  " this is a test - NewAdditionalFileSource";
   _di_IOTAFile file = new File(form_source);
   return file; // Expand(form_source, ModuleIdent, FormIdent, AncestorIdent);
}
AnsiString __fastcall Creator::GetAdditionalFileName(int I){return "";}
AnsiString __fastcall Creator::GetAdditionalFileExt(int I){return "";}
*/

// IOTAModuleCreator
AnsiString __fastcall Creator::GetAncestorName(){return "";}
AnsiString __fastcall Creator::GetImplFileName(){return "";}
AnsiString __fastcall Creator::GetIntfFileName(){return "";}
AnsiString __fastcall Creator::GetFormName(){return "";}
bool __fastcall Creator::GetMainForm(){return true;}
bool __fastcall Creator::GetShowForm(){return true;}
bool __fastcall Creator::GetShowSource(){return true;}
_di_IOTAFile __fastcall Creator::NewFormFile(
    const AnsiString FormIdent, const AnsiString AncestorIdent)
{
   const AnsiString form_source =  " this is a test - NewFormFile";
   _di_IOTAFile file = new File(form_source);
   return file; // Expand(form_source, ModuleIdent, FormIdent, AncestorIdent);
}


_di_IOTAFile __fastcall Creator::NewImplSource(
    const AnsiString ModuleIdent, const AnsiString FormIdent,
    const AnsiString AncestorIdent)
{
//   const AnsiString form_source; // =  " this is a test - NewImplSource";
   // let's grab data from Wizard that we want in the text file.

//   AnsiString dtstring = Date().FormatString("m/d/yyyy @ hh:mm AM/PM"); //hh:nn:ss am/pm");

   AnsiString dtstring;
   TDateTime adatetime;
   adatetime = adatetime.CurrentDateTime();

   dtstring = adatetime.FormatString("mm/dd/yyyy hh:nn:ss am/pm");


   AnsiString form_source  = "Memory Analysis Results \n\n";
   form_source += "Project = " + wizard->projectname + "\n";
   form_source += "Run Date = " + dtstring + "\n";
   form_source += wizard->memtotal + "\n";;
   form_source += wizard->memstartfree + "\n";;
   form_source += wizard->memstopfree + "\n";;
   form_source += wizard->memfinalusage + "\n";;
   form_source += wizard->mempeakusage + "\n\n\n";;
   form_source += "Enter your notes below...";;

   _di_IOTAFile file = new File(form_source);
   return file; // Expand(form_source, ModuleIdent, FormIdent, AncestorIdent);
}


_di_IOTAFile __fastcall Creator::NewIntfSource(
    const AnsiString ModuleIdent, const AnsiString FormIdent,
    const AnsiString AncestorIdent)
{
   const AnsiString form_source =  " this is a test - NewIntfSource";
   _di_IOTAFile file = new File(form_source);
   return file; // Expand(form_source, ModuleIdent, FormIdent, AncestorIdent);
}
void __fastcall Creator::FormCreated(
    const _di_IOTAFormEditor FormEditor){}

// IOTACreator
AnsiString __fastcall Creator::GetCreatorType(){return creator_type;}
bool __fastcall Creator::GetExisting(){return false;}
AnsiString __fastcall Creator::GetFileSystem(){return "";}

_di_IOTAModule __fastcall Creator::GetOwner()
{
  // Return the current project.
  _di_IOTAProject result = 0;

  _di_IOTAModuleServices svc =
    interface_cast<IOTAModuleServices>(BorlandIDEServices);
  for (int i = 0; i < svc->ModuleCount; ++i)
  {
    _di_IOTAModule module = svc->Modules[i];
    _di_IOTAProject project;
    _di_IOTAProjectGroup group;
    if (module->Supports(project)) {
      // Remember the first project module.
      if (result == 0)
        result = project;
    } else if (module->Supports(group)) {
      // Found the project group, so return its active project.
      result = group->ActiveProject;
      break;
    }
  }
  return result;
}

bool __fastcall Creator::GetUnnamed(){return true;}

HRESULT __stdcall Creator::QueryInterface(const GUID& iid, void** obj)
{
//  QUERY_INTERFACE(IOTAAdditionalFilesModuleCreator, iid, obj);
  QUERY_INTERFACE(IOTAModuleCreator, iid, obj);
  QUERY_INTERFACE(IOTACreator, iid, obj);
  QUERY_INTERFACE(IInterface, iid, obj);
  return E_NOINTERFACE;
}

ULONG __stdcall Creator::AddRef()
{
  return InterlockedIncrement(&ref_count);
}

ULONG __stdcall Creator::Release()
{
  ULONG result = InterlockedDecrement(&ref_count);
  if (ref_count == 0)
    delete this;
  return result;
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------

__fastcall DebugNotifier::DebugNotifier(const _di_IOTADebuggerServices debugger,
                           const MemStatusWizard*   wizard)
: index(-1), debugger(debugger), wizard(wizard)
{
    // register the notifier
    index =  debugger->AddNotifier(this);

    #ifdef DebugMessages
    char value[MAX_PATH];
    sprintf(value," - [Debug] - DebugNotifer has been created.  Index = %d",index);
    wizard->MessageServices->AddTitleMessage(
       AnsiString(wizard->GetName() + value),wizard->MessageGroup);
    #endif
}

//---------------------------------------------------------------------------

__fastcall DebugNotifier::~DebugNotifier()
{
   //unregister the notifier if that hasn't happend yet
   if (index >= 0)
   {

    #ifdef DebugMessages
    char value[MAX_PATH];
    sprintf(value," - [Debug] - About to call RemoveNotifer - inside ~DebugNotifier() - Index = %d",index);
    wizard->MessageServices->AddTitleMessage(
       AnsiString(wizard->GetName() + value),wizard->MessageGroup);
    #endif
    debugger->RemoveNotifier(index);
   }
   debugger = 0;
}

ULONG   __stdcall DebugNotifier::AddRef()  { return inherited::AddRef(); }
ULONG   __stdcall DebugNotifier::Release() { return inherited::Release(); }
HRESULT __stdcall DebugNotifier::QueryInterface(const GUID& iid, void** obj)
{
  QUERY_INTERFACE(IOTADebuggerNotifier, iid, obj);
  return inherited::QueryInterface(iid, obj);
}

void __fastcall DebugNotifier::AfterSave()  {}
void __fastcall DebugNotifier::BeforeSave() {}
void __fastcall DebugNotifier::Destroyed()
{
   //unregister the notifier if that hasn't happend yet
   if (index >= 0)
   {
    #ifdef DebugMessages
    char value[MAX_PATH];
    sprintf(value," - [Debug] - About to call RemoveNotifer - inside Destroyed() - Index = %d",index);
    wizard->MessageServices->AddTitleMessage(
       AnsiString(wizard->GetName() + value),wizard->MessageGroup);
    #endif

    debugger->RemoveNotifier(index);
    index = -1;
   }
   debugger = 0;
}
//---------------------------------------------------------------------------

void __fastcall DebugNotifier::Modified()   {}

void __fastcall DebugNotifier::BreakpointAdded(_di_IOTABreakpoint Breakpoint)
{
    #ifdef DebugMessages
    wizard->MessageServices->AddTitleMessage(
       AnsiString(wizard->GetName() + " - Breakpoint Added..."),wizard->MessageGroup);
    #endif
}

//---------------------------------------------------------------------------

void __fastcall DebugNotifier::BreakpointDeleted(_di_IOTABreakpoint Breakpoint)
{
    #ifdef DebugMessages
    wizard->MessageServices->AddTitleMessage(
       AnsiString(wizard->GetName() + " - Breakpoint Deleted..."),wizard->MessageGroup);
    #endif
}

//---------------------------------------------------------------------------

void __fastcall DebugNotifier::ProcessCreated(_di_IOTAProcess Process)
{
    wizard->SetProcessActive(true);

    #ifdef DebugMessages
    wizard->MessageServices->AddTitleMessage(
       AnsiString(wizard->GetName() + " - Process Created - Process ID = " + AnsiString((int)Process->ProcessId)),wizard->MessageGroup);
    #endif
}

//---------------------------------------------------------------------------

void __fastcall DebugNotifier::ProcessDestroyed(_di_IOTAProcess Process)
{
    wizard->SetProcessActive(false);

    #ifdef DebugMessages
    wizard->MessageServices->AddTitleMessage(
       AnsiString(wizard->GetName() + " - Process Destroyed - Process ID = " + AnsiString((int)Process->ProcessId)),wizard->MessageGroup);
    #endif
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------

__fastcall MemStatusWizard::MemStatusWizard()
: action(0), menu_item(0)
{
//    debugnotifier = NULL;
    ProcessActive = false;
/*
  _di_INTAServices services;
 BorlandIDEServices->Supports(services); // get access to Modules)


  // Add an image to the image list.
  Graphics::TBitmap* bitmap(new Graphics::TBitmap());
  bitmap->LoadFromResourceID(reinterpret_cast<unsigned>(HInstance), 1);
  int image = services->AddMasked(bitmap, bitmap->TransparentColor, "Tempest Software.intro wizard image");
  delete bitmap;

  // Create an action item for the demo action.
  action = new TAction(0);
  action->ActionList = services->ActionList;
  action->Caption = GetMenuText();
  action->Hint = "Display a silly dialog box";
  action->ImageIndex = image;
  action->Name = "WizDemoCommand";
  action->OnExecute = action_execute;
  action->OnUpdate = action_update;

  // Create a menu item at the top of the View menu.
  for (int i = 0; i < services->MainMenu->Items->Count; ++i)
  {
    TMenuItem* item = services->MainMenu->Items->Items[i];
    if (CompareText(item->Name, "ViewsMenu") == 0)
    {
      menu_item = new TMenuItem(0);
      menu_item->Action = action;
      menu_item->Name = "WizDemoItem";
      item->Insert(0, menu_item);
    }
  }
*/
}

//---------------------------------------------------------------------------

__fastcall MemStatusWizard::~MemStatusWizard()
{
//  if (debugnotifier)
//      debugnotifier->Destroyed();

//  MessageServices->AddTitleMessage("All Done",MessageGroup); // debug

  // unregister all the notifiers in the list
/*
  for (int i = notifierlist->Count-1; i >= 0; i--)   // last to first
  {
     _di_IOTANotifier notifier;
     // cast item into notifier (if you can)
     Supports(notifierlist->Items[i], IOTANotifier, &notifier);
//     notifier = (_di_IOTADebuggerNotifier )notifierlist->Items[i];
//     notifier = notifierlist->Items[i];
//     notifier = notifierlist->Items[i];
//          projectgroup = (_di_IOTAProjectGroup)module;
//     Supports(notifierlist->Items[i], IID_IOTANotifier, &notifier);
     notifier->Destroyed();
     notifierlist->Delete(i);
  }
  delete notifierlist;
/*

//  delete item;

/*
  _di_INTAServices services;
  Cast(BorlandIDEServices, services);
  // Check all the toolbars, and remove any buttons that use this action.
  remove_action_from_toolbar(action, services->ToolBar[sCustomToolBar]);
  remove_action_from_toolbar(action, services->ToolBar[sDesktopToolBar]);
  remove_action_from_toolbar(action, services->ToolBar[sStandardToolBar]);
  remove_action_from_toolbar(action, services->ToolBar[sDebugToolBar]);
  remove_action_from_toolbar(action, services->ToolBar[sViewToolBar]);
  remove_action_from_toolbar(action, services->ToolBar[sInternetToolBar]);
  remove_action_from_toolbar(action, services->ToolBar[sCORBAToolBar]);

  delete menu_item;
  delete action;
*/
}



ULONG   __stdcall MemStatusWizard::AddRef()  { return inherited::AddRef(); }
ULONG   __stdcall MemStatusWizard::Release() { return inherited::Release(); }
HRESULT __stdcall MemStatusWizard::QueryInterface(const GUID& iid, void** obj)
{
  QUERY_INTERFACE(IOTAMenuWizard, iid, obj);
  QUERY_INTERFACE(IOTAWizard, iid, obj);
  return inherited::QueryInterface(iid, obj);
}

void __fastcall MemStatusWizard::AfterSave()  {}
void __fastcall MemStatusWizard::BeforeSave() {}
void __fastcall MemStatusWizard::Destroyed()  {}
void __fastcall MemStatusWizard::Modified()   {}

//---------------------------------------------------------------------------

AnsiString __fastcall MemStatusWizard::GetIDString()
{
  return "CBuilderDevelopersGuide.MemStat Wizard";
}

//---------------------------------------------------------------------------

AnsiString __fastcall MemStatusWizard::GetName()
{
  return "MemStat Wizard";
}

//---------------------------------------------------------------------------

TWizardState __fastcall MemStatusWizard::GetState()
{
  TWizardState result;
  result << wsEnabled;
  return result;
}

//---------------------------------------------------------------------------

AnsiString __fastcall MemStatusWizard::GetMenuText()
{
  return "MemStat Wizard...";
}

//---------------------------------------------------------------------------
_di_IOTAProject MemStatusWizard::FindCurrentProject(_di_IOTAModuleServices ModServices)
{
    //To obtain the active IOTAProjectGroup reference,
    //iterate over all open modules and find the one module that
    //supports the IOTAProjectGroup interface.

    if (!ModServices) return NULL; // get out, no modules to search

    _di_IOTAModule module;
    _di_IOTAProjectGroup projectgroup = NULL;
    _di_IOTAProject project = NULL;

    bool done = false;
    int index = 0;
    MessageServices->AddTitleMessage(
       AnsiString(GetName() + " - Locating Active Project..."),MessageGroup);
    while (!done)
    {
       if (index < ModServices->ModuleCount)
       {
          module = ModServices->Modules[index];
          // cast module into project (if you can)
          projectgroup = (_di_IOTAProjectGroup)module;
          if (projectgroup)
          {
              //done = true;
              project = projectgroup->ActiveProject;
              MessageServices->AddTitleMessage(
                AnsiString(GetName() + " - Project Found = " +
                        project->FileName),MessageGroup);
              done = true;
          }
          else
          index++;
       }
       else
       {
         done = true;
          MessageServices->AddTitleMessage(
            AnsiString(GetName() + " -  Unable to locate project"),MessageGroup);
       }
    }  // while
    return project;
}

//---------------------------------------------------------------------------

TMenuItem * MemStatusWizard::FindMenuItemCaption(TMenuItem* topmenu,
                AnsiString Caption)
{
    TMenuItem *menuitem = NULL;
    bool done = false;
    if (!topmenu) return menuitem; // get out, no menu to search
    int index = 0;
    while (!done)
    {
       if (index < topmenu->Count)
       {
          menuitem = topmenu->Items[index];
          if (menuitem->Caption.AnsiPos(Caption))
          {
                  done = true;
          }
          index ++;
       }
       else
       {
          done = true;
          menuitem = NULL;
       }
    }  // while
    return menuitem;
}

//---------------------------------------------------------------------------


void __fastcall MemStatusWizard::SetupMessageViewAccess()
{
    BorlandIDEServices->Supports(MessageServices); // get access to Message View
    MessageGroup = MessageServices->AddMessageGroup(GetName());
    MessageServices->ClearMessageGroup(MessageGroup); // need clean canvas
    MessageServices->ShowMessageView(MessageGroup);   // make it visible
    MessageServices->AddTitleMessage(GetName() + " - Activated",MessageGroup);
}

//---------------------------------------------------------------------------

AnsiString __fastcall MemStatusWizard::ExtractFileNameNoExt(const AnsiString FileLocation, bool keeppath)
{
     AnsiString name;
     if (keeppath)
        name = FileLocation;
     else
        name = ExtractFileName(FileLocation);

     AnsiString extension = ExtractFileExt(name); // Extract the Ext. portion to manipulate
     int extlen = extension.Length(); // So's we know how long it is (how many chars!)
     int extpos = name.AnsiPos(extension); // Locate the position of the extension in the filename
     name.Delete(extpos,extlen); // Remove the old extension
     return  name;
}

//---------------------------------------------------------------------------


void __fastcall MemStatusWizard::Execute()
{
  Application->ProcessMessages();  // let menu processing complete

  bool launch = true;  // unless instruected otherwise, run the application
  TFormMemStat*  FormMemStat = NULL;

  SetupMessageViewAccess();

  _di_IOTADebuggerServices DebuggerServices;  // we'll use these a little later
 // IOTADebuggerNotifier* debugnotifier;        // keep track of debugnotifier
  DebugNotifier* debugnotifier;        // keep track of debugnotifier

  _di_IOTAModuleServices ModServices;
  BorlandIDEServices->Supports(ModServices); // get access to Modules)
  _di_IOTAProject project = FindCurrentProject(ModServices);
  if (project)
  {
      _di_IOTAProjectBuilder projectbuilder = project->ProjectBuilder;
     projectname = ExtractFileName(project->FileName);

     if (projectbuilder->ShouldBuild)
     {
          MessageServices->AddTitleMessage(
                AnsiString(GetName() + " - Project needs to be built first"),
                MessageGroup);


          AnsiString message = "MemStatus Wizard detected that the " +
                               projectname + " project needs to be built first.\n"
                               "Do you wish to continue?";
          int result = MessageBox(NULL,message.c_str(),
                              "MemStat Wizard - Build Project?",
                              MB_YESNO);
          if (result == IDYES)
          {
              launch = projectbuilder->BuildProject(cmOTAMake,true,true);
          }
          else launch = false; // user doesn't want to run now
     }


  }
  else  // could not find project
  {
      AnsiString message = GetName() + " - Project not loaded. Unable to run.";
      MessageServices->AddTitleMessage(message,MessageGroup);
      MessageBox(NULL,message.c_str(),"MemStat Wizard - Build Project?", MB_OK);
      launch = false;
  }

  if (launch)  // if launch is still a go
  {
    MessageServices->AddTitleMessage(
        AnsiString(GetName() + " - Project is built and ready to run"),MessageGroup);

    _di_INTAServices NativeServices;
    BorlandIDEServices->Supports(NativeServices); // get access to IDE (menu bar)

    // let's find the Run top menu item...
    TMenuItem* MenuItem =
        FindMenuItemCaption(NativeServices->MainMenu->Items,"Run");
    if (MenuItem)
    {
        // now let's find the Run (F9) menu item
        TMenuItem* temp = FindMenuItemCaption(MenuItem,"Run");
        MenuItem = temp;
        if (MenuItem)
        {
            if (MenuItem->Enabled)
            {
                int result = MessageBox(NULL,
                        "MemStat Wizard is ready to launch active project and "\
                        "measure memory performance. \n\n" \
                        "Although not required, it's recommended that you "\
                        "close all other applications with the exception of "\
                        "C++Builder before running the memory test. This will "\
                        "allow the MemStat Wizard to more precisely measure "\
                        "memory performance of the application under test.\n\n"\
                        "Do you wish to continue?",
                        "MemStat Wizard - Ready to Run",MB_YESNO);
                if (result == IDYES)
                {
                    FormMemStat = new TFormMemStat(0);// instantiate MemStat form
                    FormMemStat->Show();  // show the wizard

                    memtotal = FormMemStat->GetMemoryTotal();
                    MessageServices->AddTitleMessage(
                        AnsiString(GetName() + " - " +
                        memtotal),MessageGroup);

                    // get interace to debuggerservices and a notifier
                    BorlandIDEServices->Supports(DebuggerServices);
                    debugnotifier = new DebugNotifier(DebuggerServices,this);

                    Application->ProcessMessages(); //let FormMemStat complete

                    FormMemStat->SpeedButtonStartClick(0); // measure memory first

                    memstartfree = FormMemStat->GetMemoryStartFree();

                    MessageServices->AddTitleMessage(
                        AnsiString(GetName() + " - " +
                        memstartfree),MessageGroup);

                    MenuItem->OnClick(0);  // run the app through the menu item

                   // here's how we could run the app from the debugger service
                   #ifdef RunFromDebugger
                    _di_IOTAProcess Process;
                    // figure out exe name
                    AnsiString exename = ExtractFileNameNoExt(
                                               project->FileName,true) + ".exe";
                    if (FileExists(exename))
                    {
                       MessageServices->AddTitleMessage(
                                AnsiString(GetName() + " - " +
                                "Create Process = " + exename),MessageGroup);
                       DebuggerServices->CreateProcess(exename, "", "");
                       Process = DebuggerServices->CurrentProcess;
                        if (Process)
                        {
                             MessageServices->AddTitleMessage(
                                AnsiString(GetName() + " - " +"Process = " +
                                AnsiString(Process->ProcessId)),MessageGroup);
                             //Process->Pause(); // test
                             //Process->Run(ormRun);   // Run Normally
                        }
                    }
                   #endif // RunFromDebugger
                }
                else
                {
                    MessageServices->AddTitleMessage(
                        AnsiString(GetName() +
                        " - User aborted run."),MessageGroup);
                }
            }
        }
    }
    if (!MenuItem)
    {
                MessageServices->AddTitleMessage(
                   AnsiString(GetName() + " - Unable to run application. " \
                   "Project not loaded."),MessageGroup);
    }
  }

  // little loop processing here - but don't tie up system (check and get out)
  if (FormMemStat)
  {
      while (FormMemStat->Visible)  // check
      {
         if (!ProcessActive)  // process is no longer active / shut it down
         {
             FormMemStat->SpeedButtonStopClick(0); // final measurement
             FormMemStat->Close();
         }
         Application->HandleMessage(); //get out (process current messages)
      }

      if (ProcessActive) // wizard has been shut down, but app remains
      {
          int result = MessageBox(NULL,
                  "MemStat Wizard has been shut down, but the application "\
                  "under test is still active. \n\n" \
                  "Do you wish to close application under test as well?",
                  "MemStat Wizard - Terminated",MB_YESNO);
          if (result == IDYES)
          {
               _di_IOTAProcess Process;
               Process = DebuggerServices->CurrentProcess;
               if (Process)
                  Process->Terminate();
          }
      }
      memstopfree = FormMemStat->GetMemoryStopFree();
      memfinalusage = FormMemStat->GetMemoryFinalUsage();
      mempeakusage = FormMemStat->GetMemoryPeakUsage();

      MessageServices->AddTitleMessage(
          AnsiString(GetName() + " - " +
          memstopfree),MessageGroup);
      MessageServices->AddTitleMessage(
          AnsiString(GetName() + " - " +
          memfinalusage),MessageGroup);
      MessageServices->AddTitleMessage(
          AnsiString(GetName() + " - " +
          mempeakusage),MessageGroup);

      // dump out log file with memory performance data
      _di_IOTAModule module = ModServices->CreateModule(new Creator(sText,this));

      delete FormMemStat;
  }
  if (debugnotifier)  // little clean-up
  {
     debugnotifier->Destroyed();
     debugnotifier =  NULL;
  }


  MessageServices->AddTitleMessage(GetName() + " - Completed",MessageGroup);
}

//---------------------------------------------------------------------------

void __fastcall MemStatusWizard::SetProcessActive(bool value)
{
  ProcessActive = value;
}


//---------------------------------------------------------------------------

void __fastcall MemStatusWizard::action_execute(TObject* Sender)
{
  Execute();
}


void __fastcall MemStatusWizard::action_update(TObject* Sender)
{
  // Enable the action item only if a file is open.
  action->Enabled = interface_cast<IOTAModuleServices>(BorlandIDEServices)->CurrentModule() != 0;
}


//---------------------------------------------------------------------------

static void remove_action_from_toolbar(TAction* action, TToolBar* toolbar)
{
  for (int i = toolbar->ButtonCount; --i >= 0; )
  {
    TToolButton* button = toolbar->Buttons[i];
    if (button->Action == action)
    {
      toolbar->Perform(CM_CONTROLCHANGE, WPARAM(button), 0);
      delete button;
    }
  }
}

//---------------------------------------------------------------------------

#ifndef DLL  // it's a package
namespace Wizard_memstatus
{
  void __fastcall PACKAGE Register()
  {
    RegisterPackageWizard(new MemStatusWizard());
  }
}
#endif





